/* Fichier : Data_Recues_du_PC_TSCRJI_BB67000_Y.ino
             Sous-programme de réception des caractères sur la ligne série.      JLF le 15/02/2025.

Ce sous-programme recoit les informations envoyées par l'ordinateur.
En modifiant ce sous-programme, il est adaptable pour d'autres simulateurs sur ordinateur.

Cette version est pour 'TS Classic Raildriver and Joystick Interface' avec 'RailsWorks Classic' et la locomotive BB67471 de Yohann.

Pour la :
 ######  ######      #####  #######   ###     ###     ###                       #     #
 #     # #     #    #     # #    #   #   #   #   #   #   #     #####  ######     #   #   ####  #    #   ##   #    #
 #     # #     #    #           #   #     # #     # #     #    #    # #           # #   #    # #    #  #  #  ##   #
 ######  ######     ######     #    #     # #     # #     #    #    # #####        #    #    # ###### #    # # #  #
 #     # #     #    #     #   #     #     # #     # #     #    #    # #            #    #    # #    # ###### #  # #
 #     # #     #    #     #   #      #   #   #   #   #   #     #    # #            #    #    # #    # #    # #   ##
 ######  ######      #####    #       ###     ###     ###      #####  ######       #     ####  #    # #    # #    #

Si vous réaliser des améliorations matériels ou logicielles, merci de les poster sur le forum RMF pour en faire profiter le plus grand nombre.
Si vous publier cette réalisation avec ou sans améliorations, vous devez publier votre code source.
Ce logiciel est un logiciel libre. Exigence du concepteur : Ne pas modifier la ligne d'affichage "JLF  xx/xx/xxxx" sur l'écran LCD.
On peut modifier ce programme et le diffuser. Dans ce cas, il faut préciser l'origine et donner accès aux sources modifiées.
Définition : Un logiciel libre est un logiciel distribué avec l’intégralité de ses programmes-sources, afin que l’ensemble des utilisateurs qui l’emploient, puissent l’enrichir et le redistribuer à leur tour.
Note : Un logiciel libre n’est pas nécessairement gratuit et les droits de la chaîne des auteurs sont préservés.
Équivalent étranger : free software, open source software.
(Source : Vocabulaire de l’informatique (liste de termes, expressions et définitions adoptés), NOR: CTNX0710138K, J.O n° 93 du 20 avril 2007 page 7078, texte n° 84)
logiciel libre
Par logiciel libre on entend un logiciel qui offre la liberté aux utilisateurs d'exécuter, de copier, de distribuer, d'étudier, de modifier et d'améliorer le logiciel. Plus précisément, elle fait référence à quatre types de liberté pour les utilisateurs du logiciel :
    La liberté d'exécuter le programme, pour tous les usages (liberté 0).
    La liberté d'étudier comment le programme fonctionne et de l'adapter à ses besoins (liberté 1). L'accès au code source est une condition requise.
    La liberté de redistribuer des copies, (liberté 2).
    La liberté d'améliorer le programme et de diffuser les améliorations au public pour en faire profiter toute la communauté (liberté 3). L'accès au code source est une condition requise.

On reçoit les données sous la forme : <Nom du groupe de données:Nom de la donnée:Valeur>
  Exemples:
    <Throttle:Regulator:.000>
    <locochanged:Default_ButtonMapper:DD24500>
    <EmergencyBrake:EmergencyBrake:.000>
    <Ammeter:Ammeter:.000>
    <Speed:SpeedometerKPH:1.125>
    <SpeedLimit:CurrentSpeedLimit:120.700>
    <Speed:SpeedometerKPH:.011>
    <Speed:SpeedometerKPH:80.011>

Quand on reçoit une valeur, pour animer une sortie, on peut animer :
    Les sorties servomoteur, avec une valeur de 0 à 255.
    Les sorties pwm (analogique 0-5 Volts), avec une valeur de 0 à 255.
    Les sorties tout ou rien, avec une valeur de 0 ou 1.
    Dans tous les cas, mettre le bit à '1' avec la ligne "bitWrite(,,1)", pour que programme effectue une mise à jour de la sortie.

  Mettre à jour les tables suivantes :
    i2c_srv_val[x] = 0 à 255 + bitWrite(i2c_srv_maj, x, 1)        (x = 0 à 7)  Servomoteurs, manomètres.
    i2c_pwm_val[x] = 0 à 255 + bitWrite(i2c_pwm_maj, x, 1)        (x = 0 à 7)  Compte-tours, compteur de vitesse, galvanomètre, ampèremètre, voltmètre, jauge.
    bitWrite(i2c_out1_val, x, 0) + bitWrite(i2c_out1_maj, x, 1);  (x = 0 à 15) Voyants.
    bitWrite(i2c_out2_val, x, 0) + bitWrite(i2c_out2_maj, x, 1);  (x = 0 à 15) Voyants.
     (bitWrite(i2c_out3_val, x, 0) + bitWrite(i2c_out3_maj, x, 1);  (x = 0 à 15) Voyants) Carte Optionnelle.
    Si maj_forcee = 1 : Mise à jour forcée des sorties vers les cartes.  */

//-----------------------------------------------------------------------------------------------------------------------------
void Data_Recues_du_PC() {
/* Cette version est pour 'TS Classic Raildriver and Joystick Interface' avec 'RailsWorks Classic'.
   On reçoit sur la liaison série, ce type de trame : <Nom du groupe de données:Nom de la donnée:Valeur>
     qu'il faut répartir en 3 chaines de caractères (80 max) :
       -  buffer_rx[0] = Nom du groupe de données (Texte).
       -  buffer_rx[1] = Nom de la donnée (Texte).
       -  buffer_rx[2] = Valeur au format texte (Nombre entier ou avec virgule).

   A chaque passage, on dépile tous les caractères reçus entre temps.
     On ne fournira une action à réaliser, que lorsque l'on aura reçu une commande complète.
     Indicateurs reçus :  Début de trame = '<'  Séparation de champs début de trame = ':'  Fin de trame = '>'  */

  while(Serial.available() > 0) {
    char car_lu = Serial.read();                         // La fonction 'Serial.read()' retourne un entier !  'car_lu' est déclaré en char.
    if(car_lu == '<') {                                  // On a reçu l'indicateur de début de trame '<'.
      debut_rx = true;                                   // D'office, on initialise tout.
      final_rx = false;                                  // indicateur de début de trame reçue = true, de fin de trame = false.
      buffer_rx_buf = 0;                                 // Initialise compteur de champ et de caractères.
      buffer_rx_cpt = 0;                                 //
      buffer_rx[0][0] = '\0';                            // Initialise les chaines de caractères.
      buffer_rx[1][0] = '\0';                            //
      buffer_rx[2][0] = '\0';                            //
    }
    else if(car_lu == '>') {                             // On a reçu l'indicateur de fin de trame '>'.
      if ((debut_rx == true) && (buffer_rx_buf == 2)) {  //
        buffer_rx[buffer_rx_buf][buffer_rx_cpt] = '\0';  // On écrit le caractère 'Null' pour finir la chaine de caractères.
        final_rx = true;                                 // On a bien reçu les trois champs, on valide la réception de fin de trame.
        break;                                           // On sort de la boucle pour traiter cette trame complète, avant de traiter au prochain passage les autres caractères.
      }
      else { debut_rx = false; }                         // On a reçu l'indicateur de fin de trame, sans recevoir celui de début de trame et les 3 champs. On laisse tomber.
    }
    else if(car_lu == ':') {                             // On a reçu l'indicateur de changement de champ de données ':'.
      if (debut_rx == true) {
        buffer_rx[buffer_rx_buf][buffer_rx_cpt] = '\0';  // On écrit le caractère 'Null' pour finir la chaine de caractères.
        buffer_rx_buf++;
        buffer_rx_cpt = 0;
        if (buffer_rx_buf >= 3) { debut_rx = false; }    // On vient de lire un troisième indicateur de changement de champ ':', il y a une erreur !
        }                                                  // On laisse tomber.
    }
    else if (debut_rx == true) {                         // On a déjà reçu l'indicateur de début de trame!
      buffer_rx[buffer_rx_buf][buffer_rx_cpt] = car_lu;  // On a reçu un caractère qui n'est pas un indicateur, on le stocke.
      buffer_rx_cpt++;
      if (buffer_rx_cpt > 78) { debut_rx = false; }      // On vient de lire 78 caractères sans indicateur de fin de trame ! On laisse tomber
    }                                                    // On n'a pas encore reçu l'indicateur de fin de trame. Donc, on jette le caractère reçu.
  }
// On a vidé le buffer de réception, ou l'on a reçu une trame complète.

// -----------------------------------------------------------
  if ((debut_rx == true) && (final_rx==true)) {
    debut_rx = false; final_rx = false;
/* On a reçu une trame de commande.
     -  buffer_rx[0] = Nom du groupe de données (Texte).
     -  buffer_rx[1] = Nom de la donnée (Texte).
     -  buffer_rx[2] = Valeur au format texte (Nombre entier ou avec virgule).
                       Suivant l'utilisation, on convertira cette dernière chaine de caractère, en entier ou en flottant.
                       buffer_rx_valeur  = atoi(buffer_rx[2]); // Conversion du dernier champ : Ascii-> Entier.   Pas de contrôle ! Si Nok valeur = 0!
                       buffer_rx_fvaleur = atof(buffer_rx[2]); // Conversion du dernier champ : Ascii-> Flottant. Pas de contrôle ! Si Nok valeur = 0!*/

// Recopier des lignes au bon endroit, pour débuger une valeur reçue :
//    Serial.print("[Groupe]"); Serial.print(buffer_rx[0]); Serial.print("[Nom]"); Serial.print(buffer_rx[1]); Serial.print("[Valeur]"); Serial.println(buffer_rx_valeur);
//    Serial.print(var_BL); Serial.print(" : "); Serial.print(var_EG1_sim); Serial.print(" : "); Serial.println(bitRead(i2c_in3_val_ref, 0));
//    Serial.print(" x=13 ");  Serial.print(bitRead(i2c_in1_val_ref, 12));Serial.println(bitRead(i2c_in1_val_ref, 13));
//
//=============================================================================================================================
// /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
//=============================================================================================================================
// SORTIES SERVOMOTEURS = MANOMETRES
// Attention mettre un '.' et pas une virgule dans les calculs.
// <  :RE_Anim:6.00>                                   ==> Sortie servo 0
    if (!strcmp(buffer_rx[1],"RE_Anim")) {
      buffer_rx_fvaleur = atof(buffer_rx[2]);           // Conversion du dernier champ : Ascii-> Flottant. Pas de contrôle ! Si Nok valeur = 0 !
      buffer_rx_fvaleur = 42.66*buffer_rx_fvaleur;      // 6 Bars => buffer_rx_fvaleur = 256 au maximum (Coéf = 256/6). Une seule multiplication en flottant, pour économiser le cpu.
      buffer_rx_valeur  = int(buffer_rx_fvaleur);       //
      buffer_rx_valeur  = min(buffer_rx_valeur, 255);   // Valeur <= 255.
      i2c_srv_val[0]    = max(buffer_rx_valeur, 0);     // Valeur positive !
      bitWrite(i2c_srv_maj, 0, 1);
    }
// <  :CP:9.00>                                        ==> Sortie servo 1
    else if (!strcmp(buffer_rx[1],"CP")) {
      buffer_rx_fvaleur = atof(buffer_rx[2]);           // Conversion du dernier champ : Ascii-> Flottant. Pas de contrôle ! Si Nok valeur = 0 !
      buffer_rx_fvaleur = 28.44*buffer_rx_fvaleur;      // 9 Bars => buffer_rx_fvaleur = 256 au maximum (Coéf = 256/9). Une seule multiplication en flottant, pour économiser le cpu.
      buffer_rx_valeur  = int(buffer_rx_fvaleur);       //
      buffer_rx_valeur  = min(buffer_rx_valeur, 255);   // Valeur <= 255.
      i2c_srv_val[1]    = max(buffer_rx_valeur, 0);     // Valeur positive !
      bitWrite(i2c_srv_maj, 1, 1);
    }
// <  :CGanim:6.00>                                    ==> Sortie servo 2
    else if (!strcmp(buffer_rx[1],"CGanim")) {
      buffer_rx_fvaleur = atof(buffer_rx[2]);           // Conversion du dernier champ : Ascii-> Flottant. Pas de contrôle ! Si Nok valeur = 0 !
      buffer_rx_fvaleur = 42.66*buffer_rx_fvaleur;      // 6 Bars => buffer_rx_fvaleur = 256 au maximum (Coéf = 256/6). Une seule multiplication en flottant, pour économiser le cpu.
      buffer_rx_valeur  = int(buffer_rx_fvaleur);       //
      buffer_rx_valeur  = min(buffer_rx_valeur, 255);   // Valeur <= 255.
      i2c_srv_val[2]    = max(buffer_rx_valeur, 0);     // Valeur positive !
      bitWrite(i2c_srv_maj, 2, 1);
    }
// <  :CFanim:5.00>                                    ==> Sortie servo 3
    else if (!strcmp(buffer_rx[1],"CFanim")) {
      buffer_rx_fvaleur = atof(buffer_rx[2]);           // Conversion du dernier champ : Ascii-> Flottant. Pas de contrôle ! Si Nok valeur = 0 !
      buffer_rx_fvaleur = 51.2*buffer_rx_fvaleur;       // 5 Bars => buffer_rx_fvaleur = 256 au maximum (Coéf = 256/5). Une seule multiplication en flottant, pour économiser le cpu.
      buffer_rx_valeur  = int(buffer_rx_fvaleur);       //
      buffer_rx_valeur  = min(buffer_rx_valeur, 255);   // Valeur <= 255.
      i2c_srv_val[3]    = max(buffer_rx_valeur, 0);     // Valeur positive !
      bitWrite(i2c_srv_maj, 3, 1);
    }
// <  :CF2anim:5.00>                                   ==> Sortie servo 4
    else if (!strcmp(buffer_rx[1],"CF2anim")) {
      buffer_rx_fvaleur = atof(buffer_rx[2]);           // Conversion du dernier champ : Ascii-> Flottant. Pas de contrôle ! Si Nok valeur = 0 !
      buffer_rx_fvaleur = 51.2*buffer_rx_fvaleur;       // 5 Bars => buffer_rx_fvaleur = 256 au maximum (Coéf = 256/5). Une seule multiplication en flottant, pour économiser le cpu.
      buffer_rx_valeur  = int(buffer_rx_fvaleur);       //
      buffer_rx_valeur  = min(buffer_rx_valeur, 255);   // Valeur <= 255.
      i2c_srv_val[4]    = max(buffer_rx_valeur, 0);     // Valeur positive !
      bitWrite(i2c_srv_maj, 4, 1);
    }
//=============================================================================================================================
// /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
//=============================================================================================================================
// SORTIES PWM - GALVANOMETRES
// Attention mettre un '.' et pas une virgule dans les calculs.
// <   :AMP_Moteur:2000.00>                            ==> Sortie pwm 0
    else if (!strcmp(buffer_rx[1],"AMP_Moteur")) {      // Ampères transmis en flottant.
      buffer_rx_fvaleur = atof(buffer_rx[2]);           // Conversion du dernier champ : Ascii-> Flottant. Pas de contrôle ! Si Nok valeur = 0 !
      buffer_rx_fvaleur = 0.128*buffer_rx_fvaleur;      // 2000 => buffer_rx_fvaleur = 256 au maximum (Coéf = 256/2000). Une seule multiplication en flottant, pour économiser le cpu.
      buffer_rx_valeur  = int(buffer_rx_fvaleur);       //
      buffer_rx_valeur  = min(buffer_rx_valeur, 255);   // Valeur <= 255.
      i2c_pwm_val[0]    = max(buffer_rx_valeur, 0);     // Valeur positive !
      bitWrite(i2c_pwm_maj, 0, 1);                      //
      i2c_pwm_val[1]    = i2c_pwm_val[0];               // Recopie de la valeur en deuxième sortie pwm[1].
      bitWrite(i2c_pwm_maj, 1, 1);
    }
// <   :AMP_Moteur:2000.00>                            ==> Sortie pwm 1 - TRAITE AVEC LA SORTIE '0' CI-DESSUS !!!
//
// <   :Tension_LDT:2000.00>                           ==> Sortie pwm 2
    else if (!strcmp(buffer_rx[1],"Tension_LDT")) {     //
      buffer_rx_fvaleur = atof(buffer_rx[2]);           // Conversion du dernier champ : Ascii-> Flottant. Pas de contrôle ! Si Nok valeur = 0 !
      buffer_rx_fvaleur = 0.128*buffer_rx_fvaleur;      // 2000 => buffer_rx_fvaleur = 256 au maximum (Coéf = 256/2000). Une seule multiplication en flottant, pour économiser le cpu.
      buffer_rx_valeur  = int(buffer_rx_fvaleur);       //
      buffer_rx_valeur  = min(buffer_rx_valeur, 255);   // Valeur <= 255.
      i2c_pwm_val[2]    = max(buffer_rx_valeur, 0);     // Valeur positive !
      bitWrite(i2c_pwm_maj, 2, 1);
    }
// <   :Compte_tours:1500.00>                          ==> Sortie pwm 3
    else if (!strcmp(buffer_rx[1],"Compte_tours")) {    //
      buffer_rx_fvaleur = atof(buffer_rx[2]);           // Conversion du dernier champ : Ascii-> Flottant. Pas de contrôle ! Si Nok valeur = 0 !
      buffer_rx_fvaleur = 0.17*buffer_rx_fvaleur;       // 1500 => buffer_rx_fvaleur = 256 au maximum (Coéf = 256/1500). Une seule multiplication en flottant, pour économiser le cpu.
      buffer_rx_valeur  = int(buffer_rx_fvaleur);       //
      buffer_rx_valeur  = min(buffer_rx_valeur, 255);   // Valeur <= 255.
      i2c_pwm_val[3]    = max(buffer_rx_valeur, 0);     // Valeur positive !
      bitWrite(i2c_pwm_maj, 3, 1);
    }
// <   :SpeedometerKPH:160.00>                         ==> Sortie pwm 4
   else if (!strcmp(buffer_rx[1],"SpeedometerKPH")) {   //
      buffer_rx_fvaleur = atof(buffer_rx[2]);           // Conversion du dernier champ : Ascii-> Flottant. Pas de contrôle ! Si Nok valeur = 0 !
      buffer_rx_fvaleur = 1.6*buffer_rx_fvaleur;        // 160 => buffer_rx_fvaleur = 256 au maximum (Coéf = 256/160). Une seule multiplication en flottant, pour économiser le cpu.
      buffer_rx_valeur  = int(buffer_rx_fvaleur);       //
      buffer_rx_valeur  = min(buffer_rx_valeur, 255);   // Valeur <= 255.
      i2c_pwm_val[4]    = max(buffer_rx_valeur, 0);     // Valeur positive !
      bitWrite(i2c_pwm_maj, 4, 1);
   }
//=============================================================================================================================
// /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
//=============================================================================================================================
// SORTIES 1 TOUT OU RIEN
    else if (!strcmp(buffer_rx[1],"VY_QT1"))             buffer2_compare_int_maj_out(out1,  0); // <   :VY_QT1:1>             Pour allumer ou éteindre le voyant n° out1/0.
    else if (!strcmp(buffer_rx[1],"VY_QT2"))             buffer2_compare_int_maj_out(out1,  1); // <   :VY_QT2:1>             Pour allumer ou éteindre le voyant n° out1/1.
    else if (!strcmp(buffer_rx[1],"VY_MD1"))             buffer2_compare_int_maj_out(out1,  2); // <   :VY_MD1:1>             Pour allumer ou éteindre le voyant n° out1/2.
    else if (!strcmp(buffer_rx[1],"VY_MD2"))             buffer2_compare_int_maj_out(out1,  3); // <   :VY_MD2:1>             Pour allumer ou éteindre le voyant n° out1/3.
    else if (!strcmp(buffer_rx[1],"VY_Batt"))            buffer2_compare_int_maj_out(out1,  4); // <   :VY_Batt:1>            Pour allumer ou éteindre le voyant n° out1/4.
    else if (!strcmp(buffer_rx[1],"VY_PAT"))             buffer2_compare_int_maj_out(out1,  5); // <   :VY_PAT:1>             Pour allumer ou éteindre le voyant n° out1/5.
    else if (!strcmp(buffer_rx[1],"Vy_Surcharge"))       buffer2_compare_int_maj_out(out1,  8); // <   :Vy_Surcharge:1>       Pour allumer ou éteindre le voyant n° out1/8.
    else if (!strcmp(buffer_rx[1],"Vy_SAL")) {           buffer2_compare_int_maj_out(out1,  9); // <   :Vy_SAL:1>             Pour allumer ou éteindre le voyant n° out1/9-out2/8-9-10.
                                                         buffer2_compare_int_maj_out(out2,  8); //                            Force aussi le clignotement des phares. Mais à la fin, il faut réallumer les phares si besoin.
                                                         buffer2_compare_int_maj_out(out2,  9); //                            Force aussi le clignotement des phares.
                                                         buffer2_compare_int_maj_out(out2, 10); //                            Force aussi le clignotement des phares.
    }
    else if (!strcmp(buffer_rx[1],"Vacma_CA"))           buffer2_compare_int_maj_out(out1, 10); // <   :Vacma_CA:1>           Pour allumer ou éteindre l'alarme sonore n° out1/10.
    else if (!strcmp(buffer_rx[1],"Vacma_RA"))           buffer2_compare_int_maj_out(out1, 11); // <   :Vacma_RA:1>           Pour allumer ou éteindre l'alarme sonore n° out1/11.
    else if (!strcmp(buffer_rx[1],"HandBrake"))          buffer2_compare_int_maj_out(out1, 12); // <   :HandBrake:1>          Pour allumer ou éteindre le voyant n° out1/12.

    // IL FAUDRA AJOUTER DU CODE POUR REMETTRE EN ROUTE LES PHARES SI ILS ETAIENT ALLUMES !!!
    // else if (!strcmp(buffer_rx[1],"SAL"))                buffer2_compare_float_maj_out(out1, 9);   // <   :SAL:1>     Signal d'alerte. Pour allumer ou éteindre le voyant n° out1/9.
//
//=============================================================================================================================
// /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
//=============================================================================================================================
// SORTIES 2 TOUT OU RIEN
    else if (!strcmp(buffer_rx[1],"Eclairage_Pupitre")) {
      buffer2_compare_float_maj_out(out2, 0);                   // <   :Eclairage_Pupitre:1>           Pour allumer ou éteindre le voyant n° out2/0.
      buffer2_compare_float_maj_sim(in2, 10);                   //
    }
    else if (!strcmp(buffer_rx[1],"Eclairage_Cabine")) {        // <   :Eclairage_Cabine:1>            Pour allumer ou éteindre le voyant n° out2/1.
      buffer2_compare_float_maj_out(out2,  1);                  //                                     Pour éclairer le pupitre.
      buffer2_compare_float_maj_out(out2, 13);                  //                                     Pour la maquette de la loco.
      buffer2_compare_float_maj_sim(in2,   8);                  //
    }
    else if (!strcmp(buffer_rx[1],"Fanal_Gauche")) {            // <   :Fanal_Gauche:1>                Pour allumer ou éteindre le voyant n° out2/8.
      buffer2_compare_float_maj_out(out2,  8);                  //
      buffer2_compare_float_maj_sim(in2,  11);                  //
    }
    else if (!strcmp(buffer_rx[1],"Fanal_Droit")) {             // <   :Fanal_Droit:1>                 Pour allumer ou éteindre le voyant n° out2/9.
      buffer2_compare_float_maj_out(out2,  9);                  //
      buffer2_compare_float_maj_sim(in2,  12);                  //
    }
    else if (!strcmp(buffer_rx[1],"Projecteurs_1")) {           // <   :Projecteurs_1:1>               Pour allumer ou éteindre le voyant n° out2/10.
      buffer2_compare_float_maj_out(out2, 10);                  //
      buffer2_compare_float_maj_sim(in2,  13);                  //
    }
    else if (!strcmp(buffer_rx[1],"Feu_RougeG"))                // <   :Feu_RougeG:1>                  Pour allumer ou éteindre le voyant n° out2/11.
      buffer2_compare_float_maj_out(out2, 11);
//
    else if (!strcmp(buffer_rx[1],"Feu_RougeD"))                // <   :Feu_RougeD:1>                  Pour allumer ou éteindre le voyant n° out2/12.
      buffer2_compare_float_maj_out(out2, 12);
//
    else if (!strcmp(buffer_rx[1],"Feu_RougeG2")) {             // <   :Feu_RougeG2:1>                 Pour allumer ou éteindre le voyant n° out2/14. Cab2
      buffer2_compare_float_maj_out(out2, 14);                  //
      buffer2_compare_float_maj_sim(in3,   8);                  //
    }
    else if (!strcmp(buffer_rx[1],"Feu_RougeD2")) {             // <   :Feu_RougeD2:1>                 Pour allumer ou éteindre le voyant n° out2/15. Cab2
      buffer2_compare_float_maj_out(out2, 15);                  //
      buffer2_compare_float_maj_sim(in3,   9);                  //
    }
// ACTION DEJA REALISEE AVEC LE TRAITEMENT DE LA SORTIE OUT2/1. // <   :Eclairage_Cabine:1>            Pour allumer ou éteindre le voyant n° out2/13.
//
//=============================================================================================================================
// /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
//=============================================================================================================================
// VARIABLE DE FONCTIONNALITES
// <locochanged:   :jCC72000>                                 ==> On a changé de locomotive, on remet à zéro tous les équipements.
    else if (!strcmp(buffer_rx[0],"locochanged")) {            //
      for (x = 0; x < i2c_srv_nbmax; x ++) i2c_srv_val[x] = 0; // Initialise la valeur des servomoteurs.
      i2c_srv_maj  = 0xFF;                                     //
      for (x = 0; x < i2c_pwm_nbmax; x ++) i2c_pwm_val[x] = 0; // Initialise la valeur des sorties pwm.
      i2c_pwm_maj  = 0xFF;                                     //
      i2c_out1_val = 0x0000; i2c_out1_maj = 0xFFFF;            // Initialise la valeur des sorties 0/1.
      i2c_out2_val = 0x0000; i2c_out2_maj = 0xFFFF;            //
      KVB_car_vers_KVB = 'R';                                  // Raz de l'affichage du KVB
    }
//
//=============================================================================================================================
// /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
//=============================================================================================================================
// DIVERS
    else if (!strcmp(buffer_rx[1],"BP_Urg"))     buffer2_compare_float_maj_sim(in1, 3);    // <   :BP_Urg:1>    Bouton rouge - Frein d'urgence.
// <   :FD:1.0>                                                  ==> Frein direct.    Valeur flottante = -1.0 -0.9 ... 0.0 ... 0.9  1.0
    else if (!strcmp(buffer_rx[1],"FD")) {                        // Grand levier de frein direct.
      buffer_rx_fvaleur = atof(buffer_rx[2]);                     // Obligé de passer par un nombre en flottant.
      if        (buffer_rx_fvaleur >  0.98)                               { bitWrite(i2c_in1_val_sim, 4, 0); bitWrite(i2c_in1_val_sim, 5, 1);
                 bitWrite(i2c_in1_maj_sim,  4, 1); bitWrite(i2c_in1_maj_sim,  5, 1); // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
      }
      else if   (buffer_rx_fvaleur < -0.98)                               { bitWrite(i2c_in1_val_sim, 4, 1); bitWrite(i2c_in1_val_sim, 5, 0);
                 bitWrite(i2c_in1_maj_sim,  4, 1); bitWrite(i2c_in1_maj_sim,  5, 1); // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
      }
      else if ((buffer_rx_fvaleur > -0.02) && (buffer_rx_fvaleur < 0.02)) { bitWrite(i2c_in1_val_sim, 4, 0); bitWrite(i2c_in1_val_sim, 5, 0);
                 bitWrite(i2c_in1_maj_sim,  4, 1); bitWrite(i2c_in1_maj_sim,  5, 1); // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
      }
    }
//
// <   :Inverseur_1:1>                                           ==> Inverseur de traction, à 3 positions.
//   i2c_in1_val(12)   i2c_in1_val(13)  Position de l'inverseur de traction    Valeur Inverseur_1
//          1                 0            = Position en avant +                      1.0
//          0                 0            = Position neutre au centre                0.0
//          0                 1            = Position en arrière -                   -1.0
    else if (!strcmp(buffer_rx[1],"Inverseur_1")) {               //
      buffer_rx_fvaleur = atof(buffer_rx[2]);                     // Obligé de passer par un nombre en flottant.
      if       (buffer_rx_fvaleur >  0.98)                                { bitWrite(i2c_in1_val_sim, 12, 1); bitWrite(i2c_in1_val_sim, 13, 0);  // (+).
                bitWrite(i2c_in1_maj_sim, 12, 1); bitWrite(i2c_in1_maj_sim, 13, 1); // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
      }
      else if  (buffer_rx_fvaleur < -0.98)                                { bitWrite(i2c_in1_val_sim, 12, 0); bitWrite(i2c_in1_val_sim, 13, 1);  // (-) ou 0.
                bitWrite(i2c_in1_maj_sim, 12, 1); bitWrite(i2c_in1_maj_sim, 13, 1); // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
      }
      else if ((buffer_rx_fvaleur > -0.02) && (buffer_rx_fvaleur < 0.02)) { bitWrite(i2c_in1_val_sim, 12, 0); bitWrite(i2c_in1_val_sim, 13, 0);  // STOP
                bitWrite(i2c_in1_maj_sim, 12, 1); bitWrite(i2c_in1_maj_sim, 13, 1); // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
      }
    }
// <   :Cerclo:1>                                               ===> Cerclo.
//   i2c_in1_val(13)   i2c_in1_val(14)     Position du Cerclo             Valeur  Cerclo
//          1                 1            = Position   (+)                    4.0
//          0                 1            = Position  (STOP)                  2.8
//          0                 0            = Position (-) ou 0                 0.0
    else if (!strcmp(buffer_rx[1],"Cerclo")) {                    //
      buffer_rx_fvaleur = atof(buffer_rx[2]);                     // Obligé de passer par un nombre en flottant.
      if       (buffer_rx_fvaleur > 3.98)                                { bitWrite(i2c_in1_val_sim, 9, 1); bitWrite(i2c_in1_val_sim, 10, 1);  // (+).
                bitWrite(i2c_in1_maj_sim,  9, 1); bitWrite(i2c_in1_maj_sim, 10, 1); // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
      }
      else if  (buffer_rx_fvaleur < 0.02)                                { bitWrite(i2c_in1_val_sim, 9, 0); bitWrite(i2c_in1_val_sim, 10, 0);  // (-) ou 0.
                bitWrite(i2c_in1_maj_sim,  9, 1); bitWrite(i2c_in1_maj_sim, 10, 1); // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
      }
      else if ((buffer_rx_fvaleur > 2,78) && (buffer_rx_fvaleur < 2,82)) { bitWrite(i2c_in1_val_sim, 9, 0); bitWrite(i2c_in1_val_sim, 10, 1);  // STOP
                bitWrite(i2c_in1_maj_sim,  9, 1); bitWrite(i2c_in1_maj_sim, 10, 1); // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
      }
    }
//----------------------------------------------
    else if (!strcmp(buffer_rx[1],"CPR-Auto"))            buffer2_compare_float_maj_sim(in2,  2); // <   :CPR-Auto:1>              Compresseur Auto.
    else if (!strcmp(buffer_rx[1],"Chauffage_Train"))     buffer2_compare_float_maj_sim(in2,  3); // <   :Chauffage_Train:1>       Chauffage_Train.
    else if (!strcmp(buffer_rx[1],"Acceleration_Diesel")) buffer2_compare_float_maj_sim(in2,  5); // <   :Acceleration_Diesel:1>   Acceleration_Diesel.
    else if (!strcmp(buffer_rx[1],"BL"))                  buffer2_compare_float_maj_sim(in2,  7); // <   :BL:1>                    Boite à leviers.
    else if (!strcmp(buffer_rx[1],"Essais_VA"))           buffer2_compare_float_maj_sim(in2, 14); // <   :Essais_VA:1>             Essais_VA.
//----------------------------------------------
    else if (!strcmp(buffer_rx[1],"Wipers"))              buffer2_compare_float_maj_sim(in3,  3); // <   :Wipers:1>              Interrupteur Essuie-glaces.
    else if (!strcmp(buffer_rx[1],"Z_IS_VA"))             buffer2_compare_float_maj_sim(in3, 12); // <   :Z_IS_VA:1>             Interrupteur annexe - Isolation VA. Nombre flottant !
    else if (!strcmp(buffer_rx[1],"Z_IS_KVB"))            buffer2_compare_float_maj_sim(in3, 13); // <   :Z_IS_KVB:1>            Interrupteur annexe - Isolation KVB.
    else if (!strcmp(buffer_rx[1],"Z_IS_RS"))             buffer2_compare_float_maj_sim(in3, 14); // <   :Z_IS_RS:1>             Interrupteur annexe - Isolation RS.
//
//=============================================================================================================================
// /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
//=============================================================================================================================
// TRANSFERT DES ORDRES DU PC VERS LE KVB, sur la LIAISON TX3.
// -----------------------------------------------------------
// Si le simulateur a envoyé une commande pour le KVB, on la traite ici.
// On peut mettre deux ordres pour une même commande, pour être compatible avec plusieurs locomotives.
/* L'afficheur :                                           Les voyants :
 b => [   ][ b ]                                        0 =>  (V)   Eteint     1 =>  (V)   Allumée
 c => [   ][   ] Efface que l'afficheur [   ][   ]      2 =>  (FU)  Eteint     3 =>  (FU)  Allumée
 e => [   ][===]                                        4 => (SOL)  Eteint     5 => (SOL)  Allumée
 F => [   ][ F ]                                        6 => (ENG)  Eteint     7 => (ENG)  Allumée
 l => [ L ][   ]                                        g => [VAL]  Eteint     G => [VAL]  Allumée     A => [VAL]  Clignotant
 L => [   ][ L ]                                        h =>  [MV]  Eteint     H =>  [MV]  Allumée
 m => [---][---] Moins                                  i =>  [FC]  Eteint     I =>  [FC]  Allumée
 M => [---][---] Moins Clignotant                       j => (LSSF) Eteint     J => (LSSF) Fixe        C => (LSSF) Clignotant
 p => [ p ][   ]                                        k => Arret  klaxon     K => Klaxon actif sur haut-parleur
 P => [   ][ P ]                                        q => Arret  buzzer     Q => Buzzer actif
 t => [888][888] Affiche 888 888
 U => [   ][ FU] fU
 y => [ 00][   ] 2 Zéro
 Y => [000][   ] 3 Zéro
 x => [---][ 00] Moins + 2 Zéro
 z => [   ][ 00] 2 Zéro Clignotant
 Z => [   ][ 00] 2 Zéro Fixe                            Il existe d'autres commandes pour le KVB, mais pas employées ici. (Voir notice du KVB).
 T => Séquence de test.
 s => Séquence d'initialisation du KVB, à la mise sous tension du pupitre. */

// -----------------------------------------------------------
// KVB.
// <KVB:XXXXXX:1>                                        ==> Envoi d'un ordre vers le KVB, sur la liaison série n°3.
#ifdef FONCTION_KVB                                       // FONCTION : Compilation conditionnelle, si KVB déclaré.
    if(!strcmp(buffer_rx[0],"KVB")) {
      buffer_rx_valeur = atoi(buffer_rx[2]);              // Valeur = 0 ou 1.
      if     (!strcmp(buffer_rx[1],"KVBVoyanSV")) {if(buffer_rx_valeur == 1) KVB_car_vers_KVB = '1'; else KVB_car_vers_KVB = '0'; }
      else if(!strcmp(buffer_rx[1],"KVBVoyanFU")) {if(buffer_rx_valeur == 1) KVB_car_vers_KVB = '3'; else KVB_car_vers_KVB = '2'; }
      else if(!strcmp(buffer_rx[1],"KVBVoyanPS")) {if(buffer_rx_valeur == 1) KVB_car_vers_KVB = '5'; else KVB_car_vers_KVB = '4'; }
      else if(!strcmp(buffer_rx[1],"KVBVoyanPE")) {if(buffer_rx_valeur == 1) KVB_car_vers_KVB = '7'; else KVB_car_vers_KVB = '6'; }
      else if(!strcmp(buffer_rx[1],"LampeLSSF"))  {if(buffer_rx_valeur == 1) KVB_car_vers_KVB = 'J'; else KVB_car_vers_KVB = 'j'; }
      else if(!strcmp(buffer_rx[1],"VY_VAL"))     {if(buffer_rx_valeur == 1) KVB_car_vers_KVB = 'G'; else KVB_car_vers_KVB = 'g'; }
      else if(!strcmp(buffer_rx[1],"VY_MAN"))     {if(buffer_rx_valeur == 1) KVB_car_vers_KVB = 'H'; else KVB_car_vers_KVB = 'h'; }
      else if(!strcmp(buffer_rx[1],"VY_FC"))      {if(buffer_rx_valeur == 1) KVB_car_vers_KVB = 'I'; else KVB_car_vers_KVB = 'i'; }
      if(!strcmp(buffer_rx[1],"KVB_Rouleau"))     {if(buffer_rx_valeur == 0) KVB_car_vers_KVB = 'c';
                                              else if(buffer_rx_valeur == 2) KVB_car_vers_KVB = 's';
                                              else if(buffer_rx_valeur == 6) KVB_car_vers_KVB = 'Y'; }
    }
#endif
  }
//
//=============================================================================================================================
// /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
//=============================================================================================================================
// Toutes les xxx msec, on vérifie périodiquement si les interrupteurs du simulateur, sont en accord avec ceux du pupitre.
// i2c_in1_val     = Valeur de l'entrée sur le pupitre physique.
// i2c_in1_val_ref = Dernière valeur mémorisée sur le pupitre physique.
// i2c_in1_val_sim = Valeur envoyée par l'ordinateur.
// Si ce n'est pas égal, on demande une mise à jour en activant un bit dans "i2c_in1_maj".
// On ne le fait pas pour toutes les valeurs. Il faut que la valeur a été reçue. (i2c_in1_maj_sim = 1).
// On le fait pour les interrupteurs, pas pour les boutons poussoirs.
//
  if (ic2_in_comp_ref_milli > millis() + duree_ic2_in_comp_ref)   ic2_in_comp_ref_milli = millis() + duree_ic2_in_comp_ref; // On limite le delai maximum d'attente, de la prochaine comparaison.
  if (millis() > ic2_in_comp_ref_milli) {
  ic2_in_comp_ref_milli = millis() + duree_ic2_in_comp_ref;  // On repassera ici dans "duree_ic2_in_comp_ref" msec.
//
    if (i2c_in1_maj_sim != 0x0000) {
      for ( x = 0; x < i2c_in_nbmax; x++) {
        if (bitRead(i2c_in1_maj_sim,  x) == 1) {
          if ((bitRead(i2c_in1_val,  x) + bitRead(i2c_in1_val_sim,  x)) == 1) { bitWrite(i2c_in1_val_ref, x, bitRead(i2c_in1_val_sim,  x)); bitWrite(i2c_in1_maj,  x, 1); }
        }
      }
      i2c_in1_maj_sim = 0x0000;
    }
    if (i2c_in2_maj_sim != 0x0000) {
      for ( x = 0; x < i2c_in_nbmax; x++) {
        if (bitRead(i2c_in2_maj_sim,  x) == 1) {
          if ((bitRead(i2c_in2_val,  x) + bitRead(i2c_in2_val_sim,  x)) == 1) { bitWrite(i2c_in2_val_ref, x, bitRead(i2c_in2_val_sim,  x)); bitWrite(i2c_in2_maj,  x, 1); }
        }
      }
      i2c_in2_maj_sim = 0x0000;
    }
    if (i2c_in3_maj_sim != 0x0000) {
      for ( x = 0; x < i2c_in_nbmax; x++) {
        if (bitRead(i2c_in3_maj_sim,  x) == 1) {
          if ((bitRead(i2c_in3_val,  x) + bitRead(i2c_in3_val_sim,  x)) == 1) { bitWrite(i2c_in3_val_ref, x, bitRead(i2c_in3_val_sim,  x)); bitWrite(i2c_in3_maj,  x, 1); }
        }
      }
      i2c_in3_maj_sim = 0x0000;
    }
  }
}
//
//=============================================================================================================================
// /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
//=============================================================================================================================
// Sous programme de comparaison d'un nombre entier et mise à jour des entrées.
//  buffer2_compare_int_maj_sim(1=in1, 2=in2, 3=in3; Numéro de l'entrée);
void buffer2_compare_int_maj_sim(int x, int y) {
  buffer_rx_valeur = atoi(buffer_rx[2]);                     // On passe par un nombre entier. Conversion en : 0/1.
  if (y < i2c_in_nbmax) {
    if      (x == 1) {
      if       (buffer_rx_valeur == 1) { bitWrite(i2c_in1_val_sim, y, 1); bitWrite(i2c_in1_maj_sim, y, 1); }
      else                             { bitWrite(i2c_in1_val_sim, y, 0); bitWrite(i2c_in1_maj_sim, y, 1); } // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
    }
    else if (x == 2) {
      if       (buffer_rx_valeur == 1) { bitWrite(i2c_in2_val_sim, y, 1); bitWrite(i2c_in2_maj_sim, y, 1); }
      else                             { bitWrite(i2c_in2_val_sim, y, 0); bitWrite(i2c_in2_maj_sim, y, 1); } // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
    }
    else if (x == 3) {
      if       (buffer_rx_valeur == 1) { bitWrite(i2c_in3_val_sim, y, 1); bitWrite(i2c_in3_maj_sim, y, 1); }
      else                             { bitWrite(i2c_in3_val_sim, y, 0); bitWrite(i2c_in3_maj_sim, y, 1); } // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
    }
  }
}
// ------------------------------------------------------------
// Sous programme de comparaison d'un nombre flottant et mise à jour des entrées.
//  buffer2_compare_float_maj_sim(1=in1, 2=in2, 3=in3; Numéro de l'entrée);
void buffer2_compare_float_maj_sim(int x, int y) {
  buffer_rx_fvaleur = atof(buffer_rx[2]);                     // Obligé de passer par un nombre flottant.
  if (y < i2c_in_nbmax) {
    if      (x == 1) {
      if       (buffer_rx_fvaleur > 0.98) { bitWrite(i2c_in1_val_sim, y, 1); bitWrite(i2c_in1_maj_sim, y, 1); }
      else if  (buffer_rx_fvaleur < 0.02) { bitWrite(i2c_in1_val_sim, y, 0); bitWrite(i2c_in1_maj_sim, y, 1); } // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
    }
    else if (x == 2) {
      if       (buffer_rx_fvaleur > 0.98) { bitWrite(i2c_in2_val_sim, y, 1); bitWrite(i2c_in2_maj_sim, y, 1); }
      else if  (buffer_rx_fvaleur < 0.02) { bitWrite(i2c_in2_val_sim, y, 0); bitWrite(i2c_in2_maj_sim, y, 1); } // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
    }
    else if (x == 3) {
      if       (buffer_rx_fvaleur > 0.98) { bitWrite(i2c_in3_val_sim, y, 1); bitWrite(i2c_in3_maj_sim, y, 1); }
      else if  (buffer_rx_fvaleur < 0.02) { bitWrite(i2c_in3_val_sim, y, 0); bitWrite(i2c_in3_maj_sim, y, 1); } // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
    }
  }
}
// ------------------------------------------------------------
// Sous programme de comparaison d'un nombre entier et mise à jour des sorties.
//  buffer2_compare_int_maj_out(1=out1, 2=out2, Numéro de la sortie);
void buffer2_compare_int_maj_out(int x, int y) {
  buffer_rx_valeur = atoi(buffer_rx[2]);                     // On passe par un nombre entier. Conversion en : 0/1.
  if (y < i2c_in_nbmax) {
    if      (x == 1) {
      if       (buffer_rx_valeur == 1) { bitWrite(i2c_out1_val, y, 1); bitWrite(i2c_out1_maj, y, 1); }
      else                             { bitWrite(i2c_out1_val, y, 0); bitWrite(i2c_out1_maj, y, 1); } // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
    }
    else if (x == 2) {
      if       (buffer_rx_valeur == 1) { bitWrite(i2c_out2_val, y, 1); bitWrite(i2c_out2_maj, y, 1); }
      else                             { bitWrite(i2c_out2_val, y, 0); bitWrite(i2c_out2_maj, y, 1); } // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
    }
  }
}
// ------------------------------------------------------------
// Sous programme de comparaison d'un nombre flottant et mise à jour des sorties.
//  buffer2_compare_float_maj_out(1=out1, 2=out2; Numéro de la sortie);
void buffer2_compare_float_maj_out(int x, int y) {
  buffer_rx_fvaleur = atof(buffer_rx[2]);                     // Obligé de passer par un nombre flottant.
  if (y < i2c_in_nbmax) {
    if      (x == 1) {
      if       (buffer_rx_fvaleur > 0.98) { bitWrite(i2c_out1_val, y, 1); bitWrite(i2c_out1_maj, y, 1); }
      else if  (buffer_rx_fvaleur < 0.02) { bitWrite(i2c_out1_val, y, 0); bitWrite(i2c_out1_maj, y, 1); } // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
    }
    else if (x == 2) {
      if       (buffer_rx_fvaleur > 0.98) { bitWrite(i2c_out2_val, y, 1); bitWrite(i2c_out2_maj, y, 1); }
      else if  (buffer_rx_fvaleur < 0.02) { bitWrite(i2c_out2_val, y, 0); bitWrite(i2c_out2_maj, y, 1); } // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
    }
  }
}