/* Fichier : PDC_Arduino_JLF_BB67000_Y.ino
   Pupitre de Conduite Locomotive.      JLF le 15/02/2025.

Si il y a un problème de compilation ou erreur 'keyboard.h', installer la bibliothèque : Arduino SAM boards (32-bit arm cortex-m0).
En branchant cette carte, on doit vous proposer de la télécharger.
Mettre à jour les librairies déjà installées.

Site web : http://www.la-tour.info/uts/uts_page15.html#conduite

Pour la :
 ######  ######      #####  #######   ###     ###     ###                       #     #                                   
 #     # #     #    #     # #    #   #   #   #   #   #   #     #####  ######     #   #   ####  #    #   ##   #    #
 #     # #     #    #           #   #     # #     # #     #    #    # #           # #   #    # #    #  #  #  ##   #
 ######  ######     ######     #    #     # #     # #     #    #    # #####        #    #    # ###### #    # # #  #
 #     # #     #    #     #   #     #     # #     # #     #    #    # #            #    #    # #    # ###### #  # #
 #     # #     #    #     #   #      #   #   #   #   #   #     #    # #            #    #    # #    # #    # #   ##
 ######  ######      #####    #       ###     ###     ###      #####  ######       #     ####  #    # #    # #    #

Si vous réaliser des améliorations matériels ou logicielles, merci de les poster sur le forum RMF pour en faire profiter le plus grand nombre.
Si vous publier cette réalisation avec ou sans améliorations, vous devez publier votre code source.
Ce logiciel est un logiciel libre. Exigence du concepteur : Ne pas modifier la ligne d'affichage "JLF  xx/xx/xxxx" sur l'écran LCD.
On peut modifier ce programme et le diffuser. Dans ce cas, il faut préciser l'origine et donner accès aux sources modifiées.
Définition : Un logiciel libre est un logiciel distribué avec l’intégralité de ses programmes-sources, afin que l’ensemble des utilisateurs qui l’emploient, puissent l’enrichir et le redistribuer à leur tour.
Note : Un logiciel libre n’est pas nécessairement gratuit et les droits de la chaîne des auteurs sont préservés.
Équivalent étranger : free software, open source software.
(Source : Vocabulaire de l’informatique (liste de termes, expressions et définitions adoptés), NOR: CTNX0710138K, J.O n° 93 du 20 avril 2007 page 7078, texte n° 84)
logiciel libre
Par logiciel libre on entend un logiciel qui offre la liberté aux utilisateurs d'exécuter, de copier, de distribuer, d'étudier, de modifier et d'améliorer le logiciel. Plus précisément, elle fait référence à quatre types de liberté pour les utilisateurs du logiciel :
    La liberté d'exécuter le programme, pour tous les usages (liberté 0).
    La liberté d'étudier comment le programme fonctionne et de l'adapter à ses besoins (liberté 1). L'accès au code source est une condition requise.
    La liberté de redistribuer des copies, (liberté 2).
    La liberté d'améliorer le programme et de diffuser les améliorations au public pour en faire profiter toute la communauté (liberté 3). L'accès au code source est une condition requise.

Code pour ARDUINO DUE : Déclaration des variables en mode Entier, plutôt qu'en octet.
Attention pour l'ecran LCD branché sur la deuxième sortie I2C : Dans le programme : 'LiquidCrystal_I2C_W1.cpp', j'ai remplacé Wire par Wire1 (Sauf dans la ligne : #include "Wire.h").

             +--------------------------+
             |                          |   I2C               +-----------------+         +-----------------+         +-----------------+
             |                          |---[/]-----+---------|     PCA9685     |---------|     PCA9685     |---------|     PCA9685     |
             |                          |---[/]-----|+--------| 8 SERVO + 8 PWM |---------| 16 SORTIES 0/5V |---------| 16 SORTIES 0/5V |
             |     ARDUINO   DUE        |           ||        +-----------------+         +-----------------+         +-----------------+
             |                          |           ||          |   |     |   |               |||||||||||                 |||||||||||
             |                          |           ||         [o] [o]   (/) (/)              ooooooooooo                 ooooooooooo
             |                I2C_1  JLF|           ||
             +--------------------------+           ||        +-----------------+         +-----------------+         +-----------------+
                |            |  ||                  +|--------|    MCP23017     |---------|    MCP23017     |---------|    MCP23017     |
                |            |  ||                  |+--------| 16 ENTREES 0/5V |---------| 16 ENTREES 0/5V |---------| 16 ENTREES 0/5V |
                |            | [//]    +---------+  ||        +-----------------+         +-----------------+         +-----------------+
                |            |  ||     | EEPROM  |--+|            |||||||||||                 |||||||||||                 |||||||||||
                |            |  ||     | AT24C04 |--|+            +++++++++++                 +++++++++++                 +++++++++++
          +------------+     |  ||     +---------+  ||
          | SIMULATEUR |     |  ||
          |   SUR PC   |     | +---------------------------+                                      Adresses I2C
          +------------+     | | ECRAN LCD 2*16 CARACTERES |                                0x20, 0x21, 0x22 : MCP23017
                             | +---------------------------+                                0x27             : LCD
                             |                                                              0x40, 0x41, 0x42 : PCA9685
                            +-------------------------+                                     0x50             : AT24C04C
                            | (1) (2) (3) (4) (5) (6) |  Clavier de 6 Touches de dialogue.
                            +-------------------------+

Broches :

                 +-------------------------------+
                 |       ARDUINO  DUE            |
                 | NC                       SLC1 |--------SLC1 --> Vers écran LCD, deuxième bus I2C
                 | IOREF                    SDA1 |--------SDA1
             ----| RST                           |
             ----| 3,3V                          |
                 | 5V                            |
             ----| GDN                           |
             ----| GDN                           |
                 | VIN                       TX3 |--------- KVB
                 |                           RX3 |---------
                 |                               |
                 |                               |
                 |                           SDA |---------
                 |                           SLC |---------
                 |                           TX1 |
    6 Boutons----| A11                       RX1 |
    Lecture      |                               |
    analogique   |                               |
                 +-------------------------------+
                   | | | | | | | | |
                   | | | | | | | | +-Bouton petit boitier : Arrêt d'envoi des touches au PC
                   | | | | | | | +-- Bouton petit boitier
                   | | | | | | +---- Bouton petit boitier
                   | | | | | +------ Bouton petit boitier : Demande Controle Général
                   | | | | |
                   | | | | +----- Lecture du signal d'interruption des MCP23017
                   | | | |
                   | | | +----  Encodeur rotatif - S1
                   | | +------  Encodeur rotatif - S2
                   | +--------  Encodeur rotatif - SWITCH
                   +----------  Led rouge ANOMALIE

Sources : Gestion du bouton rotatif : Jérôme TOMSKI : https://passionelectronique.fr/encodeur-rotatif-incremental-mecanique
*/


// Fonctions désactivables par l'utilisateur, si le #define est mis en commentaires = //#define ....
#define FONCTION_KVB                // Permet les échanges de données par la liaison série n°3 avec le KVB.
// #define FONCTION_JOYSTICK        // Permet d'émuler un Joystick 7 axes et 32 boutons, et aussi de lire les entrées CAN.
//---------------------------------------------------------------------------
#ifdef FONCTION_JOYSTICK            // Compilation conditionnelle.
  // On peut déclarer plusieurs Joysticks, mais on ne peut en utiliser qu'un dans l'interface 'TS Classic Raildriver and Joystick Interface' avec 'RailsWorks Classic'. 7 axes maximum.
  #include <Joystick.h>               // Pour émuler un Joystick sous Windows (V2.1.1). URL : https://github.com/MHeironimus/ArduinoJoystickLibrary
  //                                                                 32 boutons, 0, Axe-X, Axe-Y, Axe-Z, Rot-X, Rot-Y, Rot-Z, Palonnier,  Manette des gaz, false, Frein, false);
  Joystick_ Joystick_1(JOYSTICK_DEFAULT_REPORT_ID,   JOYSTICK_TYPE_JOYSTICK, 32, 0, true,  true,  true,  true,  true,  true,  true,       true,            false, true,  false);
#endif
#include "stdlib.h"
#include "Wire.h"                   // Pour écran LCD 1602 avec module I2C pour débug.
#include <MCP23017.h>               // Pour le module I2C d'entrées. Librairie de Rob Tillaart (V0.8.1)             URL: https://github.com/RobTillaart/MCP23017_RT
#include <PCA9685.h>                // Pour le module I2C de sorties servo + pwm PCA9685_RT de Rob Tillaart (V0.7.1)URL : https://github.com/RobTillaart/PCA9685_RT
#include <I2C_eeprom.h>             // Pour le module I2C eeprom de Rob Tillaart (V1.9.2)                           URL : https://github.com/RobTillaart/I2C_EEPROM
#include <Keyboard.h>               // Pour émuler un clavier.
#include "LiquidCrystal_I2C_W1.h"   // Librairie en fichiers locaux pour le second port I2C. J'ai modifié ces fichiers !!! Frank de Bradander (V1.1.2). SDA1+SCL1 = I2C1. https://github.com/fdebrabander/Arduino-LiquidCrystal-I2C-library

// Constantes modifiables par l'utilisateur.
const long duree_touche_50        =   50; // Durée en msec avant relâchement d'une touche : Keyboard.release('x').
const long duree_touche_100       =  100; // Durée en msec avant relâchement d'une touche : Keyboard.release('x').
const long duree_touche_200       =  200; // Durée en msec avant relâchement d'une touche : Keyboard.release('x').
const long duree_touche_300       =  300; // Durée en msec avant relâchement d'une touche : Keyboard.release('x').
const long duree_touche_400       =  400; // Durée en msec avant relâchement d'une touche : Keyboard.release('x').
const long duree_ic2_in_comp_ref  = 3000; // Compare les valeurs des positions des interrupteurs entre le pupitre et le simu, toutes les xxx msec.
//---------------------------------------------------------------------------
#define pin_led_en_vie_boit    35   // N° de broche de l'Arduino. Boitier de commande, led clignotante quand le programme tourne.
#define pin_boitier_int_0      37   // N° de broche de l'Arduino. Boitier de commande, interrupteur 0.
#define pin_boitier_bp_1       43   // N° de broche de l'Arduino. Boitier de commande, bouton poussoir 1.
#define pin_boitier_bp_2       41   // N° de broche de l'Arduino. Boitier de commande, bouton poussoir 2.
#define pin_boitier_bp_3       39   // N° de broche de l'Arduino. Boitier de commande, bouton poussoir 3.
#define pin_interrupt_MCP      45   // N° de broche de l'Arduino. Lecture du signal d'interruption 'ITA' des MCP23017.
#define pin_lcd_led_rouge      47   // N° de broche de l'Arduino. Sortie digital pour allumer la led rouge "Erreur". 0 Volt = led allumée.
#define pin_commutateur_rot_S1 49   // N° de broche de l'Arduino connectée à la ligne S1 du module KY-040, commutateur rotatif.
#define pin_commutateur_rot_S2 51   // N° de broche de l'Arduino connectée à la ligne S2 du module KY-040, commutateur rotatif.
#define pin_commutateur_rot_SW 53   // N° de broche de l'Arduino connectée à la ligne SW du module KY-040, commutateur rotatif.
#define pin_led_en_vie         50   // N° de broche de l'Arduino connectée à une led clignotante quand le programme tourne.
#define pin_led_car_envoi      52   // N° de broche de l'Arduino connectée à une led active lors d'envoi de touche.
#define pin_lcd_clavier_broche 11   // N° de broche de l'Arduino. Entrée analogique ADC11 pour lecture des boutons du boitier de commande, en mode analogique.
// Pour la 7200 de SimExpress
#define pin_regul_broche        0   // N° de broche de l'Arduino. Entrée analogique ADC00 pour lecture du potentiomètre de régulation, en mode analogique.
#define pin_ltrac_broche        1   // N° de broche de l'Arduino. Entrée analogique ADC01 pour lecture du potentiomètre du levier de traction VI, en mode analogique.
#define pin_eg_vit_broche       2   // N° de broche de l'Arduino. Entrée analogique ADC02 pour lecture du potentiomètre de la vitesse de l'essuie-glaces, en mode analogique.

LiquidCrystal_I2C LCD(0x27, 16, 2); // Ecran LCD 1602 avec module I2C pour débug. Ecran LCD type 16 car. x 2 lignes. Adresse I2C = 0x27.
MCP23017   MCP23017_1(0x20);        // Module MCP23017 pour les 16 Sorties. Adresse I2C = 0x20.
MCP23017   MCP23017_2(0x21);        // Module MCP23017 pour les 16 Sorties. Adresse I2C = 0x21.
MCP23017   MCP23017_3(0x22);        // Module MCP23017 pour les 16 Sorties. Adresse I2C = 0x22.
PCA9685    PCA_spwm(0x40);          // Module PCA9685 pour les 8 servomoteurs et les 8 sorties pwm. Adresse : 0x40.
PCA9685    PCA_out1(0x41);          // Module PCA9685 pour les 16 sorties.  Adresse I2C = 0x41.
PCA9685    PCA_out2(0x42);          // Module PCA9685 pour les 16 sorties.  Adresse I2C = 0x42.
I2C_eeprom EEPROM_24C04(0x50, I2C_DEVICESIZE_24LC04);  // Module eeprom 24C04, 512 octets. Adresse : 0x50.

int          x, y;                  // Diverses variables locales de type ENTIER   16 bits.
int          i, j, k, l;            // Diverses variables locales de type ENTIER   16 bits.
unsigned int m;                     // Diverses variables locales de type ENTIER NON SIGNE 16 bits.
float        f;                     // Diverses variables locales de type FLOTTANT 32 bits.

// Variables pour les servomoteurs.
const int i2c_srv_nbmax = 8;        // Nombre maximum de servomoteurs.
int   numero_srv;                   // Numéro de servo en cours de traitement.
int   i2c_srv_inv;                  // Course inversée x 8 bits.
int   i2c_srv_maj;                  // Si bit(x) = 1 : La valeur reçue du PC a bougé => Demande de mise à jour de la carte externe.
int   i2c_srv_sim;
int   i2c_srv_par;                  // Si bit(x) = 1 : Paramétrage en cours sur un élément.
int   i2c_srv_min_x;                // Valeur en cours de traitement.
int   i2c_srv_max_x;                // Valeur en cours de traitement.
int   i2c_srv_moy_x;                // Valeur en cours de traitement. Format 'integer' pour les calculs signés, bien que la valeur = 0 à 255.
int   i2c_srv_val[i2c_srv_nbmax];   // 0 à 255 : Valeur brute reçue du PC.
int   i2c_srv_val_old[i2c_srv_nbmax];// 0 à 255. Ancienne valeur brute reçue du PC, si elle a bougé.
int   i2c_srv_min[i2c_srv_nbmax];   // 179, 332 ==>  +700, +1300 µs : Paramétrage pour la course maximum du servomoteur.
int   i2c_srv_max[i2c_srv_nbmax];   // 434, 588 ==> +1700, +2300 µs : Paramétrage pour la course minimum   du servomoteur.
int   i2c_srv_moy[i2c_srv_nbmax];   // -51, +51 ==>  -200,  +200 µs : Paramétrage pour la course moyenne du servomoteur.

// Variables pour les galvanomètres.
const int i2c_pwm_nbmax = 8;        // Nombre maximum de sorties pwm.
int   numero_pwm;                   // Numéro de pwm en cours de traitement.
int   i2c_pwm_inv;                  // Impulsion inversée x 8 bits.
int   i2c_pwm_maj;                  // Si bit(x) = 1 : La valeur reçue du PC a bougé, demande de mise à jour de la carte externe.
int   i2c_pwm_par;                  // Si bit(x) = 1 : Paramétrage en cours sur un élément.
int   i2c_pwm_sim;                  // Si bit(x) = 1 : Paramétrage en cours sur un élément, mise à jour de la carte externe avec la valeur reçue du PC.
int   i2c_pwm_val[i2c_pwm_nbmax];   // 0 à 255 : Valeur brute reçue du PC.
int   i2c_pwm_val_old[i2c_pwm_nbmax];// 0 à 255. Ancienne valeur brute reçue du PC, si elle a bougé.
int   i2c_pwm_ech[i2c_pwm_nbmax];   // Echelle, 63 à 255. Paramétrage pour un gain de 0,5 à 2,0.

// Variables des sorties tout ou rien.
const int i2c_out_nbmax = 16;       // Carte 1, 2 et 3 : Nombre de sortie 'tout ou rien' utilisées.
const int out1 = 1;
const int out2 = 2;
int       numero_out;               // Numéro de sortie tout ou rien en cours de traitement.
unsigned int   i2c_out1_maj;        // Si bit(x) = 1 : La valeur reçue du PC a bougé, demande de mise à jour de la carte externe.
unsigned int   i2c_out1_val;        // Valeur brute reçue du PC. 1 bit par sortie.
unsigned int   i2c_out1_val_old;    // Ancienne valeur brute reçue du PC, si elle a bougé. 1 bit par sortie.
unsigned int   i2c_out2_maj;        //
unsigned int   i2c_out2_val;        //
unsigned int   i2c_out2_val_old;    //
//unsigned int   i2c_out3_maj;      // Utilisé si la carte n° 3 est installée.
//unsigned int   i2c_out3_val;      // Attention, si elle est en place, il faut re-vérifier tout le code.
//unsigned int   i2c_out3_val_old;  //

// Variables des entrées numériques, pour émuler un clavier, et envoyer des codes de touche au PC.
const int      i2c_in_nbmax = 16;   // Nombre maximum d'entrées numériques
const int in1 = 1;
const int in2 = 2;
const int in3 = 3;
int            numero_in;           // Numéro d'entrées en cours de traitement.
unsigned int   i2c_in1_maj,     i2c_in2_maj,     i2c_in3_maj;     // Si bit(x) = 1 : La valeur d'entrée a bougé.
unsigned int   i2c_in1_maj_sim, i2c_in2_maj_sim, i2c_in3_maj_sim; // Si bit(x) = 1 : La valeur d'entrée a bougé sur le simu.
unsigned int   i2c_in1_val,     i2c_in2_val,     i2c_in3_val;     // Si bit(x) = 1 : L'entrée est activée.
unsigned int   i2c_in1_val_old, i2c_in2_val_old, i2c_in3_val_old; //
unsigned int   i2c_in1_val_ref, i2c_in2_val_ref, i2c_in3_val_ref; // Valeur de référence envoyée par le PC, mis à jour une fois toutes les xx msec.
unsigned int   i2c_in1_val_sim, i2c_in2_val_sim, i2c_in3_val_sim; // Valeur de référence envoyée par le PC.
unsigned long  ic2_in_comp_ref_milli;               // Pour renvoyer les interrupteurs en mauvaise position par rapport au simulateur.

// Gestion de la file d'envoi de code de touche.
const int    touche_nb_max = 70;           // Taille file d'attente d'envoi des codes de touche émulation clavier.
const int    touche_etat_demande      = 1; // Valeur de touche_etat[]. Etat = Demande d'envoi faite.
const int    touche_etat_p_en_cours   = 2; // Etat = Keyboard.Pressed().
const int    touche_etat_lib_en_cours = 3; // Etat =
const int    touche_etat_fait         = 0; // Etat = Touche envoyée.
const unsigned int NORMAL  = 0;            // Pour la file d'attente d'envoi de code de touche. NORMAL, SHIFT, CTRL.
const unsigned int PRESS   = 0;            // Quand on ne veut que envoyer que l'appui d'une touche.
const unsigned int RELEASE = 1;            // Quand on ne veut que envoyer que la fin d'appui d'une touche.
int           touche_num_libre;            // Dernier indice utilisé.
int           touche_num_en_cours;         // Indice en cours d'envoi.
unsigned long touche_milli_en_cours;       // Tempo de la touche en cours d'envoi.
unsigned int  touche_shift[touche_nb_max]; // Touche à envoyer : Normal = 0, Shift, Ctr.
unsigned int  touche_code[touche_nb_max];  // Touche à envoyer : Code de la touche = 'a', '1', 124, 96,,,
unsigned int  touche_milli[touche_nb_max]; // Touche à envoyer : Délai avant le release = 50, 100, 200, 400,,,
unsigned int  touche_etat[touche_nb_max];  // Touche à envoyer : Demande, Traitement "Press" en cours, Traitement "Release" en cours, fait.

// Divers
int   maj_forcee;                          // Si = 1 : Mise à jour forcée des sorties vers les cartes. Le PC peut envoyer un code pour forcer la mise à jour.
int   offset_eeprom;                       // Variable pour pointer une valeur en eeprom.
int   led_car_envoi_val;                   // = 1 quand des touches sont en cours d'envoi.
int   led_en_vie_cpt;                      // = 0 à n, compteur.
int   led_en_vie_val;                      // = 0/1 led clignotante.

// Partie écran LCD.
const int tx_erreur_nbocc =  7;            // Nombre de texte d'erreur en mémoire.
const int tx_erreur_nbcar = 17;            // Nombre de caractère + 1 par texte. LCD = 16 caractères x 2 lignes.
char  erreur_texte1[tx_erreur_nbocc][tx_erreur_nbcar]; // Tableau du texte des erreurs affichées sur l'écran LCD.
char  erreur_texte2[tx_erreur_nbocc][tx_erreur_nbcar]; // Tableau du texte des erreurs affichées sur l'écran LCD.
int   erreur_valeur[tx_erreur_nbocc];      // Valeur de l'erreur. 0 = pas d'erreur.
int   lcd_menu1;                           // 0 à x, : Numéro du menu principal affiché sur l'écran LCD.
int   lcd_menu1_flag;                      // 0 ou 1 : Si = 1 => Premier passage et l'on doit afficher le texte complet sur l'écran LCD.
int   lcd_menu2;                           // 0 à x, : Numéro du sous-menu affiché sur l'écran LCD.
const int lcd_menu_nbocc = 7;              // Nombre de menu.
const int lcd_menu_nbcar = 17;             // Nombre de caractère + 1 par texte.
char  lcd_menu1_txt[lcd_menu_nbocc][lcd_menu_nbcar]; // Tableau du texte des menus affichés sur l'écran LCD.
char  lcd_menu2_txt[lcd_menu_nbocc][lcd_menu_nbcar]; // Tableau du texte des menus affichés sur l'écran LCD.
char  lcd_buffer[20];                      // Tableau temporaire de texte.
char  lcd_buffer_f[20];                    // Tableau temporaire de texte.
int   lcd_clavier_val;                     // 0 à 1023 : Valeur lue sur l'entrée analogique, pour la série de boutons de l'écran LCD.
int   lcd_trigger;                         // Pour laisser le temps au signal de se stabiliser.
int   lcd_trigger_nb;                      // Pour laisser le temps au signal de se stabiliser.
int   lcd_clavier_touche;                  // N° de touche appuyée, sur l'entrée analogique.
int   lcd_clavier_touche_old;              // Ancien N° de touche appuyée, sur l'entrée analogique.
int   lcd_clavier_touche2[5];              // tableau pour l'anti rebond.
int   lcd_aff_val_bouge;                   // Si l'ancienne valeur a bougé, on l'affiche sur l'écran lcd.
int   lcd_aff_val_simu;                    // Pour afficher une valeur brute du simu sur l'écran lcd.
int   lcd_present;                         // Pour savoir si l'écran LCD est bien branché.
const int lcd_clavier_touche_rien    = 0;  // Conversion après lecture du code de touche du boitier de configuration.
const int lcd_clavier_touche_abraz   = 1;
const int lcd_clavier_touche_valsim  = 2;
const int lcd_clavier_touche_suivant = 3;
const int lcd_clavier_touche_valide  = 4;
const int lcd_clavier_touche_ok      = 5;
const int lcd_clavier_touche_ruf     = 6;

// Encodeur rotatif.
int   enc_rot_etatActuelS1;                // Signal de l'encodeur rotatif.
int   enc_rot_etatActuelS2;                // Signal de l'encodeur rotatif.
int   enc_rot_etatActuelSW;                // Signal de l'encodeur rotatif (Bouton poussoir).
int   enc_rot_etatPrecedentSW;             // Cette variable nous permettra de stocker le dernier état de la ligne SW, afin de le comparer à l'actuel
int   enc_rot_etatPrecedentS1;             // Cette variable nous permettra de stocker le dernier état de la ligne CLK, afin de le comparer à l'actuel
int   enc_rot_etatPrecedentS2;             // Cette variable nous permettra de stocker le dernier état de la ligne DT, afin de le comparer à l'actuel
int   enc_rot_compteur;                    // Cette variable nous permettra de compter combien de crans ont été parcourus, sur l'encodeur
                                           // (sachant que nous compterons dans le sens horaire, et décompterons dans le sens antihoraire)
int   enc_rot_positif;                     // = 1 si l'on a tourné le bouton dans le sens '+'. Sinon = 0.
int   enc_rot_modif;                       // = 1 si l'on tourné le bouton, ou appuyé dessus.

// Boitier de commande.
int      bp_cpt;                           // Compteur pour ne faire l'acquisition qu'une fois sur trente = Toutes les msec.
unsigned int_0_cpt;                        // 16 derniers états de l'interrupteur 0.
unsigned bp_1_cpt;                         // 16 derniers états du bouton poussoir 1.
unsigned bp_2_cpt;                         // 16 derniers états du bouton poussoir 1.
unsigned bp_3_cpt;                         // 16 derniers états du bouton poussoir 2.
int      int_0_val, bp_1_val, bp_2_val, bp_3_val; // 0/1 : Etat des boutons 1, 2, 3 et de l'interrupteur 0.

int   mult_391_in;                         // Servomoteur : Pour passer de la valeur brute (0-255) vers la plage 1000 - 2000 µs.
int   mult_391_out;                        // Il faut multiplier par 3,91.
int   mult_391_temp;                       // On utilise une routine avec décalages pour faire un calcul plus rapide.

unsigned long milli_actuel;                // Pour afficher le temps d'exécution de la boucle principale, sur l'écran lcd.
unsigned long milli_old;
unsigned long milli_affiche;
int           milli_cpt;

// Variables globales pour les sous-programmes : 'Data_Recues_du_PC_TSCRJI.ino' et 'Data_Envoyees_vers_PC_TSCRJI'.
byte    buffer_rx_cpt;                     // Compteur de n° du caractère courant.
byte    buffer_rx_buf;                     // Compteur de n° du buffer courant.
char    car_lu;                            // Caractère lu.
char    buffer_rx[3][80];                  // 3 Buffers de réception des caractères reçus.
int     buffer_rx_valeur;                  // Conversion du dernier champ : Ascii-> Entier.
float   buffer_rx_fvaleur;                 // Conversion du dernier champ : Ascii-> Flottant.
boolean debut_rx;                          // Flag de début de réception,  true = indicateur de début de trame reçu.
boolean final_rx;                          // Flag de fin réception,       true = indicateur de fin de trame reçu.

// Variables gobales pour le KVB.
//     Afficheurs : [888][888]     (V) (FU)      (LSSF)
//     Lampes :     [VAL] [MV] [FC] [    ]   [  ]
//     Boutons :    [VAL] [MV] [FC] [TEST]   [SF]
//                                (SOL) (ENG)
//     Roues Cod. : [VD VU]    [VU]    |DC DD DU]    Centaines, Dizaines, Unités + Bouton [VO-ME-MA]
char KVB_car_vers_KVB;                     // Caractère reçu du PC à renvoyer au KVB.
char roues_codeuses[12];                   // Stocke les n° des roues codeuses/
int  roues_codeuses_cpt;

// Joystick, pour envoyer des grandeurs analogiques.
const int joystick_1_nb_max = 7;           // Pour le moment, on arrive à émuler un joystick à 7 axes et 32 boutons.
int  joystick_1[joystick_1_nb_max];
int  joystick_1_old[joystick_1_nb_max];
int  joystick_cpt;                         // Numéro de joystick en cours de traitement.
int  joystick_maj;                         // 1 = Demande de mise à jour vers le PC.

// Pour la 7200 de Julien
int  boite_a_picot_on;                     // Pour allumer toutes les lampes.
// Pour la 7200 de SimExpress
unsigned long lect_can_milli;              // Delais de lecture des entrées analogiques.
int  regul_val,  regul_val_1023,  regul_val_ref,  regul_val_sim,  regul_val_maj;             // Cerclo
int  ltrac_val,  ltrac_val_1023,  ltrac_val_ref,  ltrac_val_sim,  ltrac_val_maj, ltrac_ver ; // Levier de traction. Pour vérifier que l'on a relâché le levier de traction.
int  eg_vit_val, eg_vit_val_1023, eg_vit_val_ref, eg_vit_val_sim, eg_vit_val_maj;            // Vitesse essuie-glaces.

// ================================================================================================================================
void setup()
{
boite_a_picot_on = 0;
// Pour la 7200SimExpress
regul_val = 0; regul_val_1023 = 0; regul_val_ref = 0; regul_val_sim = 0; regul_val_maj = 0; lect_can_milli = 0;
ltrac_val = 0; ltrac_val_1023 = 0; ltrac_val_ref = 0; ltrac_val_sim = 0; ltrac_val_maj = 0; ltrac_ver   = 0;
eg_vit_val = 0; eg_vit_val_1023 =0;  eg_vit_val_ref = 0; eg_vit_val_sim = 0; eg_vit_val_maj = 0;;            // Vitesse essuie-glaces.

// ------------------------------------------------------------
// Emulation Joystick
#ifdef FONCTION_JOYSTICK                         // Compilation conditionnelle.
    Joystick_1.setXAxisRange(0, 31);             // Echelle pour les 7 axes.
    Joystick_1.setYAxisRange(0, 31);
    Joystick_1.setZAxisRange(0, 31);
    Joystick_1.setRxAxisRange(0, 31);
    Joystick_1.setRyAxisRange(0, 31);
    Joystick_1.setRzAxisRange(0, 31);
    Joystick_1.setThrottleRange(0, 31);
    Joystick_1.begin(false);                     // Pas d'envoi automatique, il faudra ajouter la ligne 'Joystick.sendState();' pour envoyer la position du Joystick.
    joystick_cpt = 0;                            // Compteur 0 à 6, pour ne traiter qu'un Joystick à la fois, à chaque passage.
    joystick_maj = 0;
    Joystick_1.setXAxis(0);
    Joystick_1.setYAxis(0);
    Joystick_1.setZAxis(0);
    Joystick_1.sendState();
#endif
// Petite pause pour laisser le temps aux signaux de se mettre en place.
  delay(100);

  for (x=0; x < tx_erreur_nbocc ; x++) erreur_valeur[x] = 0;

  pinMode(pin_boitier_int_0, INPUT_PULLUP);         // Résistance de rappel.
  pinMode(pin_boitier_bp_1,  INPUT_PULLUP);         // Résistance de rappel.
  pinMode(pin_boitier_bp_2,  INPUT_PULLUP);         // Résistance de rappel.
  pinMode(pin_boitier_bp_3,  INPUT_PULLUP);         // Résistance de rappel.

// A la mise sous tension, initialise l'écran LCD 1602 avec module I2C. Routine spéciale pour la deuxième ligne IC2.
  pinMode(pin_commutateur_rot_SW, INPUT);
  pinMode(pin_commutateur_rot_S1, INPUT);
  pinMode(pin_commutateur_rot_S2, INPUT);
  pinMode(pin_lcd_led_rouge,      OUTPUT);
  pinMode(pin_led_en_vie,         OUTPUT);
  pinMode(pin_led_en_vie_boit,    OUTPUT);
  pinMode(pin_led_car_envoi,      OUTPUT);
  pinMode(pin_interrupt_MCP, INPUT_PULLUP);      // La sortie des MCP23017 est à collecteur ouvert.
  digitalWrite(pin_lcd_led_rouge, LOW);            // Eteint la led rouge "Erreur".

// Mémorisation des valeurs initiales des lignes SW/CLK/DT, au démarrage du programme.
  enc_rot_compteur = 0;
  enc_rot_positif  = 0;
  enc_rot_etatPrecedentSW = digitalRead(pin_commutateur_rot_SW);
  enc_rot_etatPrecedentS1 = digitalRead(pin_commutateur_rot_S1);
  enc_rot_etatPrecedentS2 = digitalRead(pin_commutateur_rot_S2);

  Wire.begin();                                             // Broches SDA + SCL.
// ------------------------------------------------------------
// Lecture eeprom. on lit l'eeprom en premier, pour savoir si les sorties pwm sont inversées.
  i2c_srv_inv = 0x0000; // Initialisation des valeurs avant lecture en eeprom.
  i2c_pwm_inv = 0x0000;
  for (x=0; x < i2c_srv_nbmax; x++) { i2c_srv_max[i] = 510; i2c_srv_min[i] = 255;i2c_srv_moy[i] = 0; }
  for (x=0; x < i2c_pwm_nbmax; x++) { i2c_pwm_ech[i] = 128; }

  EEPROM_24C04.begin();
  if (! EEPROM_24C04.isConnected())  {                      // Module EEPROM AT24C04.
    erreur_valeur[4] = 1;                                   // En cas d'erreur, affichera le message d'erreur : "MODULE  EEPROM".
    digitalWrite(pin_lcd_led_rouge, HIGH);                  // et allumera la led rouge "Erreur".
  }
  init_eeprom();                                            // Vérifie les valeurs enregistrées en eeprom au démarrage, et si l'eeprom est vierge, écriture des valeurs par défaut.
  i = EEPROM_24C04.readByte(0); j = EEPROM_24C04.readByte(1); k = EEPROM_24C04.readByte(2); l = EEPROM_24C04.readByte(3);
  if (i != 0xAA || j != 0x55 || k != 0xF0 || l != 0x0F) {   // Au début de l'eeprom, on doit avoir = 'AA55F00F'. Sinon, l'eeprom ne s'est pas correctement initialisée.
    erreur_valeur[0] = 1;                                   // En cas, affichera le message d'erreur : "ERR INIT  EEPROM".
    digitalWrite(pin_lcd_led_rouge, HIGH);                  // et allumera la led rouge "Erreur".
  }
// Lecture des valeurs des servomoteur et galvanomètres en eeprom.
  lire_eeprom();                                            // Lit les valeurs en eeprom au démarrage, pour remplir les tableaux en mémoire.
// ------------------------------------------------------------
// Définition des E/S du MCP23017 en entrée.
// Cela DOIT précéder l'initialisation du MCP23017 qui suit, utilisant la fonction begin (Ceci est spécifique à la librairie "MCP23017.h").
  if (MCP23017_1.begin() == 0) {                            // Module MCP23017 '1' pour les 16 entrées.
    erreur_valeur[3] = 1;                                   // En cas d'erreur, affichera le message d'erreur : "MODULE  MCP23017".
    strncpy(erreur_texte2[3],"1:ENTREES ABSENT",tx_erreur_nbcar);
    digitalWrite(pin_lcd_led_rouge, HIGH);                  // Allume la led rouge "Erreur".
  }
  if (MCP23017_2.begin() == 0) {                            // Module MCP23017 '2' pour les 16 entrées.
    erreur_valeur[3] = 1;                                   // En cas d'erreur, affichera le message d'erreur : "MODULE  MCP23017".
    strncpy(erreur_texte2[3],"2:ENTREES ABSENT",tx_erreur_nbcar);
    digitalWrite(pin_lcd_led_rouge, HIGH);                       // Allume la led rouge "Erreur".
  }
  if (MCP23017_3.begin() == 0) {                            // Module MCP23017 '3' pour les 16 entrées.
    erreur_valeur[3] = 1;                                   // En cas d'erreur, affichera le message d'erreur : "MODULE  MCP23017".
    strncpy(erreur_texte2[3],"3:ENTREES ABSENT",tx_erreur_nbcar);
    digitalWrite(pin_lcd_led_rouge, HIGH);                  // Allume la led rouge "Erreur".
  }
  // ------------------------------------------------------------
  MCP23017_1.pinMode16(0xFFFF);      // Module MCP configuré en 16 entrées. (0 = output , 1 = input).
  MCP23017_1.setPullup16(0x0000);    // Module MCP configuré sans les résistances de pull-up, elles sont sur le circuit imprimé.
  MCP23017_1.setPolarity16(0xFFFF);  // Module MCP configuré avec inversion de polarité en entrée.
  MCP23017_1.enableControlRegister(MCP23x17_IOCR_MIRROR | MCP23x17_IOCR_ODR);  // Module MCP configuré INT unique et open drain.
  MCP23017_1.enableInterrupt16(0xFFFF, CHANGE);

  MCP23017_2.pinMode16(0xFFFF);      // Module MCP configuré en 16 entrées. (0 = output , 1 = input).
  MCP23017_2.setPullup16(0x0000);    // Module MCP configuré sans les résistances de pull-up.
  MCP23017_2.setPolarity16(0xFFFF);  // Module MCP configuré avec inversion de polarité en entrée, elles sont sur le circuit imprimé.
  MCP23017_2.enableControlRegister(MCP23x17_IOCR_MIRROR | MCP23x17_IOCR_ODR);  // Module MCP configuré INT unique et open drain.
  MCP23017_2.enableInterrupt16(0xFFFF, CHANGE);

  MCP23017_3.pinMode16(0xFFFF);      // Module MCP configuré en 16 entrées. (0 = output , 1 = input).
  MCP23017_3.setPullup16(0x0000);    // Module MCP configuré sans les résistances de pull-up.
  MCP23017_3.setPolarity16(0xFFFF);  // Module MCP configuré avec inversion de polarité en entrée, elles sont sur le circuit imprimé.
  MCP23017_3.enableControlRegister(MCP23x17_IOCR_MIRROR | MCP23x17_IOCR_ODR);  // Module MCP configuré INT unique et open drain.
  MCP23017_3.enableInterrupt16(0xFFFF, CHANGE);
// ------------------------------------------------------------
  if (PCA_spwm.begin() == 0) {                                 // Module PCA9685 pour les 8 servomoteurs et les 8 sorties pwm.
    erreur_valeur[2] = 1;                                      // En cas d'erreur, affichera le message d'erreur : "MODULE  PCA9685 ".
    strncpy(erreur_texte2[2],"SERVO/PWM ABSENT",tx_erreur_nbcar);
    digitalWrite(pin_lcd_led_rouge, HIGH);                     // Allume la led rouge "Erreur".
  }
  PCA_spwm.setFrequency(62, 0);                                // Pour 62 Hz en sortie, le Prescaler sera configuré à 97.
  for (x = 0; x < i2c_pwm_nbmax; x++ ) {                       // Initialisation, pour ne pas avoir une impulsion sur les cadrans.
    if (bitRead(i2c_pwm_inv, x) == 1) { PCA_spwm.setPWM(i2c_srv_nbmax + x, 4095);} // Impossible de mettre ce circuit en haute impédance.
    else                              { PCA_spwm.setPWM(i2c_srv_nbmax + x,    0);}
  }
// ------------------------------
  if (PCA_out1.begin() == 0) {                                 // Module PCA9685 '1' pour les 16 sorties.
    erreur_valeur[2] = 1;                                      // En cas d'erreur, affichera le message d'erreur : "MODULE  PCA9685 ".
    strncpy(erreur_texte2[2],"  OUT1  ABSENT  ",tx_erreur_nbcar);
    digitalWrite(pin_lcd_led_rouge, HIGH);                     // Allume la led rouge "Erreur".
  }
  PCA_out1.setFrequency(62, 0);                                // Pour 62 Hz en sortie, le Prescaler sera configuré à 97.
  for (x=0; x < i2c_out_nbmax; x++ ) PCA_out1.write1(x, HIGH); // Initialise les sorties tout ou rien.
// ------------------------------
  if (PCA_out2.begin() == 0) {                                 // Module PCA9685 '2' pour les 16 sorties.
    erreur_valeur[2] = 1;                                      // En cas d'erreur, affichera le message d'erreur : "MODULE  PCA9685 ".
    strncpy(erreur_texte2[2],"  OUT2  ABSENT  ",tx_erreur_nbcar);
    digitalWrite(pin_lcd_led_rouge, HIGH);                     // Allume la led rouge "Erreur".
  }
  PCA_out2.setFrequency(62, 0);                                // Pour 62 Hz en sortie, le Prescaler sera configuré à 97.
  for (x=0; x < i2c_out_nbmax; x++ ) PCA_out2.write1(x, HIGH); // Initialise les sorties tout ou rien.
  delay(100);
  i = MCP23017_1.read16();   // Lecture pour raz des valeurs en entrée.
  i = MCP23017_2.read16();
  i = MCP23017_3.read16();
  LCD.init();       delay(100);                             // Initialisation de l'afficheur LCD. Adresse I2C = 0x27.
  Wire1.beginTransmission(0x27);                            // 0x27 étant le numéro de l'adresse de l'écran LCD I2C.
  if (Wire1.endTransmission() == 0) lcd_present = 1; else lcd_present = 0;
  if (lcd_present == 1) {                                   // lcd_present == 1 => l'écran LCD est bien connecté.
    LCD.backlight();  delay(100);
    LCD.clear();
    LCD.setCursor(0, 0); LCD.print(" BB 67471 Yohan ");     // Affiche un message provisoire sur l'écran LCD.
    LCD.setCursor(0, 1); LCD.print("ASL26 - JLF 2025");
  }
  Serial.begin(38400);                                      // Vers le PC : 9600 / 19200 / 38400 bps.
#ifdef FONCTION_KVB                                         // Compilation conditionnelle.
    Serial3.begin(9600);                                    // Vers le KVB
#endif
  Keyboard.begin(); delay(100);                             // Pas de clavier "KeyboardLayout_fr_FR" pour le moment.
  Keyboard.releaseAll();
  delay(3000);
  if (lcd_present == 1) LCD.clear();
// ------------------------------------------------------------
// Défini les messages d'erreur de l'écran LCD.
  strncpy(erreur_texte1[0],"ERR INIT  EEPROM",tx_erreur_nbcar);
  strncpy(erreur_texte2[0],"ECRIT.IMPOSSIBLE",tx_erreur_nbcar);
  strncpy(erreur_texte1[1],"EEPROM VIERGE   ",tx_erreur_nbcar);
  strncpy(erreur_texte2[1],"ECRIT VAL DEFAUT",tx_erreur_nbcar);
  strncpy(erreur_texte1[2],"MODULE  PCA9685 ",tx_erreur_nbcar);
//strncpy(erreur_texte2[2],"SERVO/PWM ABSENT",tx_erreur_nbcar); // Ce texte sera écrit entièrement dans le code.
  strncpy(erreur_texte1[3],"MODULE  MCP23017",tx_erreur_nbcar);
//strncpy(erreur_texte2[3],"ENTREES-: ABSENT",tx_erreur_nbcar); // Ce texte sera écrit entièrement dans le code.
  strncpy(erreur_texte1[4],"MODULE EEPROM   ",tx_erreur_nbcar);
  strncpy(erreur_texte2[4]," AT24C04 ABSENT ",tx_erreur_nbcar);
  strncpy(erreur_texte1[5],"Texte libre     ",tx_erreur_nbcar);
  strncpy(erreur_texte2[5],"Texte libre     ",tx_erreur_nbcar);
  strncpy(erreur_texte1[6],"FIN ouPAS ERREUR",tx_erreur_nbcar); // Dernier bloc n° : tx_erreur_nbocc - 1.
  strncpy(erreur_texte2[6],"QUITTE ou RAZ   ",tx_erreur_nbcar);
// Défini les menus affichés sur l'écran LCD.
  strncpy(lcd_menu1_txt[0],"JLF - 15/02/2025",lcd_menu_nbcar);
  strncpy(lcd_menu2_txt[0],"MENU:TOURNER BTN",lcd_menu_nbcar);
  strncpy(lcd_menu1_txt[1],"(1)CONFIG SERVO ",lcd_menu_nbcar);
  strncpy(lcd_menu2_txt[1],"MIN/MAX/MOY/INV ",lcd_menu_nbcar);
  strncpy(lcd_menu1_txt[2],"(2)CONFIG GALVA ",lcd_menu_nbcar);
  strncpy(lcd_menu2_txt[2],"   ECH / INV    ",lcd_menu_nbcar);
  strncpy(lcd_menu1_txt[3],"(3)AFFICHE LES  ",lcd_menu_nbcar);
  strncpy(lcd_menu2_txt[3],"   ERREURS      ",lcd_menu_nbcar);
  strncpy(lcd_menu1_txt[4],"(4)INFORMATIONS ",lcd_menu_nbcar);
  strncpy(lcd_menu2_txt[4],"   SYSTEME      ",lcd_menu_nbcar);
  strncpy(lcd_menu1_txt[5],"(5)AFFICHE VAL. ",lcd_menu_nbcar);
  strncpy(lcd_menu2_txt[5],"RECUES/ENVOYEES ",lcd_menu_nbcar);
  strncpy(lcd_menu1_txt[6],"(6)RAZ EEPROM   ",lcd_menu_nbcar);
  strncpy(lcd_menu2_txt[6],"VAL. PAR DEFAUT?",lcd_menu_nbcar);

// Attention !!! Ne pas dépasser le nombre prévu de menu du tableau : lcd_menu_nbocc.
  lcd_menu1 =         0;
  lcd_menu1_flag =    0;
  lcd_menu2 =         0;
  lcd_aff_val_bouge = 0;
 
  if (lcd_present == 1) LCD.setCursor(0, 0); LCD.print(lcd_menu1_txt[0]); // Affiche le menu d'accueilsur l'écran LCD.
  if (lcd_present == 1) LCD.setCursor(0, 1); LCD.print(lcd_menu2_txt[0]);
  enc_rot_modif    = 0;
  enc_rot_positif  = 0;
  enc_rot_compteur = 0;
  lcd_clavier_touche     = lcd_clavier_touche_rien;
  lcd_clavier_touche_old = lcd_clavier_touche_rien;
  for (i = 0; i < 5; i++) lcd_clavier_touche2[i] = lcd_clavier_touche_rien;
  lcd_trigger = 0;
  lcd_trigger_nb = 0;
  milli_cpt     = 0;
  milli_actuel  = 0;
  milli_old     = 0;
  milli_affiche = 0;

  i2c_srv_par   = 0;
  i2c_srv_maj   = 0;
  i2c_srv_sim   = 0;
  i2c_pwm_par   = 0;
  i2c_pwm_maj   = 0;
  i2c_pwm_sim   = 0;
  k = 0;
  l = 0;

  for (x = 0; x < i2c_srv_nbmax; x++ ) {   // Initialise la valeur brute des servomoteurs.
    i2c_srv_val[x]     = 0;
    i2c_srv_val_old[x] = 0;
  }
  i2c_srv_maj      = 0x00;
  for (x = 0; x < i2c_pwm_nbmax; x++ ) {   // Initialise la valeur brute des sorties pwm.
    i2c_pwm_val[x]     = 0;
    i2c_pwm_val_old[x] = 0;
  }
 
  i2c_out1_val = 0x0000; i2c_out1_val_old = 0x0000; i2c_out1_maj = 0x0000;
  i2c_out2_val = 0x0000; i2c_out2_val_old = 0x0000; i2c_out2_maj = 0x0000;
  // i2c_out3_val = 0x0000; i2c_out3_val_old = 0x0000; i2c_out3_maj = 0x0000; // Si carte n°3 installée.

  i2c_in1_val = 0x0000;     i2c_in1_val_old = 0x0000; i2c_in1_maj     = 0x0000; i2c_in1_maj_sim = 0x0000;
  i2c_in2_val = 0x0000;     i2c_in2_val_old = 0x0000; i2c_in2_maj     = 0x0000; i2c_in2_maj_sim = 0x0000;
  i2c_in3_val = 0x0000;     i2c_in3_val_old = 0x0000; i2c_in3_maj     = 0x0000; i2c_in3_maj_sim = 0x0000;
  i2c_in1_val_ref = 0x0000; i2c_in2_val_ref = 0x0000; i2c_in3_val_ref = 0x0000;
  i2c_in1_val_sim = 0x0000; i2c_in2_val_sim = 0x0000; i2c_in3_val_sim = 0x0000;

// File d'envoi des codes de touche.
  touche_num_libre    = 0; // Dernier indice utilisé.
  touche_num_en_cours = 0; // Prochain indice d'envoi.
  for (x = 0; x < touche_nb_max; x++) touche_etat[x] = touche_etat_fait; // Etat du code de touche à envoyer.

// Boitier de commande
  bp_cpt    = 0;        // Compteur pour ne faire l'acquisition qu'une fois sur vingt cinq. = Toutes les msec.
  int_0_cpt = 0x0000;   // 16 derniers états de l'interrupteur 0.
  bp_1_cpt  = 0x0000;   // 16 derniers états du bouton poussoir 1.
  bp_2_cpt  = 0x0000;   // 16 derniers états du bouton poussoir 1.
  bp_3_cpt  = 0x0000;   // 16 derniers états du bouton poussoir 1.
  int_0_val = 0; bp_1_val = 0; bp_2_val = 0; bp_3_val = 0;   // Etat des boutons 3,2,1 et de l'interrupteur 0.

  ic2_in_comp_ref_milli = 0;
  for (x = 0; x < i2c_out_nbmax; x ++)  PCA_out1.write1(x, HIGH);  // RAZ des valeurs des sorties out1.
  for (x = 0; x < i2c_out_nbmax; x ++)  PCA_out2.write1(x, HIGH);  // RAZ des valeurs des sorties out2.

  lcd_aff_val_simu = 0;
  numero_srv       = 0;
  numero_pwm       = 0;
  numero_in        = 0;
  numero_out       = 0;
  maj_forcee       = 1;  // Force un premier passage de mise à jour de toutes les sorties.

  // Lecture des entrées pour mise à jour des variables.
  //                   MODULE   MCP23017
  //                +---------------------+
  //    Ports       | AAAAAAAA   BBBBBBBB |
  //    N° entrées  | 76543210   01234567 |
  //                +---------------------+
  //  En pratique     00000000   00111111
  //  N° de 0 à 15 :  01234567   89012345
  // Sur le module, on a de gauche à droite les entrées A7 à A0, puis B0 à B7.
  // Dans le code, on remet en ordre les entrées pour avoir les entrées de 0(A7) à 15(B7), de gauche à droite.
  i = MCP23017_1.read16();
  i2c_in1_val = i & 0x00FF;
  i2c_in1_val = i2c_in1_val<<8;
  for (x = 0; x <  8; x++) { bitWrite(i2c_in1_val,  7 - x, bitRead(i, x + 8)); }  // Bits A7-A0 B0-B7 en bonne position dans 'i2c_in1_val', entrées de 0 à 15 de gauche à droite.
  i2c_in1_maj = i2c_in1_val ^ i2c_in1_val_old;
  i2c_in1_val_old  = i2c_in1_val;
  i = MCP23017_2.read16();
  i2c_in2_val = i & 0x00FF;
  i2c_in2_val = i2c_in2_val<<8;
  for (x = 0; x <  8; x++) { bitWrite(i2c_in2_val,  7 - x, bitRead(i, x + 8)); }  // Bits A7-A0 B0-B7 en bonne position dans 'i2c_in1_val', entrées de 0 à 15 de gauche à droite.
  i2c_in2_maj = i2c_in2_val ^ i2c_in2_val_old;
  i2c_in2_val_old  = i2c_in2_val;
  i = MCP23017_3.read16();
  i2c_in3_val = i & 0x00FF;
  i2c_in3_val = i2c_in3_val<<8;
  for (x = 0; x <  8; x++) { bitWrite(i2c_in3_val,  7 - x, bitRead(i, x + 8)); }  // Bits A7-A0 B0-B7 en bonne position dans 'i2c_in1_val', entrées de 0 à 15 de gauche à droite.
  i2c_in3_maj = i2c_in3_val ^ i2c_in3_val_old;
  i2c_in3_val_old  = i2c_in3_val;

// Raz des variables pour le routine de réception des caractères sur la ligne série, envoyés par 'TS Classic Raildriver and Joystick Interface'.
  buffer_rx_cpt = 0;  // Compteur de n° du buffer courant.
  buffer_rx_buf = 0;  // Compteur de n° du caractère courant.
  debut_rx = false;   // Flag de début de réception d'une trame du PC.
  final_rx = false;   // Flag de fin réception d'une trame du PC.

#ifdef FONCTION_KVB                                    // Compilation conditionnelle.
// Raz des variables (Voyants) du KVB.
  KVB_car_vers_KVB = '\0'; // Caractère reçu du PC à renvoyer au KVB.
  if (Serial3.availableForWrite() > 0) Serial3.write('R');     // Caractère 'R' = Initialisation du KVB, en cas de reset de la carte DUE.
  roues_codeuses_cpt=0;
#endif
  led_car_envoi_val  = 0;                  
  led_en_vie_cpt     = 0;
  led_en_vie_val     = 0;
}

// ================================================================================================================================
void loop()
{
//=============================================================================================================================
// /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
//=============================================================================================================================
// RECEPTION DES DONNEES DEPUIS LE PC.
// Traitement des données reçues sur la ligne série, envoyées par le programme 'TS Classic Raildriver and Joystick Interface'.
  Data_Recues_du_PC();   // Appel à la routine 'Data_Recues_du_PC()' dans le fichier 'Data_Recues_du_PC_TSCRJI.ino'.

//-----------------------------------------------------------------------------------------------------------------------------
// KVB : Si l'on a reçu un ordre pour le KVB, on envoie une commande au KVB = 1 octet sur la liaison série n° 3
// Pour le moment pas de gestion à l'envoi du caractère, on reçoit plus lentement les ordres du PC, que l'on envoie de caractère au KVB.
// Sert à allumer les voyants, éclairer les touches, et les deux afficheurs.
#ifdef FONCTION_KVB                                                       // Compilation conditionnelle.
    if (KVB_car_vers_KVB != '\0') {
      if (Serial3.availableForWrite() > 0) Serial3.write(KVB_car_vers_KVB); // Caractère à renvoyer vers le KVB.
      KVB_car_vers_KVB = '\0';                                              // Caractère envoyé.
    }
#endif
/*  Lignes de code pour débug uniquement.
    i  = analogRead(0);           // POUR TEST avec un potentiomètre en A0.
    i2c_pwm_val[0]   = i>>2;      // POUR TEST
    bitWrite(i2c_pwm_maj, 0, 1);
    i2c_pwm_val[1]   = i>>2;      // POUR TEST
    bitWrite(i2c_srv_maj, 1, 1);
    i2c_srv_val[0]   = i>>2;      // POUR TEST
    bitWrite(i2c_srv_maj, 0, 1);
    i2c_srv_val[1]   = i>>2;      // POUR TEST
    bitWrite(i2c_pwm_maj, 1, 1);
    if (i > 512 ) {
      bitWrite(i2c_out1_val,  0, 1) + bitWrite(i2c_out1_maj,  0, 1);   // POUR TEST
      bitWrite(i2c_out2_val, 15, 1) + bitWrite(i2c_out2_maj, 15, 1);
    }
    else {
      bitWrite(i2c_out1_val,  0, 0) + bitWrite(i2c_out1_maj,  0, 1);   // POUR TEST
      bitWrite(i2c_out2_val, 15, 0) + bitWrite(i2c_out2_maj, 15, 1);
    }
    if   (bitRead(i2c_in1_maj, 1) == 1) {
      if (bitRead(i2c_in1_val, 1) == 1) bitWrite(i2c_out1_val, 1, 1); // Voyant n° out2/15.
      else                               bitWrite(i2c_out1_val, 1, 0); // Voyant n° out2/15.
                                         bitWrite(i2c_out1_maj, 1, 1);
    }
    if   (bitRead(i2c_in1_maj, 2) == 1) {
      if (bitRead(i2c_in1_val, 2) == 1) bitWrite(i2c_out1_val, 2, 1); // Voyant n° out2/15.
      else                               bitWrite(i2c_out1_val, 2, 0); // Voyant n° out2/15.
                                         bitWrite(i2c_out1_maj, 2, 1);
    }
    i2c_in1_maj = 0;*/

//=============================================================================================================================
// /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
//=============================================================================================================================
// EMISSION DES DONNEES VERS LE PC.
// Traitement des données à envoyer sur la ligne série, envoyées au programme Railsworks su PC.
  Data_Envoyees_vers_PC();   // Appel à la routine 'Data_Envoyees_vers_PC()' dans le fichier 'Data_Envoyees_vers_PC_TSCRJI.ino'.
//=============================================================================================================================
// /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
//=============================================================================================================================
// Traitement des données reçues et élaboration des données à envoyer.
// Partie : Servomoteurs.
// On vérifie dans la table des srv, si une donnée a été reçue.
// Si oui et si la valeur a changé, on valide la mise à jour sur la carte externe, sinon, on annule la mise à jour.
 if (maj_forcee == 1) {
    i2c_srv_maj = 0xFF;
  }
  else {
    for (x = 0; x < i2c_srv_nbmax; x ++ ) {
      if ((bitRead(i2c_srv_par, x) == 0) && (i2c_srv_val[x] == i2c_srv_val_old[x])) {
        bitWrite(i2c_srv_maj, x, 0);                // En mode normal, si valeurs identiques, on annule la mise à jour.
      }
      else { i2c_srv_val_old[x] = i2c_srv_val[x]; } // En mode normal, si valeurs différentes, on renseigne 'i2c_srv_val_old'.
    }
  }
// Si la mise à jour 'srv' est demandée, on va mettre à jour la carte partie 'srv'.
// On envoie 586 à 178, si la course est inversée.  x = byte, m = entier 16 bits non signé.
// L'impulsion de commande des servomoteurs est envoyé tous les 16 msec, au lieu des 20 msec habituels, pour bénéficier d'une meilleure résolution (256 pas).
//
//                       0                      128                     255            <-- Valeur brute reçue du PC.
//                     1000 µs                 1500 µs                 2000 µs         <-- Valeurs habituelles d'un servomoteur.
//                       |                       |                       |
//               [  700  à  1300  ]     [  1300  à  1700  ]     [  1700  à  2300  ]    <-- Plages de réglages, MIN, MOY et MAX.
//
  if (i2c_srv_maj != 0x00) {                                     // Si aucune mise à jour demandée, on passe.
    for (x = 0; x < i2c_srv_nbmax; x ++ ) {
      if (bitRead(i2c_srv_maj, x) == 1) {                        // On traite que si demande de maj.
        i = i2c_srv_val[x];
        i2c_srv_max_x = i2c_srv_max[x];
        i2c_srv_min_x = i2c_srv_min[x];
        i2c_srv_moy_x = i2c_srv_moy[x];
        if (bitRead(i2c_srv_par, x) == 1) {                      // Si Paramétrage en cours...
          if (bitRead(i2c_srv_sim, x) == 0) {                    // Si Paramétrage en cours et utiliser la valeur 0, 128 ou 255.
            if      (lcd_menu2 == 0) {
              i = 255;                                           // SERVO - Menu2 n° 0 : Réglage servo MAX. On est en train de modifier les paramètres de cette sortie servo.
              i2c_srv_max_x = i2c_srv_max_x + enc_rot_compteur;  // Nouvelle valeur max (434 à 588).
            }
            else if (lcd_menu2 == 1) {
              i = 0;                                             // SERVO - Menu2 n° 1 : Réglage servo MIN.
              i2c_srv_min_x = i2c_srv_min_x + enc_rot_compteur;  // Nouvelle valeur min (179 à 332).
            }
            else if (lcd_menu2 == 2) {
              i = 128;                                           // SERVO - Menu2 n° 2 : Réglage servo MOY.
              i2c_srv_moy_x = i2c_srv_moy_x + enc_rot_compteur;  // Nouvelle valeur moy (-51 à 51).
            }
          }
          else {                                                 // Si Paramétrage en cours et utiliser la valeur du sime5.
            if      (lcd_menu2 == 0) i2c_srv_max_x = i2c_srv_max_x + enc_rot_compteur;  // Nouvelle valeur max (434 à 588).
            else if (lcd_menu2 == 1) i2c_srv_min_x = i2c_srv_min_x + enc_rot_compteur;  // Nouvelle valeur min (179 à 332).
            else if (lcd_menu2 == 2) i2c_srv_moy_x = i2c_srv_moy_x + enc_rot_compteur;  // Nouvelle valeur moy (-51 à 51).
          }
        }
        if ((bitRead(i2c_srv_par, x) == 0) || (bitRead(i2c_srv_sim, x) == 1)) {    // Si pas de Paramétrage en cours ou utiliser la valeur simu.
          if (bitRead(i2c_srv_inv, x) == 1 ) i = 255 - i; // Course inversée.
        }
        if ((i2c_srv_max_x - i2c_srv_min_x) <= 256) {     // Pour éviter les dépassements de capacité, tout en gardant une bonne précision.
          m = i2c_srv_max_x - i2c_srv_min_x;              // Si (MAX-MIN <= 256) :     (MAX-MIN)*Valeur reçue/256 + MIN + ((128- |128-Valeur_reçue|*MOY)/128
          m = m * i;                                      // Sinon               : ((MAX-MIN)/2)*Valeur reçue/128 + MIN + ((128- |128-Valeur_reçue|*MOY)/128
          m = m >> 8;   // Division par 256.
          m = m + i2c_srv_min_x;                          // m = ((max-min) * val)/256 + min
          j = 128 - abs(128 - i);
          j = j * i2c_srv_moy_x;                          // Multiplication signée : Format entier pour 'i' et 'i2c_srv_moy_x' obligatoire.
          j = j >> 7;   // Division par 128.
          m = m + j;
          PCA_spwm.setPWM(x, m);                          // La sortie srv n°0 commence au n°0 sur la carte. 0,7 msec pour écrire sur la carte !!!
        }
        else {                                            // Si (MAX-MIN > 256) : ((MAX-MIN)/2)*Valeur reçue/128 + MIN + ((128- |128-Valeur_reçue|*MOY)/128
          m = i2c_srv_max_x - i2c_srv_min_x;
          m = m >> 1;   // Division par 2.
          m = m * i;
          m = m >> 7;   // Division par 128.
          m = m + i2c_srv_min_x;                          // m = (((max-min)/2) * val)/128 + min
          j = 128 - abs(128 - i);
          j = j * i2c_srv_moy_x;
          j = j >> 7;   // Division par 128.
          m = m + j;
          PCA_spwm.setPWM(x, m);                          // La sortie srv n°0 commence au n°0 sur la carte. 0,7 msec pour écrire sur la carte !!!
        }
      }
    }
    i2c_srv_maj = 0x00;                                   // Tous les demandes de mise à jour srv, ont été traitées.
  }

//-----------------------------------------------------------------------------------------------------------------------------
// Partie : Pwm (Galvanomètres, compte-tours, compteur de vitesse).
// On vérifie dans la table des pwm (Galva), si une donnée a été reçue.
// Si oui et si la valeur a changé, on valide la mise à jour sur la carte externe.
// Sinon, on annule la mise à jour.
// i2c_pwm_maj(x) = 1 : Mise à jour demandée, vers les cartes externes. Condition obligatoire pour faire une mise à jour.
// i2c_pwm_par(x) = 1 : Ne vérifie pas si 'val_old != val', pour faire une mise à jour.
// i2c_pwm_par(x) = 1 : i2c_pwm_sim(x) = 0 : Paramétrage sur écran LCD en cours. Utilise la valeur = 255. Ne pas modifier i2c_pwm_val_old(x).
// i2c_pwm_par(x) = 1 : i2c_pwm_sim(x) = 1 : Paramétrage sur écran LCD en cours. Utilise la valeur reçue du PC. Ne pas modifier i2c_pwm_val_old(x).
  if (maj_forcee == 1) {
    i2c_pwm_maj = 0xFF;
  }
  else {
    for (x = 0; x < i2c_pwm_nbmax; x ++ ) {
      if ((bitRead(i2c_pwm_par, x) == 0) && (i2c_pwm_val[x] == i2c_pwm_val_old[x])) {
        bitWrite(i2c_pwm_maj, x, 0);                // En mode normal, si valeurs identiques, on annule la mise à jour.
      }
      else { i2c_pwm_val_old[x] = i2c_pwm_val[x]; } // En mode normal, si valeurs différentes, on renseigne 'i2c_pwm_val_old'.
    }
  }
// Si la mise à jour 'pwm' est demandée, on va mettre à jour la carte partie 'pwm'.
// La sortie est active au niveau bas !
// Si l'impulsion de sortie est normale  ==>   0 ---> 225   On envoie    4095 ---> 15  (4095 = Eteint).
// Si l'impulsion de sortie est inversée ==>   0 ---> 225   On envoie    0 ----> 4080  (   0 = Etient).
// x = byte, m = entier 16 bits non signé.
// Des parties de code sont redondantes, et pouraient être mutualisées, mais c'est plus facile à comprendre comme cela.
  if (i2c_pwm_maj != 0x00) {                                    // Si aucune mise à jour demandée, on passe.
    for (x = 0; x < i2c_pwm_nbmax; x ++ ) {
      if (bitRead(i2c_pwm_maj, x) == 1) {                       // On traite que si demande de maj.
        if (bitRead(i2c_pwm_par, x) == 1) {                     // Si Paramétrage en cours...
          if (bitRead(i2c_pwm_sim, x) == 0) {                   // Si Paramétrage en cours et utiliser la valeur 128.
            m = 128;                                            // Mise à jour avec valeur = 128. On est en train de modifier les paramètres de cette sortie pwm.
            m = m*(i2c_pwm_ech[numero_pwm] + enc_rot_compteur); // Si Paramétrage en cours, on utilise la valeur d'échelle (63 à 255) en cours de saisie.
            m = m >> 3;
            if (m > 4095) m = 4095;                             // Avec une échelle > 1.000, on peut dépasser 4095.
            y = x + 8;                                          // La sortie pwm n°0 commence au n°8 sur la carte.
//  Le type d'impulsion n'est pas pris dynamiquement en compte, il faudra la valider dans le menu pour qu'elle soit prise en compte dansl e calcul.
            if (bitRead(i2c_pwm_inv, x) == 1 ) m = 4095 - m;    // Impulsion de sortie à polarité inversée.
            if (m == 4095 ) PCA_spwm.write1(y, HIGH);
            else            PCA_spwm.setPWM(y, m);
            }
          else {                                                // Si Paramétrage en cours et utiliser la valeur du simu.
            m = i2c_pwm_val[x];                                 // Valeur à envoyée  = (Valeur_reçue * Echelle)/8.
            m = m*(i2c_pwm_ech[numero_pwm] + enc_rot_compteur); // Si Paramétrage en cours, on utilise la valeur d'échelle (63 à 255) en cours de saisie.
            m = m >> 3;
            y = x + 8;                                          // La sortie pwm n°0 commence au n°8 sur la carte.
            if (m > 4095) m = 4095;                             // Avec une échelle > 1.000, on peut dépasser 4095.
            if (bitRead(i2c_pwm_inv, x) == 1 ) m = 4095 - m;    // Impulsion de sortie à polarité inversée.
            if (m == 4095 ) PCA_spwm.write1(y, HIGH);
            else            PCA_spwm.setPWM(y, m);
          }
        }
        else {                                                  // Si pas de Paramétrage en cours, et traitement normal.
          if (i2c_pwm_ech[x] == 128) {                          // Codage du calcul simplifié, si échelle = 128, valeur vers la carte (0-4095) = 16 x valeur reçue (0-255).
            m = i2c_pwm_val[x];                                 // Pas besoin de faire de multiplication. On ne peut pas dépasser 4095 avec ce calcul.
            m = m << 4;
            y = x + 8;                                          // La sortie pwm n°0 commence au n°8 sur la carte.
            if (m > 4095) m = 4095;                             // Avec une échelle > 1.000, on peut dépasser 4095.
            if (bitRead(i2c_pwm_inv, x) == 1 ) m = 4095 - m;    // Impulsion de sortie de polarité inversée  0 pour 0%.
            if (m == 4095 ) PCA_spwm.write1(y, HIGH);
            else            PCA_spwm.setPWM(y, m);
          }
          else {                                                // Codage du calcul normal, si échelle ! 128, valeur vers la carte (0-4095) = (Valeur_reçue * Echelle)/8.
            m = i2c_pwm_val[x];                                 // Valeur reçue = 0 à 255. Echelle = 63 à 255.
            m = m*i2c_pwm_ech[x];
            m = m >> 3;
            y = x + 8;                                          // La sortie pwm n°0 commence au n°8 sur la carte.
            if (m > 4095) m = 4095;                             // Avec une échelle > 1.000, on peut dépasser 4095.
            if (bitRead(i2c_pwm_inv, x) == 1 ) m = 4095 - m;    // Impulsion de sortie de polarité inversée  0 pour 0%.
            if (m == 4095 ) PCA_spwm.write1(y, HIGH);
            else            PCA_spwm.setPWM(y, m);
          }
        }
      }
    }
    i2c_pwm_maj = 0x00;                                         // Tous les demandes de mise à jour pwm, ont été traitées.
  }

//-----------------------------------------------------------------------------------------------------------------------------
// Partie : Sorties tout ou rien n° 1 et 2.
// On vérifie dans les tables out1 et out2, si une donnée a été reçue.
// Si oui et si la valeur a changé, on valide la mise à jour sur la carte externe, sinon, on annule la mise à jour.
// Normalement, les sorties sont animées une par une. Si le cas fréquent serait d'avoir plusieurs sortie d'animées en même temps,
// on pourrait utiliser l'instruction Write16(), pour tout écrire d'une fois.
  if (maj_forcee == 1) {
    i2c_out1_maj = 0xFFFF;
    i2c_out2_maj = 0xFFFF;
  }
  else {
// On vérifie si la demande de mise à jour est justifiée. On l'annule si la sortie est déjà dans le bon état.
    for (x = 0; x < i2c_out_nbmax; x ++ ) {
      if (bitRead(i2c_out1_maj, x) == 1) {
        if (bitRead(i2c_out1_val, x) == bitRead(i2c_out1_val_old, x)) { bitWrite(i2c_out1_maj, x, 0); }  // On annule la mise à jour.
        else {
          if (bitRead(i2c_out1_val, x) == 0) { bitWrite(i2c_out1_val_old, x, 0); }
          else                               { bitWrite(i2c_out1_val_old, x, 1); }
        }
      }
    }
    for (x = 0; x < i2c_out_nbmax; x ++ ) {
      if (bitRead(i2c_out2_maj, x) == 1) {
        if (bitRead(i2c_out2_val, x) == bitRead(i2c_out2_val_old, x)) { bitWrite(i2c_out2_maj, x, 0); }  // On annule la mise à jour.
        else {
          if (bitRead(i2c_out2_val, x) == 0) { bitWrite(i2c_out2_val_old, x, 0); }
          else                               { bitWrite(i2c_out2_val_old, x, 1); }
        }
      }
    }
  }
// Partie sorties tout ou rien.
// On vérifie dans les tables out1 et out2, si une donnée a été reçue.
  if (i2c_out1_maj != 0x00) {                                            // Si aucune mise à jour demandée, on passe.
    for (x = 0; x < i2c_out_nbmax; x ++) {
      if (bitRead(i2c_out1_maj, x) == 1) {
        if (bitRead(i2c_out1_val, x) == 1) { PCA_out1.write1(x,  LOW); } // Allume le voyant.
        else                               { PCA_out1.write1(x, HIGH); } // Eteint le voyant.
      }
    }
  }
  if (i2c_out2_maj != 0x00) {                                            // Si aucune mise à jour demandée, on passe.
    for (x = 0; x < i2c_out_nbmax; x ++) {
      if (bitRead(i2c_out2_maj, x) == 1) {
        if (bitRead(i2c_out2_val, x) == 1) { PCA_out2.write1(x,  LOW); } // Allume le voyant.
        else                               { PCA_out2.write1(x, HIGH); } // Eteint le voyant.
      }
    }
  }
  i2c_out1_maj = 0x0000;   // Tous les demandes de mise à jour out1 ont été traitées.
  i2c_out2_maj = 0x0000;   // Tous les demandes de mise à jour out2 ont été traitées.
  maj_forcee   = 0;        // La demande de mise à jour forcée a été traitée.

//-----------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------
// Lecture des 48 entrées numériques.
// Si une entrée a bougé, la broche 'pin_interrupt_MCP' est = 1.
// On a programmé le MCP23017 pour qu'il envoie un signal bas sur la broche 'pin_interrupt_MCP', quand une des entrées change de valeur.
// Par contre, on ne sait pas quel est le MCP23017 en cause.
// Le MCP23017 est équipé d'anti-rebond matériel.
// La lecture d'un périphérique I2C prend du temps ~ 1 msec.
//
  if (digitalRead(pin_interrupt_MCP) == 0) {
// Une entrée a bougé. La lecture du MCP23017 fera descendre automatique le signal 'pin_interrupt_MCP'.
// Lecture des entrées pour mise à jour des variables.
//                   MODULE   MCP23017
//                +---------------------+
//    Ports       | AAAAAAAA   BBBBBBBB |
//    N° entrées  | 76543210   01234567 |
//                +---------------------+
//  En pratique     00000000   00111111
//  N° de 0 à 15 :  01234567   89012345
// Sur le module, on a de gauche à droite les entrées A7 à A0, puis B0 à B7.
// Dans le code, on remet en ordre les entrées pour avoir les entrées de 0(A7) à 15(B7), de gauche à droite.
    i = MCP23017_1.read16();
    i2c_in1_val = i & 0x00FF;
    i2c_in1_val = i2c_in1_val<<8;
    for (x = 0; x <  8; x++) { bitWrite(i2c_in1_val,  7 - x, bitRead(i, x + 8)); }  // Bits A7-A0 B0-B7 en bonne position dans 'i2c_in1_val', entrées de 0 à 15 de gauche à droite.
    i2c_in1_maj = i2c_in1_val ^ i2c_in1_val_old;
    i2c_in1_val_old  = i2c_in1_val;
    i = MCP23017_2.read16();
    i2c_in2_val = i & 0x00FF;
    i2c_in2_val = i2c_in2_val<<8;
    for (x = 0; x <  8; x++) { bitWrite(i2c_in2_val,  7 - x, bitRead(i, x + 8)); }  // Bits A7-A0 B0-B7 en bonne position dans 'i2c_in1_val', entrées de 0 à 15 de gauche à droite.
    i2c_in2_maj = i2c_in2_val ^ i2c_in2_val_old;
    i2c_in2_val_old  = i2c_in2_val;
    i = MCP23017_3.read16();
    i2c_in3_val = i & 0x00FF;
    i2c_in3_val = i2c_in3_val<<8;
    for (x = 0; x <  8; x++) { bitWrite(i2c_in3_val,  7 - x, bitRead(i, x + 8)); }  // Bits A7-A0 B0-B7 en bonne position dans 'i2c_in1_val', entrées de 0 à 15 de gauche à droite.
    i2c_in3_maj = i2c_in3_val ^ i2c_in3_val_old;
    i2c_in3_val_old  = i2c_in3_val;
  }

//-----------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------
// Lecture des boutons du clavier LCD.
// Si le menu d'accueilest affiché, on n'appelle pas la routine d'acquisition, pour éviter d'exécuter du code.
  if (lcd_menu1 != 0) acq_boutons_lcd() ;                                   // En retour : 'lcd_clavier_touche' = 0 à 6, à remettre à 0 après traitement.
  else if ((lcd_menu1 == 0) && (enc_rot_compteur != 0)) acq_boutons_lcd() ; // En retour : 'lcd_clavier_touche' = 0 à 6, à remettre à 0 après traitement.
//-----------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------
/*
  lcd_menu1      : 0 = "JLF - 12/02/2025" à 5 = "(5)AFFICHE VAL. RECUES/ENVOYEES".
  lcd_menu1_flag : 1 = On vient de valider un des menus principaux, pour ne passer qu'une première fois dans le code.
  lcd_menu2      : 0 = MAX, MIN, MOY, INV, ECH,
  numero_srv, numero_pwm = Numéro de servo, galva en cours d'affichage.  */
  // Le menu d'accueilest affiché sur l'écran LCD.
  if (lcd_menu1 == 0) {
    enc_rot_compt();         // Vérifie si l'on a tourné l'encodeur rotatif, pour faire défiler les menus principaux.
    if ((enc_rot_modif == 1) || (lcd_menu1_flag == 1 )) {  // Si oui, on affiche le texte du nouveau menu principal.
      enc_rot_modif = 0;     // Pour ne pas repasser tout le temps ici.
      lcd_menu1_flag = 0;    // Pour ne pas repasser tout le temps ici.
      if (enc_rot_compteur >= lcd_menu_nbocc) enc_rot_compteur = lcd_menu_nbocc-1;
      if (enc_rot_compteur < 0) enc_rot_compteur = 0;
      LCD.setCursor(0, 0); LCD.print(lcd_menu1_txt[enc_rot_compteur]);
      LCD.setCursor(0, 1); LCD.print(lcd_menu2_txt[enc_rot_compteur]);
    }
    enc_rot_sw();                    // Verifie si l'on a appuyé sur le bouton de l'encodeur rotatif, pour valider un menu principal.
    if ((enc_rot_modif==1) || (lcd_clavier_touche == lcd_clavier_touche_ok)) {          // Si oui, on va afficher un des menus principaux.
      enc_rot_modif=0;               // Pour ne pas repasser tout le temps ici.            5' = Touche "OK". Même action que le bouton de l'encodeur rotatif.
      if (enc_rot_compteur != 0) {   // Pas d'action si l'on est déjà sur le menu d'acceuil.
        lcd_menu1=enc_rot_compteur;  // On active le menu secondaire appelé.
        lcd_menu1_flag=1;            // Pour forcer l'affichage sur l'écran lcd, au premier passage.
        lcd_menu2 = 0;               // Sous menus : MAX, MIN, MOY, INV,,,
        numero_srv = 0;              // Affiche le 1er élément  du sous menu.
        numero_pwm = 0;              // Affiche le 1er élément  du sous menu.
        enc_rot_compteur = 0;
        lcd_aff_val_simu = 1;        // On affiche la valeur 0-255 par défaut.
        lcd_clavier_touche = lcd_clavier_touche_rien;
        if (lcd_menu1 == 4) {
            milli_cpt = 0;
            milli_old  = millis(); // Affichage durée boucle correcte pour le 1er affichage.
        }
      }
    }
  }

//-----------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------
// Le menu de réglage des servo est affiché sur l'écran LCD.
// Paramétrage valeur minimum, maximum, moyenne et course inversée.
// Si la touche "Valeur du simulateur" est appuyée, on force la mise à jour sur la carte MCP23017, avec la valeur courante reçue du simu.
  if (lcd_menu1 == 1) {
    if (lcd_menu2 == 0) {                 // SERVO - Menu2 = 0 : Réglage servo MAX.
      enc_rot_compt();                    // Vérifie si l'on a tourné l'encodeur rotatif, pour faire défiler la valeur.
      if ((lcd_menu1_flag == 1) || (enc_rot_modif ==1)) {
        lcd_menu1_flag = 0;               // Pour n'afficher qu'une fois le menu sur l'écran LCD.
        enc_rot_modif  = 0;               // SERVO - On acquitte 'enc_rot_modif'.
                                          // Affichage sur l'écran lcd.
        mult_391_in = i2c_srv_max[numero_srv];
        mult_391();
        sprintf(lcd_buffer, "%s%2d%s%4d", "SRV:", numero_srv, " MAX: ", mult_391_out);
        LCD.setCursor(0, 0); LCD.print(lcd_buffer);
        mult_391_in = mult_391_in+enc_rot_compteur;
        if (mult_391_in < 434) { enc_rot_compteur = 434 - i2c_srv_max[numero_srv]; mult_391_in = 434;}
        if (mult_391_in > 588) { enc_rot_compteur = 588 - i2c_srv_max[numero_srv]; mult_391_in = 588;}
        mult_391();
        if (bitRead(i2c_srv_sim, numero_srv) == 1) { sprintf(lcd_buffer, "%s%4d", "NVL VAL(si):", mult_391_out); }
        else                                       { sprintf(lcd_buffer, "%s%4d", "NVL VAL   : ", mult_391_out); }
        LCD.setCursor(0, 1); LCD.print(lcd_buffer);
        bitWrite(i2c_srv_par, numero_srv, 1);  // Demande de mise à jour vers la carte externe.
        bitWrite(i2c_srv_maj, numero_srv, 1);  //
      }
      enc_rot_sw();            // Verifie si l'on a appuyé sur le bouton de l'encodeur rotatif, pour valider la nouvelle valeur.
      if (lcd_clavier_touche == lcd_clavier_touche_ok) { // SRV - '5' = Touche "OK". Même action que le bouton de l'encodeur rotatif.
          lcd_clavier_touche = lcd_clavier_touche_rien;
          enc_rot_modif = 1;
      }
      if ((enc_rot_modif == 1) || (lcd_clavier_touche == lcd_clavier_touche_valide)) { // SRV - '6' = Touche "VALIDE + QUITTE".
        offset_eeprom = 0x40 + 2*numero_srv;
        i = i2c_srv_max[numero_srv] + enc_rot_compteur;               // Nouvelle valeur max (434 à 588).
        i2c_srv_max[numero_srv] = i;
        EEPROM_24C04.updateBlock(offset_eeprom, (uint8_t *) &i, 2);   // Nouvelle valeur max.
        lcd_menu1_flag = 1;                     // On demande l'affichage du prochain sous-menu avec le même galva ou du menu principal.
        enc_rot_modif = 0;                      // SRV - On acquitte 'enc_rot_modif'.
        enc_rot_compteur = 0;
        if (lcd_clavier_touche == lcd_clavier_touche_valide) {        // SRV - '6' = Touche appuyée : "VALIDE + QUITTE".
          lcd_clavier_touche = lcd_clavier_touche_rien;
          lcd_menu1 = 0;
          i2c_srv_par = 0;                      // SRV - En quittant ce menu, on désinhibe tous les servo.
          i2c_srv_sim = 0;                      //
          bitWrite(i2c_srv_maj, numero_srv, 1); // Demande de mise à jour avec la valeur reçue du PC.
          i2c_srv_val_old[numero_srv] = 254;    // Si l'ancienne valeur <> 254 (majorité des cas).
        }
        else {
          lcd_menu2++;                          // SRV - On a validé l'échelle, on passe au sous menu d'impulsion "normale/inversée" sur le même galva.
          bitWrite(i2c_srv_maj, numero_srv, 1); // Demande de mise à jour avec la valeur reçue du PC.
          i2c_srv_val_old[numero_srv] = 254;    // Si l'ancienne valeur <> 254 (majorité des cas).
        }
      }
    }
    if (lcd_menu2 == 1) {                       // SRV - Menu2 = 1 : Réglage servo MIN.
      if (lcd_menu1_flag == 1) enc_rot_compteur = 0;
      enc_rot_compt();                          // Vérifie si l'on a tourné l'encodeur rotatif, pour faire défiler la valeur.
      if ((lcd_menu1_flag == 1) || (enc_rot_modif ==1)) {
        lcd_menu1_flag = 0;                     // Pour n'afficher qu'une fois le menu sur l'écran LCD.
        enc_rot_modif  = 0;                     // SRV - On acquitte 'enc_rot_modif'.
                                                // Affichage sur l'écran lcd.
        mult_391_in = i2c_srv_min[numero_srv];
        mult_391();
        sprintf(lcd_buffer, "%s%2d%s%4d", "SRV:", numero_srv, " MIN: ", mult_391_out);
        LCD.setCursor(0, 0); LCD.print(lcd_buffer);
        mult_391_in = mult_391_in+enc_rot_compteur;
        if (mult_391_in < 179) { enc_rot_compteur = 179 - i2c_srv_min[numero_srv]; mult_391_in = 179;}
        if (mult_391_in > 332) { enc_rot_compteur = 332 - i2c_srv_min[numero_srv]; mult_391_in = 332;}
        mult_391();
        if (bitRead(i2c_srv_sim, numero_srv) == 1) { sprintf(lcd_buffer, "%s%4d", "NVL VAL(si):", mult_391_out); }
        else                                       { sprintf(lcd_buffer, "%s%4d", "NVL VAL   : ", mult_391_out); }
        LCD.setCursor(0, 1); LCD.print(lcd_buffer);
        bitWrite(i2c_srv_par, numero_srv, 1);  // Demande de mise à jour vers la carte externe.
        bitWrite(i2c_srv_maj, numero_srv, 1);  //
      }
      enc_rot_sw();            // Verifie si l'on a appuyé sur le bouton de l'encodeur rotatif, pour valider la nouvelle valeur.
      if (lcd_clavier_touche == lcd_clavier_touche_ok) { // SRV - '5' = Touche "OK". Même action que le bouton de l'encodeur rotatif.
          lcd_clavier_touche = lcd_clavier_touche_rien;
          enc_rot_modif = 1;
      }
      if ((enc_rot_modif == 1) || (lcd_clavier_touche == lcd_clavier_touche_valide)) { // SRV - '6' = Touche "VALIDE + QUITTE".
        offset_eeprom = 0x60 + 2*numero_srv;
        i = i2c_srv_min[numero_srv] + enc_rot_compteur;       // Nouvelle valeur min (179 à 332).
        i2c_srv_min[numero_srv] = i;
        EEPROM_24C04.updateBlock(offset_eeprom, (uint8_t *) &i, 2);       // Nouvelle valeur min.
        lcd_menu1_flag = 1;                     // On demande l'affichage du prochain sous-menu avec le même galva ou du menu principal.
        enc_rot_modif = 0;                      // SRV - On acquitte 'enc_rot_modif'.
        enc_rot_compteur = 0;
        if (lcd_clavier_touche == lcd_clavier_touche_valide) {          // SRV - '6' = Touche appuyée : "VALIDE + QUITTE".
          lcd_clavier_touche = lcd_clavier_touche_rien;
          lcd_menu1 = 0;
          i2c_srv_par = 0;                      // SRV - En quittant ce menu, on désinhibe tous les servos.
          i2c_srv_sim = 0;                      //
          bitWrite(i2c_srv_maj, numero_srv, 1); // Demande de mise à jour avec la valeur reçue du PC.
          i2c_srv_val_old[numero_srv] = 254;    // Si l'ancienne valeur <> 254 (majorité des cas).
        }
        else {
          lcd_menu2++;                          // SRV - On a validé l'échelle, on passe au sous menu d'impulsion "normale/inversée" sur le même galva.
          bitWrite(i2c_srv_maj, numero_srv, 1); // Demande de mise à jour avec la valeur reçue du PC.
          i2c_srv_val_old[numero_srv] = 254;    // Si l'ancienne valeur <> 254 (majorité des cas).
        }
      }
    }
    if (lcd_menu2 == 2) {                       // SRV - Menu2 = 2 : Réglage servo MOY.
      enc_rot_compt();                          // Vérifie si l'on a tourné l'encodeur rotatif, pour faire défiler la valeur.
      if ((lcd_menu1_flag == 1) || (enc_rot_modif ==1)) {
        lcd_menu1_flag = 0;                     // Pour n'afficher qu'une fois le menu sur l'écran LCD.
        enc_rot_modif  = 0;                     // SERVO - On acquitte 'enc_rot_modif'.
                                                // Affichage sur l'écran lcd.
        mult_391_in = i2c_srv_moy[numero_srv];
        mult_391();
        sprintf(lcd_buffer, "%s%2d%s%4d", "SRV:", numero_srv, " MOY: ", mult_391_out);
        LCD.setCursor(0, 0); LCD.print(lcd_buffer);
        mult_391_in = mult_391_in + enc_rot_compteur;
        if (mult_391_in < -51) { enc_rot_compteur = -51 - i2c_srv_moy[numero_srv]; mult_391_in = -51;}  // Correction à mi-course -200 µs / + 200 µs maximum.
        if (mult_391_in >  51) { enc_rot_compteur =  51 - i2c_srv_moy[numero_srv]; mult_391_in =  51;}
        mult_391();
        if (bitRead(i2c_srv_sim, numero_srv) == 1) { sprintf(lcd_buffer, "%s%4d", "NVL VAL(si):", mult_391_out); }
        else                                       { sprintf(lcd_buffer, "%s%4d", "NVL VAL   : ", mult_391_out); }
        LCD.setCursor(0, 1); LCD.print(lcd_buffer);
        bitWrite(i2c_srv_par, numero_srv, 1);  // Demande de mise à jour vers la carte externe.
        bitWrite(i2c_srv_maj, numero_srv, 1);  //
      }
      enc_rot_sw();            // Verifie si l'on a appuyé sur le bouton de l'encodeur rotatif, pour valider la nouvelle valeur.
      if (lcd_clavier_touche == lcd_clavier_touche_ok) { // SRV - '5' = Touche "OK". Même action que le bouton de l'encodeur rotatif.
          lcd_clavier_touche = lcd_clavier_touche_rien;
          enc_rot_modif = 1;
      }
      if ((enc_rot_modif == 1) || (lcd_clavier_touche == lcd_clavier_touche_valide)) { // SRV - '6' = Touche "VALIDE + QUITTE".
        offset_eeprom = 0x80 + 2*numero_srv;
        i = i2c_srv_moy[numero_srv] + enc_rot_compteur;              // Nouvelle valeur moy (-51 à 51).
        i2c_srv_moy[numero_srv] = i;
        EEPROM_24C04.updateBlock(offset_eeprom, (uint8_t *) &i, 2);  // Nouvelle valeur moy  (-51 à 51).
        lcd_menu1_flag = 1;                     // On demande l'affichage du prochain sous-menu avec le même galva ou du menu principal.
        enc_rot_modif = 0;                      // SRV - On acquitte 'enc_rot_modif'.
        enc_rot_compteur = 0;
        if (lcd_clavier_touche == lcd_clavier_touche_valide) {       // SRV - '6' = Touche appuyée : "VALIDE + QUITTE".
          lcd_clavier_touche = lcd_clavier_touche_rien;
          lcd_menu1 = 0;
          i2c_srv_par = 0;                      // SRV - En quittant ce menu, on désinhibe tous les servos.
          i2c_srv_sim = 0;                      //
          bitWrite(i2c_srv_maj, numero_srv, 1); // Demande de mise à jour avec la valeur reçue du PC.
          i2c_srv_val_old[numero_srv] = 254;    // Si l'ancienne valeur <> 254 (majorité des cas).
        }
        else {
          lcd_menu2++;                          // SRV - On a validé l'échelle, on passe au sous menu d'impulsion "normale/inversée" sur le même galva.
          bitWrite(i2c_srv_maj, numero_srv, 1); // Demande de mise à jour avec la valeur reçue du PC.
          i2c_srv_val_old[numero_srv] = 254;    // Si l'ancienne valeur <> 254 (majorité des cas).
        }
      }
    }
    if (lcd_menu2 == 3) {                       // SRV - Menu2 = 3 : Réglage servo course inversée.
      if (lcd_menu1_flag == 1) enc_rot_compteur = (bitRead(i2c_srv_inv, numero_srv)); // Pour initialiser "enc_rot_compteur" avec la valeur Normale/inverse.
      enc_rot_compt();                          // Vérifie si l'on a tourné l'encodeur rotatif, pour faire défiler la valeur.
      if ((lcd_menu1_flag == 1) || (enc_rot_modif ==1)) {
        lcd_menu1_flag = 0;                     // Pour n'afficher qu'une fois le menu sur l'écran LCD.
        enc_rot_modif  = 0;                     // SRV - On acquitte 'enc_rot_modif'.
        if (bitRead(i2c_srv_inv, numero_srv) == 0) { sprintf(lcd_buffer, "%s%2d%s", "SRV:", numero_srv, "  : NOR   "); }
        else                                       { sprintf(lcd_buffer, "%s%2d%s", "SRV:", numero_srv, "  : INV   "); }
        LCD.setCursor(0, 0); LCD.print(lcd_buffer);
        if (bitRead(enc_rot_compteur, 0) == 0) { sprintf(lcd_buffer, "%s", "COURSE  NORMALE "); }
        else                                   { sprintf(lcd_buffer, "%s", "COURSE  INVERSEE");  }
        LCD.setCursor(0, 1); LCD.print(lcd_buffer);
        i2c_srv_sim = 0;                        // Pas de cas (si) dans ce sous-menu.
        bitWrite(i2c_srv_par, numero_srv, 1);   // Demande de mise à jour vers la carte externe.
        bitWrite(i2c_srv_maj, numero_srv, 1);   //
      }
      enc_rot_sw();            // Verifie si l'on a appuyé sur le bouton de l'encodeur rotatif, pour valider la nouvelle valeur.
      if (lcd_clavier_touche == lcd_clavier_touche_ok) { // SRV - '5' = Touche "OK". Même action que le bouton de l'encodeur rotatif.
          lcd_clavier_touche = lcd_clavier_touche_rien;
          enc_rot_modif = 1;
      }
      if ((enc_rot_modif == 1) || (lcd_clavier_touche == lcd_clavier_touche_valide)) {  // On a appuyé sur le bouton 'VALIDE', ou appuyé sur '6' = Touche "VALIDE + QUITTE".
        enc_rot_modif = 0;
        offset_eeprom = 0x30;
        enc_rot_compteur = enc_rot_compteur & 0x01;           // 'enc_rot_compteur' = 0 ou 1.
        bitWrite(i2c_srv_inv, numero_srv, enc_rot_compteur);  // On modifie le type "Normal/inversé", en mémoire et dans l'eeprom.
        if (enc_rot_compteur == 0) {
          EEPROM_24C04.readBlock(offset_eeprom, (uint8_t *) &i, 2);          // On travaille sur les 16 bits !
          bitClear(i, numero_srv);
          EEPROM_24C04.updateBlock(offset_eeprom, (uint8_t *) &i, 2);
        }
        else {
          EEPROM_24C04.readBlock(offset_eeprom, (uint8_t *) &i, 2);
          bitSet(i, numero_srv);
          EEPROM_24C04.updateBlock(offset_eeprom, (uint8_t *) &i, 2);
        }
        enc_rot_compteur = 0;
        lcd_menu2 = 0;                           // Pour aller au sous-menu "ECH", prochain galva.
        lcd_menu1_flag = 1;
        i2c_srv_par = 0;                         // SRV - On change de n° de srv, on désinhibe tous les servo pour que la sortie srv retrouve la valeur du simu.
        bitWrite(i2c_srv_maj, (numero_srv) , 1); // Demande de mise à jour de la sortie précédemment configurée, avec la valeur reçue du PC.
        i2c_srv_val_old[numero_srv] = 254;       // Si l'ancienne valeur <> 254 (majorité des cas).
        numero_srv++;                            // Element suivant = Servo suivant.
        if ((numero_srv >= i2c_srv_nbmax) ||(lcd_clavier_touche == lcd_clavier_touche_valide)) { // SRV - Dernier élément ou appuyé sur '6' = Touche "VALIDE + QUITTE" -> Retour au menu (1).
          lcd_clavier_touche = lcd_clavier_touche_rien;
          lcd_menu1 = 0;
          enc_rot_modif=0;
          i2c_srv_sim = 0;                       //
        }
      }
    }
    if (lcd_clavier_touche == lcd_clavier_touche_valsim) {      // SRV - Touche "Valeur du simulateur" ou 255 : Affichage "(si)".
      if (bitRead(i2c_srv_sim, numero_srv ) == 0 ) { bitWrite(i2c_srv_sim, numero_srv, 1); }
      else                                         { bitWrite(i2c_srv_sim, numero_srv, 0); }
      lcd_clavier_touche = lcd_clavier_touche_rien;
      lcd_menu1_flag = 1;
    }
    if (lcd_clavier_touche == lcd_clavier_touche_abraz) {       // SRV - '4' = Touche "ABANDON / RAZ".
      lcd_clavier_touche = lcd_clavier_touche_rien;
      lcd_menu1 = 0;
      lcd_menu1_flag = 0;
      enc_rot_compteur=0;
      enc_rot_modif=1;
      i2c_srv_par = 0;                          // SRV - En quittant ce menu, on désinhibe tous les servos.
      i2c_srv_sim = 0;                          //
      bitWrite(i2c_srv_maj, numero_srv, 1);     // Demande de mise à jour avec la valeur reçue du PC.
      i2c_srv_val_old[numero_srv] = 254;        // Si l'ancienne valeur <> 254 (majorité des cas).
    }
  }
//-----------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------
// Le menu de réglage des galva (pwm) est affiché sur l'écran LCD.
// Paramétrage échelle et impulsion inversée.
// On force la mise à jour sur la carte MCP23017, avec i2c_pwm_val[x]=255. bitRead(i2c_pwm_par)= 1.
// Si la touche "Valeur du simulateur" est appuyée, on force la mise à jour sur la carte MCP23017, avec la valeur courante reçue du simu.
// Si le galva n'est pas inhibé, on valide le changement val_old = val.
//
  if (lcd_menu1 == 2) {
    if (lcd_menu2 == 0) {                 // PWM - Menu2 = 0 : Réglage galva ECH.
      enc_rot_compt();                    // Vérifie si l'on a tourné l'encodeur rotatif, pour faire défiler la valeur.
      if ((lcd_menu1_flag == 1) || (enc_rot_modif ==1)) {
        lcd_menu1_flag = 0;               // Pour n'afficher qu'une fois le menu sur l'écran LCD.
        enc_rot_modif  = 0;               // PWM - On acquitte 'enc_rot_modif'.
                                          // Affichage sur l'écran lcd.
        f = i2c_pwm_ech[numero_pwm];      // f (flottant) = 63 à 255. Calcul de l'échelle.
        f = f/128;                        // f (flottant) = 0,500 à 2.000
//      dtostrf(f, 4, 3, lcd_buffer_f);   // 4 chiffres en tout, 3 chiffres après le virgule. // Ne fonctionne que sur processeur AVR.
        i = 10000 * f;
        sprintf(&lcd_buffer_f[1], "%05d", i);   // 1000 ou 1164 ou 0985.  // Fonction pour afficher un flottant sous la forme x.xxxx.
        lcd_buffer_f[0]=lcd_buffer_f[1];
        lcd_buffer_f[1]='.';
        lcd_buffer_f[5]=0;
        sprintf(lcd_buffer, "%s%2d%s%s", "GAL:", numero_pwm, " ECH:", lcd_buffer_f);
        LCD.setCursor(0, 0); LCD.print(lcd_buffer);
        x = i2c_pwm_ech[numero_pwm] + enc_rot_compteur;    // x (entier) = 63 à 255.
        if (x > 255) { enc_rot_compteur = 255 - i2c_pwm_ech[numero_pwm]; x = 255;}  // Maximum 255 = 2.00
        if (x <  63) { enc_rot_compteur =  63 - i2c_pwm_ech[numero_pwm]; x =  63;}  // Minimum  63 = 0.50
        f = x;
        f = f/128;                        // f (flottant) = 0,500 à 2.000 = Nouvelle échelle.
//      dtostrf(f, 4, 3, lcd_buffer_f);   // 4 chiffres en tout, 3 chiffres après le virgule. // Ne fonctionne que sur processeur AVR.
        i = 10000 * f;
        sprintf(&lcd_buffer_f[1], "%05d", i);   // 1000 ou 1164 ou 0985.  // Fonction pour afficher un flottant sous la forme x.xxxx.
        lcd_buffer_f[0]=lcd_buffer_f[1];
        lcd_buffer_f[1]='.';
        lcd_buffer_f[5]=0;
        if (bitRead(i2c_pwm_sim, numero_pwm) == 1) { sprintf(lcd_buffer, "%s%s", "NVL VAL(si)", lcd_buffer_f); }
        else                                       { sprintf(lcd_buffer, "%s%s", "NVL VAL   :", lcd_buffer_f); }
        LCD.setCursor(0, 1); LCD.print(lcd_buffer);
        bitWrite(i2c_pwm_par, numero_pwm, 1);  // Demande de mise à jour vers la carte externe.
        bitWrite(i2c_pwm_maj, numero_pwm, 1);  //
      }
      enc_rot_sw();                             // Verifie si l'on a appuyé sur le bouton de l'encodeur rotatif, pour valider la nouvelle valeur.
      if (lcd_clavier_touche == lcd_clavier_touche_ok) { // SRV - '5' = Touche "OK". Même action que le bouton de l'encodeur rotatif.
          lcd_clavier_touche = lcd_clavier_touche_rien;
          enc_rot_modif = 1;
      }
      if ((enc_rot_modif == 1) || (lcd_clavier_touche == lcd_clavier_touche_valide)) {  // On a appuyé sur le bouton 'VALIDE', ou appuyé sur '6' = Touche "VALIDE + QUITTE".
        offset_eeprom = 0xB0 + 2*numero_pwm;
        i = i2c_pwm_ech[numero_pwm] + enc_rot_compteur;         // Nouvelle valeur d'échelle (63 à 255).
        i2c_pwm_ech[numero_pwm] = i;            // On enregistre la nouvelle valeur d'échelle (63 à 255) en mémoire.
        EEPROM_24C04.updateBlock(offset_eeprom, (uint8_t *) &i, 2);
        lcd_menu1_flag = 1;                     // On demande l'affichage du prochain sous-menu avec le même galva ou du menu principal.
        enc_rot_modif = 0;                      // PWM - On acquitte 'enc_rot_modif'.
        enc_rot_compteur = 0;
        if (lcd_clavier_touche == lcd_clavier_touche_valide) {          // PWM - '6' = Touche appuyée : "VALIDE + QUITTE".
          lcd_clavier_touche = lcd_clavier_touche_rien;
          lcd_menu1 = 0;
          i2c_pwm_par = 0;                      // PWM - En quittant ce menu, on désinhibe tous les pwm.
          i2c_pwm_sim = 0;                      //
          bitWrite(i2c_pwm_maj, numero_pwm, 1); // Demande de mise à jour avec la valeur reçue du PC.
          i2c_pwm_val_old[numero_pwm] = 254;    // Si l'ancienne valeur <> 254 (majorité des cas).
        }
        else {
          lcd_menu2++;                          // PWM - On a validé l'échelle, on passe au sous menu d'impulsion "normale/inversée" sur le même galva.
          bitWrite(i2c_pwm_maj, numero_pwm, 1); // Demande de mise à jour avec la valeur reçue du PC.
          i2c_pwm_val_old[numero_pwm] = 254;    // Si l'ancienne valeur <> 254 (majorité des cas).
        }
      }
    }

    if (lcd_menu2 == 1) {                       // PWM - Menu2 = 1 : Réglage des galva impulsion inversée.
      if (lcd_menu1_flag == 1) enc_rot_compteur = (bitRead(i2c_pwm_inv, numero_pwm)); // Pour initialiser "enc_rot_compteur" avec la valeur Normale/inverse.
      enc_rot_compt();                          // Vérifie si l'on a tourné l'encodeur rotatif, pour faire défiler la valeur.
      if ((lcd_menu1_flag == 1) || (enc_rot_modif == 1)) {
        lcd_menu1_flag = 0;                     // Pour n'afficher qu'une fois le menu sur l'écran LCD.
        enc_rot_modif  = 0;                     // PWM - On acquitte 'enc_rot_modif'.
        if (bitRead(i2c_pwm_inv, numero_pwm) == 0) { sprintf(lcd_buffer, "%s%2d%s", "GAL:", numero_pwm, "  : NOR   "); }
        else {                                       sprintf(lcd_buffer, "%s%2d%s", "GAL:", numero_pwm, "  : INV   "); }
        LCD.setCursor(0, 0); LCD.print(lcd_buffer);
        if (bitRead(enc_rot_compteur,0) == 0) { sprintf(lcd_buffer, "%s", "IMPULS  NORMALE "); }
        else {                                  sprintf(lcd_buffer, "%s", "IMPULS  INVERSEE"); }
        LCD.setCursor(0, 1); LCD.print(lcd_buffer);
        i2c_pwm_sim = 0;                        // Pas de cas (si) dans ce sous-menu.
        bitWrite(i2c_pwm_par, numero_pwm, 1);   // Demande de mise à jour vers la carte externe.
        bitWrite(i2c_pwm_maj, numero_pwm, 1);   //
      }
      enc_rot_sw();                             // Verifie si l'on a appuyé sur le bouton de l'encodeur rotatif, pour valider la nouvelle valeur.
      if (lcd_clavier_touche == lcd_clavier_touche_ok) { // SRV - '5' = Touche "OK". Même action que le bouton de l'encodeur rotatif.
          lcd_clavier_touche = lcd_clavier_touche_rien;
          enc_rot_modif = 1;
      }
       if ((enc_rot_modif == 1) || (lcd_clavier_touche == lcd_clavier_touche_valide)) {  // On a appuyé sur le bouton 'VALIDE', ou appuyé sur '6' = Touche "VALIDE + QUITTE".
        enc_rot_modif = 0;
        offset_eeprom = 0xA0;
        enc_rot_compteur = enc_rot_compteur & 0x01;           // 'enc_rot_compteur' = 0 ou 1.
        bitWrite(i2c_pwm_inv, numero_pwm, enc_rot_compteur);  // On modifie le type "Normal/inversé", en mémoire et dans l'eeprom.
        if (enc_rot_compteur == 0) {
          EEPROM_24C04.readBlock(offset_eeprom, (uint8_t *) &i, 2);   // On travaille sur les 16 bits !
          bitClear(i, numero_pwm);
          EEPROM_24C04.updateBlock(offset_eeprom, (uint8_t *) &i, 2);
        }
        else {
          EEPROM_24C04.readBlock(offset_eeprom, (uint8_t *) &i, 2);
          bitSet(i, numero_pwm);
          EEPROM_24C04.updateBlock(offset_eeprom, (uint8_t *) &i, 2);
        }
        enc_rot_compteur = 0;
        lcd_menu2 = 0;                           // Pour aller au sous-menu "ECH", prochain galva.
        lcd_menu1_flag = 1;
        i2c_pwm_par = 0;                         // PWM - On change de n° de pwm, on désinhibe tous les pwm. pour que la sortie pwm retrouve la valeur du simu.
        bitWrite(i2c_pwm_maj, (numero_pwm) , 1); // Demande de mise à jour de la sortie précédemment configurée, avec la valeur reçue du PC.
        i2c_pwm_val_old[numero_pwm] = 254;       // Si l'ancienne valeur <> 254 (majorité des cas).
        numero_pwm++;                            // Element suivant = Galva suivant.
        if ((numero_pwm >= i2c_pwm_nbmax) ||(lcd_clavier_touche == lcd_clavier_touche_valide)) { // PWM - Dernier élément ou appuyé sur '6' = Touche "VALIDE + QUITTE" -> Retour au menu (1).
          lcd_clavier_touche = lcd_clavier_touche_rien;
          lcd_menu1 = 0;
          enc_rot_modif=0;
          i2c_pwm_sim = 0;                       //
        }
      }
    }
    if (lcd_clavier_touche == lcd_clavier_touche_valsim) {               // PWM - Touche "Valeur du simulateur" ou 255 : Affichage "(si)".
      if (lcd_menu2 == 0) {                      // PWM - Mode (si) uniquement sur le Paramétrage de l'échelle.
        if (bitRead(i2c_pwm_sim, numero_pwm ) == 0 ) { bitWrite(i2c_pwm_sim, numero_pwm, 1); }
        else                                         { bitWrite(i2c_pwm_sim, numero_pwm, 0); }
      }
      lcd_clavier_touche = lcd_clavier_touche_rien;
      lcd_menu1_flag = 1;
    }
    if (lcd_clavier_touche == lcd_clavier_touche_abraz) {              // PWM - '4' = Touche "ABANDON / RAZ".
      lcd_clavier_touche = lcd_clavier_touche_rien;
      lcd_menu1 = 0;
      lcd_menu1_flag = 0;
      enc_rot_compteur=0;
      enc_rot_modif=1;
      i2c_pwm_par = 0;                          // PWM - En quittant ce menu, on désinhibe tous les pwm.
      i2c_pwm_sim = 0;                          //
      bitWrite(i2c_pwm_maj, numero_pwm, 1);     // Demande de mise à jour avec la valeur reçue du PC.
      i2c_pwm_val_old[numero_pwm] = 254;        // Si l'ancienne valeur <> 254 (majorité des cas).
    }
  }
//-----------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------
// Le menu d'affichage des erreurs et RAZ des erreurs sur l'écran LCD.
  if (lcd_menu1 == 3) {
    enc_rot_compt();         // Vérifie si l'on a tourné l'encodeur rotatif, pour faire défiler les textes d'erreur.
    if ((lcd_menu1_flag == 1) || (enc_rot_modif ==1)) {
      lcd_menu1_flag = 0;
      enc_rot_modif  = 0;
      erreur_valeur[tx_erreur_nbocc-1]=1; // On doit toujours afficher au moins le dernier message d'erreur, même si il n'y a aucune erreur en mémoire.
      if (enc_rot_compteur < 0 ) enc_rot_compteur =0;
      if (enc_rot_compteur >= tx_erreur_nbocc) enc_rot_compteur = tx_erreur_nbocc-1;
      if (enc_rot_positif==0) {
        while ((erreur_valeur[enc_rot_compteur]==0) && (enc_rot_compteur >= 1 )) enc_rot_compteur--; // On affiche que les erreurs en cours.
      }
      while ((erreur_valeur[enc_rot_compteur]==0) && (enc_rot_compteur < tx_erreur_nbocc )) enc_rot_compteur++; // On affiche que les erreurs en cours.
      LCD.setCursor(0, 0); LCD.print(erreur_texte1[enc_rot_compteur]);
      LCD.setCursor(0, 1); LCD.print(erreur_texte2[enc_rot_compteur]);
    }
    if (lcd_clavier_touche == lcd_clavier_touche_valide) {  // ERREUR - '6' = Touche "VALIDE + QUITTE".
      lcd_clavier_touche = lcd_clavier_touche_rien;
      lcd_menu1 = 0;
      lcd_menu1_flag = 0;
      enc_rot_compteur=0;
      enc_rot_modif=1;
    }
    if (lcd_clavier_touche == lcd_clavier_touche_abraz) {  // ERREUR - '4' = Touche "ABANDON / RAZ".
      lcd_clavier_touche = lcd_clavier_touche_rien;
      lcd_menu1 = 0;
      lcd_menu1_flag = 0;
      enc_rot_compteur=0;
      enc_rot_modif=1;
      for (x=0; x<(tx_erreur_nbocc-1) ; x++) erreur_valeur[x]=0;   // Raz des erreurs en mémoire.
      digitalWrite(pin_lcd_led_rouge,LOW);                             // Eteint la led rouge "Erreur".
    }
  }

//-----------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------
// Le menu d'affichage les informations du système sur l'écran LCD.
  if (lcd_menu1 == 4) {
    enc_rot_compt();         // Vérifie si l'on a tourné l'encodeur rotatif, pour faire défiler les textes d'erreur.
//    if ((lcd_menu1_flag == 1) || (enc_rot_modif == 1 || enc_rot_compteur == 0)) {
      enc_rot_modif = 0;
      lcd_menu1_flag = 0;
      if (enc_rot_compteur  < 0 ) enc_rot_compteur=0;
      if (enc_rot_compteur >= 1 ) enc_rot_compteur=1;
      switch (enc_rot_compteur) {
        case 0 : {                                                 // Affiche le temps moyen sur 1000 boucles du programme.
          milli_cpt++;
          if (milli_cpt>=999) {
            milli_cpt = 0;
            milli_actuel  = millis();
            milli_affiche = milli_actuel - milli_old;
            milli_old     = milli_actuel;
            if (milli_affiche < 5000) {                            // On affiche pas de valeur > 5 msec, pour ne pas afficher de valeur erronée au premier passage.
              sprintf(lcd_buffer, "%11ld%s", milli_affiche, " us  ");
              LCD.setCursor(0, 0); LCD.print("DUREE BOUCLE :  ");  // Prend 25 msec de temps cpu !
              LCD.setCursor(0, 1); LCD.print(lcd_buffer);          // Prend 25 msec de temps cpu !
            }
            milli_old = millis();                                  // Donc, on décompte le temps cpu à partir d'ici.
          }
          break;
        }
        case 1 : {                                                 // Affiche la valeur de conversion CAN de lecture des touches du clavier LCD.
          milli_actuel = millis();                                 // Pour quitter ce menu, il faut repasser sur le menu "Affiche le temps cpu".
          if (milli_actuel - milli_old > 200) {                    // Affiche la valeur toutes les 200 msec.
            acq_boutons_lcd();
            if      (lcd_clavier_val > 938 ) {
              sprintf(lcd_buffer, "%s%4d", "938<x<1023: ", lcd_clavier_val); // Pas de touche appuyée.
              sprintf(lcd_buffer_f, "%s", "TOUCHES DU LCD  ");
            }
            else if (lcd_clavier_val > 768 ) {
              sprintf(lcd_buffer, "%s%4d", "768<x<937 : ", lcd_clavier_val);
              sprintf(lcd_buffer_f, "%s", "TOUCHES DU LCD 0");
            }
            else if (lcd_clavier_val > 597 ) {
              sprintf(lcd_buffer, "%s%4d", "597<x<767 : ", lcd_clavier_val);
              sprintf(lcd_buffer_f, "%s", "TOUCHES DU LCD 1");
            }
            else if (lcd_clavier_val > 426 ) {
              sprintf(lcd_buffer, "%s%4d", "426<x<596 : ", lcd_clavier_val);
              sprintf(lcd_buffer_f, "%s", "TOUCHES DU LCD 2");
            }
            else if (lcd_clavier_val > 256 ) {
              sprintf(lcd_buffer, "%s%4d", "256<x<425 : ", lcd_clavier_val);
              sprintf(lcd_buffer_f, "%s", "TOUCHES DU LCD 3");
            }
            else if (lcd_clavier_val >  85 ) {
              sprintf(lcd_buffer, "%s%4d", " 85<x<255 : ", lcd_clavier_val);
              sprintf(lcd_buffer_f, "%s", "TOUCHES DU LCD 4");
            }
            else                             {
              sprintf(lcd_buffer, "%s%4d", "  0<x<84  : ", lcd_clavier_val);
              sprintf(lcd_buffer_f, "%s", "TOUCHES DU LCD 5");
            }
            LCD.setCursor(0, 0); LCD.print(lcd_buffer_f);  //
            LCD.setCursor(0, 1); LCD.print(lcd_buffer);
            milli_old = milli_actuel;
          }
          break;
        }
        case 2 : {
          LCD.setCursor(0, 0); LCD.print("Information pas ");  // Pas encore utilisé.
          LCD.setCursor(0, 1); LCD.print("encore utilisee ");
          break;
        }
        break;
      }
//    }
    if ((lcd_clavier_touche == lcd_clavier_touche_abraz) || (lcd_clavier_touche == lcd_clavier_touche_valide)) {  // '4' = Touche "ABANDON / RAZ" ou '6' = Touche "VALIDE + QUITTE".
      if (enc_rot_compteur !=1) {
        lcd_clavier_touche = lcd_clavier_touche_rien;
        lcd_menu1 = 0;
        lcd_menu1_flag = 0;
        enc_rot_compteur=0;
        enc_rot_modif=1;
      }
    }
  }

//-----------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------
// Le menu d'affichage des valeurs reçues et envoyées au simu, sur l'écran LCD.
  if (lcd_menu1 == 5) {
    enc_rot_compt();            // Vérifie si l'on a tourné l'encodeur rotatif, pour faire défiler les variables à afficher.
    milli_actuel = millis();
    if ((enc_rot_modif == 1) || (milli_actuel - milli_old > 200) || (lcd_menu1_flag == 1) || (enc_rot_compteur >= i2c_srv_nbmax + i2c_pwm_nbmax + 3 + 3)) { // Affiche la valeur toutes les 200 msec.
      if (enc_rot_compteur < 0 ) enc_rot_compteur = 0;           // On remet à jour "milli_old = milli_actuel" juste en fin de "if".
      if (enc_rot_compteur < i2c_srv_nbmax ) {
// Affichage des valeurs des servos sur l'écran LCD.
        numero_srv = enc_rot_compteur;
        i = i2c_srv_val[numero_srv];
        if ((lcd_aff_val_bouge != i) || (lcd_menu1_flag == 1) || (enc_rot_modif == 1)) {   // On sauvegarde la valeur en cours, pour l'afficher que si elle a bougé.
          lcd_menu1_flag = 0;
          lcd_aff_val_bouge = i;
          sprintf(lcd_buffer, "%2d%s", i2c_srv_nbmax, " SERVOMOTEURS ");
          LCD.setCursor(0, 0); LCD.print(lcd_buffer);
          if (lcd_aff_val_simu == 0) {
            if (bitRead(i2c_srv_inv, numero_srv) == 1 ) i = 255 - i; // Course inversée.
            if ((i2c_srv_max[numero_srv]-i2c_srv_min[numero_srv]) <= 256) {  // Pour éviter les dépassements de capacité, tout en gardant une bonne précision.
              m = i2c_srv_max[numero_srv] - i2c_srv_min[numero_srv];         // Si (MAX-MIN <= 256) :     (MAX-MIN)*Valeur reçue/256 + MIN + ((128- |128-Valeur_reçue|*MOY)/128
              m = m * i;                                                     // Sinon               : ((MAX-MIN)/2)*Valeur reçue/128 + MIN + ((128- |128-Valeur_reçue|*MOY)/128
              m = m >> 8;   // Division par 256.
              m = m + i2c_srv_min[numero_srv];                               // m = ((max-min) * val)/256 + min
              j = 128 - abs(128 - i);
              i2c_srv_moy_x = i2c_srv_moy[numero_srv];                       // Multiplication signée : Format entier pour 'i' et 'i2c_srv_moy_x' obligatoire.
              j = j * i2c_srv_moy_x;
              j = j >> 7;   // Division par 128.
              m = m + j;
              mult_391_in = m;
              mult_391();
              sprintf(lcd_buffer, "%s%2d%s%4d", "SRV:", numero_srv, " VAL: ", mult_391_out);
              LCD.setCursor(0, 1); LCD.print(lcd_buffer);
            }
            else  {                                                          // Si (MAX-MIN > 256) : ((MAX-MIN)/2)*Valeur reçue/128 + MIN + ((128- |128-Valeur_reçue|*MOY)/128
              m = i2c_srv_max[numero_srv] - i2c_srv_min[numero_srv];
              m = m >> 1;   // Division par 2.
              m = m * i;
              m = m >> 7;   // Division par 128.
              m = m + i2c_srv_min[numero_srv];                               // m = (((max-min)/2) * val)/128 + min
              j = 128 - abs(128 - i);
              i2c_srv_moy_x = i2c_srv_moy[numero_srv];                       // Multiplication signée : Format entier pour 'i' et 'i2c_srv_moy_x' obligatoire.
              j = j * i2c_srv_moy_x;
              j = j >> 7;   // Division par 128.
              m = m + j;
              mult_391_in = m;
              mult_391();
              sprintf(lcd_buffer, "%s%2d%s%4d", "SRV:", numero_srv, " VAL: ", mult_391_out);
              LCD.setCursor(0, 1); LCD.print(lcd_buffer);
            }
          }
          else {
            sprintf(lcd_buffer, "%s%2d%s%3d", "SRV:", numero_srv, " (si): ", i);
            LCD.setCursor(0, 1); LCD.print(lcd_buffer);
          }
        }
      }
      if ((enc_rot_compteur >= i2c_srv_nbmax) && (enc_rot_compteur < (i2c_srv_nbmax + i2c_pwm_nbmax))) {
// Affichage des valeurs des sorties pwm sur l'écran LCD.
        numero_pwm = enc_rot_compteur - i2c_srv_nbmax;
        y = i2c_pwm_val[numero_pwm];
        if ((lcd_aff_val_bouge != y) || (lcd_menu1_flag == 1) || (enc_rot_modif == 1)) {   // On sauvegarde la valeur en cours, pour l'afficher que si elle a bougé.
          lcd_menu1_flag = 0;
          lcd_aff_val_bouge = y;
          sprintf(lcd_buffer, "%2d%s", i2c_pwm_nbmax, " PWM/GALVA/CT ");
          LCD.setCursor(0, 0); LCD.print(lcd_buffer);
          if (lcd_aff_val_simu == 0) {
            if (i2c_pwm_ech[numero_pwm] == 128) {                      // Mise à jour avec valeur = i2c_pwm_val[x].
              m = i2c_pwm_val[numero_pwm];                             // Calcul d'échelle simplifiée si echelle = 128, val = 16 x valeur reçue.
              m = m << 4;
            }
            else {
              m = i2c_pwm_val[numero_pwm];                             // Valeur à envoyer  = (Valeur_reçue * Echelle)/8.
              m = m*i2c_pwm_ech[numero_pwm];
              m = m >> 3;
              if (m > 4095) m = 4095;                                  // Avec une échelle > 1.000, on peut dépasser 4095.
            }
            y = numero_pwm + 8;                                        // La sortie pwm n°0 commence au n°8 sur la carte.
            sprintf(lcd_buffer, "%s%2d%s%4d", "PWM:", numero_pwm, " VAL: ", m); // On ne prend pas en compte la polarité de l'impulsion. 0 = 0 et 255 = 4095.
            LCD.setCursor(0, 1); LCD.print(lcd_buffer);
          }
          else {
            sprintf(lcd_buffer, "%s%2d%s%3d", "PWM:", numero_pwm, " (si): ", y);
            LCD.setCursor(0, 1); LCD.print(lcd_buffer);
          }
        }
      }
      if ((enc_rot_compteur >= i2c_srv_nbmax + i2c_pwm_nbmax) && (enc_rot_compteur < (i2c_srv_nbmax + i2c_pwm_nbmax + 3))) {
// Affichage des valeurs des sorties tout ou rien sur l'écran LCD.
        numero_out = enc_rot_compteur - i2c_srv_nbmax - i2c_pwm_nbmax;
        if (numero_out == 0) j = i2c_out1_val;
        if (numero_out == 1) j = i2c_out2_val;
//        if (numero_out == 2) j = i2c_out3_val; // Si carte n° installéé.
        if ((lcd_aff_val_bouge != j) || (lcd_menu1_flag == 1) || (enc_rot_modif == 1)) {   // On sauvegarde la valeur en cours, pour l'afficher que si elle a bougé.
          lcd_menu1_flag = 0;
          lcd_aff_val_bouge = j;
          sprintf(lcd_buffer, "%1d%s%1d", 3, " SORTIES*16 : ", numero_out+1);
          LCD.setCursor(0, 0); LCD.print(lcd_buffer);
          for (int i = 0; i < 16; i++) {
            lcd_buffer[i] = (j & 1 << (16-i-1)) ? '1' : '0';            // Conversion entier 16 bits vers binaire format texte.
            lcd_buffer[16]='\0';
          }
          LCD.setCursor(0, 1); LCD.print(lcd_buffer);
        }
      }
      if ((enc_rot_compteur >= i2c_srv_nbmax + i2c_pwm_nbmax + 3) && (enc_rot_compteur < (i2c_srv_nbmax + i2c_pwm_nbmax + 3 + 3))) {
// Affichage des valeurs des entrées sur l'écran LCD.
        numero_in = enc_rot_compteur - i2c_srv_nbmax - i2c_pwm_nbmax - 3;
        if (numero_in == 0) j = i2c_in1_val;
        if (numero_in == 1) j = i2c_in2_val;
        if (numero_in == 2) j = i2c_in3_val;
        if ((lcd_aff_val_bouge != j) || (lcd_menu1_flag == 1) || (enc_rot_modif == 1)) {   // On sauvegarde la valeur en cours, pour l'afficher que si elle a bougé.
          lcd_menu1_flag = 0;
          lcd_aff_val_bouge = j;
          sprintf(lcd_buffer, "%1d%s%1d", 3, " 16*ENTREES : ", numero_in+1);
          LCD.setCursor(0, 0); LCD.print(lcd_buffer);
          for (int i = 0; i < 16; i++) {
            lcd_buffer[i] = (j & 1 << (16-i-1)) ? '1' : '0';          // Conversion entier 16 bits vers binaire format texte.
            lcd_buffer[16]='\0';
          }
          LCD.setCursor(0, 1); LCD.print(lcd_buffer);
        }
      }
      if ((enc_rot_compteur >= i2c_srv_nbmax + i2c_pwm_nbmax + 3 + 3) && (enc_rot_compteur < (i2c_srv_nbmax + i2c_pwm_nbmax + 3 + 3 + 1))) {
// Affichage du caractère de touche enfoncée, envoyée au PC, sur l'écran LCD.
        if ((lcd_menu1_flag == 1) || (enc_rot_modif == 1) || (i2c_in1_maj != 0x0000) || (i2c_in2_maj != 0x0000) || (i2c_in3_maj != 0x0000)){
          lcd_menu1_flag = 0;
          LCD.setCursor(0, 0); LCD.print("EMUL. CLAVIER   ");  //
          if ((lcd_buffer[0] == '0' ) || (lcd_buffer[0] = '1')) { LCD.setCursor(0, 1); LCD.print("                "); } // Glute pour savoir si c'est la première que l'on passe dasn ce menu.
          if (i2c_in1_maj != 0x0000) {
            for (x = 0; x < i2c_in_nbmax; x ++ ) {
              if (bitRead(i2c_in1_maj, x) == 1) {                 // On traite que si demande de maj.
//                if (bitRead(i2c_in1_val, x) == 1) { sprintf(lcd_buffer, "%s%c", "TCH.ENFONCEE-->", i2c_in1_txt[x]); }
//                else                              { sprintf(lcd_buffer, "%s%c", "TCH.RELACHEE:  ", i2c_in1_txt[x]); }
              LCD.setCursor(0, 1); LCD.print(lcd_buffer);
              }
            }
          }
          if (i2c_in2_maj != 0x0000) {
            for (x = 0; x < i2c_in_nbmax; x ++ ) {
              if (bitRead(i2c_in2_maj, x) == 1) {                 // On traite que si demande de maj.
//                if (bitRead(i2c_in2_val, x) == 1) { sprintf(lcd_buffer, "%s%c", "TCH.ENFONCEE-->", i2c_in2_txt[x]); }
//                else                              { sprintf(lcd_buffer, "%s%c", "TCH.RELACHEE:  ", i2c_in2_txt[x]); }
              LCD.setCursor(0, 1); LCD.print(lcd_buffer);
              }
            }
          }
          if (i2c_in3_maj != 0x0000) {
            for (x = 0; x < i2c_in_nbmax; x ++ ) {
              if (bitRead(i2c_in3_maj, x) == 1) {                 // On traite que si demande de maj.
//                if (bitRead(i2c_in3_val, x) == 1) { sprintf(lcd_buffer, "%s%c", "TCH.ENFONCEE-->", i2c_in3_txt[x]); }
//                else                              { sprintf(lcd_buffer, "%s%c", "TCH.RELACHEE:  ", i2c_in3_txt[x]); }
              LCD.setCursor(0, 1); LCD.print(lcd_buffer);
              }
            }
          }
        }
      }
      if (enc_rot_compteur >= i2c_srv_nbmax + i2c_pwm_nbmax + 3 + 3 + 1) { // On a dépassé la dernière données à afficher.
        enc_rot_compteur =  i2c_srv_nbmax + i2c_pwm_nbmax + 3 + 3 + 1 -1;
      }
      enc_rot_modif = 0;
      milli_old = milli_actuel;
    }
    if (lcd_clavier_touche == lcd_clavier_touche_valsim) {              // Touche "Valeur du simulateur"  0 à 255 : Affichage "(si)".
      if (lcd_aff_val_simu == 0 ) { lcd_aff_val_simu = 1; }
      else                        { lcd_aff_val_simu = 0; }
      lcd_clavier_touche = lcd_clavier_touche_rien;
      lcd_menu1_flag = 1;
    }
    if ((lcd_clavier_touche == lcd_clavier_touche_abraz) || (lcd_clavier_touche == lcd_clavier_touche_valide)) {  // '4' = Touche "ABANDON / RAZ" ou '6' = Touche "VALIDE + QUITTE".
      lcd_clavier_touche = lcd_clavier_touche_rien;
      lcd_menu1 = 0;
      lcd_menu1_flag = 1;
      enc_rot_compteur=0;
      enc_rot_modif=0;
    }
  }

//-----------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------
// Le menu de RAZ de l'eeprom est affiché sur l'écran LCD.
// On initialise l'eeprom avec les valeurs par défaut.
// Bouton rotaif, afficher "RAZ :!!! OUI !!!" > Appui sur bouton (Valide) > affiche "CONFIRMER RAZ" > Appui sur bouton (Valide) > Affiche "RAZ EEPROM FAIT".
  if (lcd_menu1 == 6) {
    if (lcd_menu2 == 0) {                 // RAZ EEPROM  - Menu2 = 0.
      enc_rot_compt();                    // Vérifie si l'on a tourné l'encodeur rotatif, pour faire défiler la valeur.
      if ((lcd_menu1_flag == 1) || (enc_rot_modif ==  1)) {
        lcd_menu1_flag = 0;               // Pour n'afficher qu'une fois le menu sur l'écran LCD.
        enc_rot_modif  = 0;               // RAZ EEPROM - On acquitte 'enc_rot_modif'.
        sprintf(lcd_buffer, "%s", "VAL. PAR DEFAUT?");
        LCD.setCursor(0, 0); LCD.print(lcd_buffer);
        if (bitRead(enc_rot_compteur,0) == 0) { sprintf(lcd_buffer, "%s", "RAZ :    NON    "); }
        else                                  { sprintf(lcd_buffer, "%s", "RAZ :!!! OUI !!!"); }
        LCD.setCursor(0, 1); LCD.print(lcd_buffer);
      }
    }
    if (lcd_menu2 == 1) {                 // RAZ EEPROM  - Menu2 = 1.
      if (lcd_menu1_flag == 1) {
        lcd_menu1_flag = 0;               // Pour n'afficher qu'une fois le menu sur l'écran LCD.
        enc_rot_modif  = 0;               // RAZ EEPROM - On acquitte 'enc_rot_modif'.
        sprintf(lcd_buffer, "%s", "!CONFIRMER RAZ !");
        LCD.setCursor(0, 0); LCD.print(lcd_buffer);
        sprintf(lcd_buffer, "%s", "  VALIDE = OK   ");
        LCD.setCursor(0, 1); LCD.print(lcd_buffer);
      }
    }
    if (lcd_menu2 == 2) {                 // RAZ EEPROM  - Menu2 = 2.
      if (lcd_menu1_flag == 1) {
        raz_eeprom();
        lire_eeprom();                    // Ne pas oublier de relire l'eeprom pour mettre à jour les valeurs en mémoire.
        lcd_menu1_flag = 0;               // Pour n'afficher qu'une fois le menu sur l'écran LCD.
        enc_rot_modif  = 0;               // RAZ EEPROM - On acquitte 'enc_rot_modif'.
        sprintf(lcd_buffer, "%s", "RAZ  EEPROM FAIT");
        LCD.setCursor(0, 0); LCD.print(lcd_buffer);
        sprintf(lcd_buffer, "%s", "VAL. PAR DEFAUT ");
        LCD.setCursor(0, 1); LCD.print(lcd_buffer);
      }
    }
    enc_rot_sw();                         // Verifie si l'on a appuyé sur le bouton de l'encodeur rotatif, pour valider la nouvelle valeur.
    if ((enc_rot_modif == 1) || ((lcd_clavier_touche != lcd_clavier_touche_valide) && (lcd_clavier_touche != lcd_clavier_touche_rien))) {
      lcd_clavier_touche = lcd_clavier_touche_rien;  // On a appuyé sur une touche autre que VALIDE, ou l'on appuyé sur le bouton rotatif.
      lcd_menu1 = 0;                                 // On revient au menu principal.
      lcd_menu1_flag = 1;
      enc_rot_compteur = 0;
      enc_rot_modif = 0;
    }
    else if ((lcd_clavier_touche == lcd_clavier_touche_valide)) {  // Touche "VALIDE + QUITTE".
      if (lcd_menu2 == 2 ) lcd_menu1 = 0;            // On était sur le dernier sous menu. On revient au menu principal.
      if ((lcd_menu2 == 0 ) && (bitRead(enc_rot_compteur,0) == 0)) lcd_menu1 = 0; // On était sur le premier sous menu choix "NON". On revient au menu principal.
      lcd_menu2++;
      lcd_menu1_flag = 1;
      enc_rot_compteur = 0;
      enc_rot_modif = 0;
      lcd_clavier_touche = lcd_clavier_touche_rien;
    }
  }
}

// ================================================================================================================================
// ================================================================================================================================
// Sous programme "enc_rot_compt()" : Vérifie si l'encodeur rotatif à tourné.
// Si oui : enc_rot_modif=1 et le compteur "enc_rot_compteur" est mis à jour.
void enc_rot_compt() {
// Lecture des signaux du KY-040 arrivant sur l'arduino.
// On regarde si la ligne CLK a changé d'état.
  enc_rot_etatActuelS1 = digitalRead(pin_commutateur_rot_S1);
  enc_rot_etatActuelS2  = digitalRead(pin_commutateur_rot_S2);
  if(enc_rot_etatActuelS1 != enc_rot_etatPrecedentS1) {
    enc_rot_etatPrecedentS1 = enc_rot_etatActuelS1;
    if(enc_rot_etatActuelS1 == LOW) {
      enc_rot_modif = 1;
      if(enc_rot_etatActuelS1 != enc_rot_etatActuelS2) { enc_rot_compteur++; enc_rot_positif = 1; }
      else { enc_rot_compteur--; enc_rot_positif = 0; }
    }
  }
}
//-----------------------------------------------------
// Sous programme "enc_rot_sw()" : Vérifie si l'on a appuyé sur le bouton de l'encodeur rotatif.
// Si oui : enc_rot_modif=1 et la variable "enc_rot_etatActuelSW" est mise à jour.
void enc_rot_sw() {
// On regarde si la ligne SW a changé d'état.
  enc_rot_etatActuelSW  = digitalRead(pin_commutateur_rot_SW);
  if(enc_rot_etatActuelSW != enc_rot_etatPrecedentSW) {
    enc_rot_etatPrecedentSW = enc_rot_etatActuelSW;
    if (enc_rot_etatActuelSW==1) enc_rot_modif = 1;
  }
}
//-----------------------------------------------------------------------------------------------------------------------------
// Sous programme de multiplication par 3,91. pour une fréquence de 62,5 Hz vers les servomoteurs et 4096 pas.
// 3,91 = 1 / (4096 * 62,5) = 16 msec / 4096 pas
// Entrée, variable renseignée : int mult_391_in
// Sortie, variable renseignée : int mult_391_out = 3,91 * mult_391_in
// Pour éviter une multiplication, on réalise une série de décalages et d'additions plus rapide.
// variable * 3,91 = (variable * 4) - (variable / 16) - (variable / 64).  Ca donne une bonne approximation.
void mult_391() {
  mult_391_out  = mult_391_in;
  mult_391_temp = mult_391_in;
  mult_391_out  = mult_391_out << 2;             // = 4 x mult_391_in
  mult_391_temp = mult_391_temp >> 4;            // /16
  mult_391_out  = mult_391_out - mult_391_temp;
  mult_391_temp = mult_391_temp >> 2;            // /64
  mult_391_out  = mult_391_out - mult_391_temp;  // = 4 x mult_391_in - mult_391_in/16 - mult_391_in/64
}
// Sous programme pour vérifier l'eeprom au démarrage, et si l'eeprom est vierge, écriture des valeurs par défaut.
/* Rangement des données en eeprom. Ce cadrage cadré au foramt hexadécimal, facilite le débug. :
Il reste de la place pour passer à 16 servos et 16 sorties pwm.
0000: AA 55 F0 0F FF FF FF FF FF FF FF FF FF FF FF FF \
0010: FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF  | Entête. AA 55 F0 0F FF = Valeurs écrites pour savoir si l'eeprom est déjà initialisée.
0020: FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF /          Le reste est libre.
0030: 00 00 FF FF FF FF FF FF FF FF FF FF FF FF FF FF > i2c_srv_inv     (2 octets)
0040: 00 02 00 02 00 02 00 02 00 02 00 02 00 02 00 02 \
0050: FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF / i2c_srv_max[8]  (8 entiers = 16 octets) Extensible à 16 servomoteurs.
0060: FF 00 FF 00 FF 00 FF 00 FF 00 FF 00 FF 00 FF 00 \
0070: FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF / i2c_srv_min[8]  (8 entiers = 16 octets) Extensible à 16 servomoteurs.
0080: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 \
0090: FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF / i2c_srv_moy[8]  (8 entiers = 16 octets) Extensible à 16 servomoteurs.
00A0: 00 00 FF FF FF FF FF FF FF FF FF FF FF FF FF FF > i2c_pwm_inv     (2 octets)
00B0: 80 80 80 80 80 80 80 80 80 80 80 80 80 80 80 80 \
00C0: FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF / i2c_pwm_ech[8]  (8 entiers = 16 octets) Extensible à 16 servomoteurs.
00D0: FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF ...Libre...
...
01F0: FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF

Résumé eeprom :
  0x00 - 0x2F -> Entête      : 30 octets
  0x30        -> i2c_srv_inv : 2 octets
  0x40 à 0x5F -> i2c_srv_max : 8 * 2 octets
  0x60 à 0x7F -> i2c_srv_min : 8 * 2 octets
  0x80 à 0x9F -> i2c_srv_moy : 8 * 2 octet
  0xA0        -> i2c_pwm_inv : 2 octets
  0xB0 à 0xCF -> i2c_pwm_ech : 8 * 2 octets
  0xD0 à ...     Libre.
  */
  //-----------------------------------------------------------------------------------------------------------------------------
void init_eeprom() {
  i = EEPROM_24C04.readByte(0); j = EEPROM_24C04.readByte(1); k = EEPROM_24C04.readByte(2); l = EEPROM_24C04.readByte(3);
// Si l'eeprom est initialisée, eeprom(0) à (3), elle contient au début les valeurs suivantes : 0xAA55F00F.
  if (i != 0xAA || j != 0x55 || k != 0xF0 || l != 0x0F) {
//  L'eeprom est vierge, on initialise l'eeprom avec les valeurs par défaut.
//  Entête = 0xAA55F00F.
//  16*servo_max = 510, 16*servo_min = 255, 16*servo_moy = 0, i2c_srv_inv = 0x0000.
//  16*pwm_ech = 128, i2c_pwm_inv = 0x0000.
    erreur_valeur[1] = 1;                        // "EEPROM VIERGE   "
    digitalWrite(pin_lcd_led_rouge, HIGH);           // Allume la led rouge "Erreur".
    raz_eeprom();                                // Ecrit les valeurs par défaut.
  }
}
void raz_eeprom() {
  for (i=0; i < 256; i++) EEPROM_24C04.updateByte(i, 0xFF);
// eeprom de 0 à 29 données d'entête.
   EEPROM_24C04.updateByte(0, 0XAA);  EEPROM_24C04.updateByte(1, 0X55);  EEPROM_24C04.updateByte(2, 0XF0);  EEPROM_24C04.updateByte(3, 0X0F);
// Stockage en eeprom pour les servomoteurs. i2c_srv_inv, i2c_srv_max[], i2c_srv_min[], i2c_srv_moy[].
  offset_eeprom=0x30;
  j = 0;     // = 0x0000
  EEPROM_24C04.updateBlock(offset_eeprom, (uint8_t *) &j, 2);                                           // Sauvegarde de "i2c_srv_inv", course inversée sur 16 bits.
  j = 510;   // = 0x01FE
  offset_eeprom=0x40;
  for (i=0; i < i2c_srv_nbmax; i++) EEPROM_24C04.updateBlock(offset_eeprom + (2*i), (uint8_t *) &j, 2); // Valeur MAX = 2000 µs = 510 en mémoire = Entier.
  j = 255;   // = 0x00FF
  offset_eeprom=0x60;
  for (i=0; i < i2c_srv_nbmax; i++) EEPROM_24C04.updateBlock(offset_eeprom + (2*i), (uint8_t *) &j, 2); // Valeur MIN = 1000 µs = 255 en mémoire = Entier.
  j = 0;     // = 0x0000
  offset_eeprom=0x80;
  for (i=0; i < i2c_srv_nbmax; i++) EEPROM_24C04.updateBlock(offset_eeprom + (2*i), (uint8_t *) &j, 2); // Valeur MOY =    0 µs =   0 en mémoire = Entier.
// Stockage en eeprom pour les galvanomètres. i2c_pwm_inv, i2c_pwm_ech[].
  offset_eeprom=0xA0;
  j = 0;     // = 0x0000
  EEPROM_24C04.updateBlock(offset_eeprom, (uint8_t *) &j, 2);                                           // Sauvegarde de "i2c_srv_inv", course inversée sur 16 bits.;                                     // Sauvegarde de "i2c_pwm_inv", impulsion inversée sur 8 bits.
  j=128;     // = 0x0080
  offset_eeprom=0xB0;
  for (i=0; i < i2c_pwm_nbmax; i++) EEPROM_24C04.updateBlock(offset_eeprom + (2*i), (uint8_t *) &j, 2); // Valeur ECH = 0,5 à 2 => 63 à 255 en mémoire = Entier. 128 => ECH = 1.000.
  offset_eeprom=0xD0;
}
//-----------------------------------------------------------------------------------------------------------------------------
// Sous programme pour lire les valeurs en eeprom au démarrage.
void lire_eeprom() {
// Lecture des valeurs des servomoteurs en eeprom.
  offset_eeprom=0x30;
  EEPROM_24C04.readBlock(offset_eeprom, (uint8_t *) &i2c_srv_inv, 2);    // Lecture de "i2c_srv_inv", course inversée sur 16 bits.
  offset_eeprom=0x40;
  for (i=0; i < i2c_srv_nbmax; i++) EEPROM_24C04.readBlock(offset_eeprom + (2*i), (uint8_t *) &i2c_srv_max[i], 2);  // Valeur MAX = 2000 µs = 510 en mémoire = Entier.
  for (i=0; i < i2c_srv_nbmax; i++) {
    if (i2c_srv_max[i] < 434) i2c_srv_max[i] = 510;
    if (i2c_srv_max[i] > 588) i2c_srv_max[i] = 510;
  }
  offset_eeprom=0x60;
  for (i=0; i < i2c_srv_nbmax; i++) EEPROM_24C04.readBlock(offset_eeprom + (2*i), (uint8_t *) &i2c_srv_min[i], 2);  // Valeur MIN = 1000 µs = 255 en mémoire = Entier.
    for (i=0; i < i2c_srv_nbmax; i++) {
    if (i2c_srv_min[i] < 179) i2c_srv_min[i] = 255;
    if (i2c_srv_min[i] > 332) i2c_srv_min[i] = 255;
  }
  offset_eeprom=0x80;
  for (i=0; i < i2c_srv_nbmax; i++) EEPROM_24C04.readBlock(offset_eeprom + (2*i), (uint8_t *) &i2c_srv_moy[i], 2);  // Valeur MOY =    0 µs =   0 en mémoire = Entier.
    for (i=0; i < i2c_srv_nbmax; i++) {
    if (i2c_srv_moy[i] < -51) i2c_srv_moy[i] = 0;
    if (i2c_srv_moy[i] >  51) i2c_srv_moy[i] = 0;
  }
// Lecture des valeurs des galvanomètres en eeprom.
  offset_eeprom=0xA0;
  EEPROM_24C04.readBlock(offset_eeprom, (uint8_t *) &i2c_pwm_inv, 2);    // Lecture de "i2c_pwm_inv", course inversée sur 16 bits.
  offset_eeprom=0xB0;
  for (i=0; i < i2c_pwm_nbmax; i++) EEPROM_24C04.readBlock(offset_eeprom + (2*i), (uint8_t *) &i2c_pwm_ech[i], 2);   // Valeur ECH = 0,5 à 2 = 63 à 255 en mémoire = Entier.
  for (i=0; i < i2c_pwm_nbmax; i++) {
    if (i2c_pwm_ech[i] < 63)  i2c_pwm_ech[i] = 128;
  }
  offset_eeprom=0xD0;
}
//-----------------------------------------------------------------------------------------------------------------------------
/*Sous programme pour acquisition analogique des boutons de l'écran LCD
  Lecture des boutons du clavier LCD.
  Si le menu d'accueilest affiché, on ne passe pas ici pour éviter d'executer ce code.
  Résistance de rappel = 2,2 K + condensateur de 100 nF à la masse.
  Résistance des boutons = 11K (Touche '1'), 4,7K,  2,2K,  1,1K,  510,    0 (Touche '6').
                           4,16              3,40   2,50   1,66   0,94V   0,00 Volts
  On a une valeur acquise CNA = 1023(Pas de touche), 855, 698, 513, 342, 192 et 0.
  En sortie : "lcd_clavier_touche" = 1 à 6, à remettre à 0 après traitement. La touche n° 6 n'est pas utilisée pour le moment */
void acq_boutons_lcd() {
  lcd_trigger_nb++;
  if (lcd_trigger_nb > 10) { // Pour ne pas passer 25000 fois par seconde dans ce code. On économise 5 µs de cpu par boucle.
    lcd_trigger_nb = 0;
    lcd_clavier_val = analogRead(pin_lcd_clavier_broche);  // Lecture de la tension délivrée par les touches LCD.
    if ((lcd_clavier_val > (lcd_trigger - 5)) && (lcd_clavier_val < (lcd_trigger + 5))) {   // On attend que la tension mesurée ne bouge plus trop.
      if      (lcd_clavier_val > 938 ) lcd_clavier_touche2[0] = lcd_clavier_touche_rien;    // Pas de touche appuyée.
      else if (lcd_clavier_val > 768 ) lcd_clavier_touche2[0] = lcd_clavier_touche_ruf;     // Touche : Réservé utilisation future.
      else if (lcd_clavier_val > 597 ) lcd_clavier_touche2[0] = lcd_clavier_touche_abraz;   // Touche : Abandon ou RAZ.
      else if (lcd_clavier_val > 426 ) lcd_clavier_touche2[0] = lcd_clavier_touche_valsim;  // Touche : Valeur du simulateur PC.
      else if (lcd_clavier_val > 256 ) lcd_clavier_touche2[0] = lcd_clavier_touche_suivant; // Touche : Servo / Galva suivant.
      else if (lcd_clavier_val >  85 ) lcd_clavier_touche2[0] = lcd_clavier_touche_valide;  // Touche : Sauve + Quitte.
      else                             lcd_clavier_touche2[0] = lcd_clavier_touche_ok;      // Touche : Même action que le bouton de l'encodeur rotatif.
      lcd_clavier_touche2[4] = lcd_clavier_touche2[3];
      lcd_clavier_touche2[3] = lcd_clavier_touche2[2];
      lcd_clavier_touche2[2] = lcd_clavier_touche2[1];
      lcd_clavier_touche2[1] = lcd_clavier_touche2[0];
      // Anti-rebond logiciel. On vérifie que que l'on a 5 fois la même touche, sur les 5 derniers échantillonnages.
      // On valide l'appui de la touche, quand elle est relachée => Test : lcd_clavier_touche2[0]==lcd_clavier_touche_rien.
      if ((lcd_clavier_touche2[0] == lcd_clavier_touche2[1]) && (lcd_clavier_touche2[0] == lcd_clavier_touche2[2]) &&
          (lcd_clavier_touche2[0] == lcd_clavier_touche2[3]) && (lcd_clavier_touche2[0] == lcd_clavier_touche2[4])) {
        if ((lcd_clavier_touche2[0] == lcd_clavier_touche_rien) && (lcd_clavier_touche_old != lcd_clavier_touche_rien)) lcd_clavier_touche = lcd_clavier_touche_old;
        lcd_clavier_touche_old = lcd_clavier_touche2[0];
      }
    }
    lcd_trigger = lcd_clavier_val;
  }
}