/* Fichier : Data_Recues_du_PC_TSCRJI_BB7200_SE.ino
             Sous-programme de réception des caractères sur la ligne série.      JLF le 15/02/2025.

Pour la : 
 ######  ######     #######  #####    ###     ###                        #####  ### #     #    ####### #     # ######  ######  #######  #####   #####  
 #     # #     #    #    #  #     #  #   #   #   #     #####  ######    #     #  #  ##   ##    #        #   #  #     # #     # #       #     # #     # 
 #     # #     #        #         # #     # #     #    #    # #         #        #  # # # #    #         # #   #     # #     # #       #       #       
 ######  ######        #     #####  #     # #     #    #    # #####      #####   #  #  #  #    #####      #    ######  ######  #####    #####   #####  
 #     # #     #      #     #       #     # #     #    #    # #               #  #  #     #    #         # #   #       #   #   #             #       # 
 #     # #     #      #     #        #   #   #   #     #    # #         #     #  #  #     #    #        #   #  #       #    #  #       #     # #     # 
 ######  ######       #     #######   ###     ###      #####  ######     #####  ### #     #    ####### #     # #       #     # #######  #####   #####  
                                                                                                                                                                                                                                                                                    
Ce sous-programme recoit les informations envoyées par l'ordinateur.
En modifiant ce sous-programme, il est adaptable pour d'autres simulateurs sur ordinateur.

Cette version est pour 'TS Classic Raildriver and Joystick Interface' avec 'RailsWorks Classic' et la locomotive BB67471 de Yohann.

Si vous réaliser des améliorations matériels ou logicielles, merci de les poster sur le forum RMF pour en faire profiter le plus grand nombre.
Si vous publier cette réalisation avec ou sans améliorations, vous devez publier votre code source.
Ce logiciel est un logiciel libre. Exigence du concepteur : Ne pas modifier la ligne d'affichage "JLF  xx/xx/xxxx" sur l'écran LCD.
On peut modifier ce programme et le diffuser. Dans ce cas, il faut préciser l'origine et donner accès aux sources modifiées.
Définition : Un logiciel libre est un logiciel distribué avec l’intégralité de ses programmes-sources, afin que l’ensemble des utilisateurs qui l’emploient, puissent l’enrichir et le redistribuer à leur tour.
Note : Un logiciel libre n’est pas nécessairement gratuit et les droits de la chaîne des auteurs sont préservés.
Équivalent étranger : free software, open source software.
(Source : Vocabulaire de l’informatique (liste de termes, expressions et définitions adoptés), NOR: CTNX0710138K, J.O n° 93 du 20 avril 2007 page 7078, texte n° 84)
logiciel libre
Par logiciel libre on entend un logiciel qui offre la liberté aux utilisateurs d'exécuter, de copier, de distribuer, d'étudier, de modifier et d'améliorer le logiciel. Plus précisément, elle fait référence à quatre types de liberté pour les utilisateurs du logiciel :
    La liberté d'exécuter le programme, pour tous les usages (liberté 0).
    La liberté d'étudier comment le programme fonctionne et de l'adapter à ses besoins (liberté 1). L'accès au code source est une condition requise.
    La liberté de redistribuer des copies, (liberté 2).
    La liberté d'améliorer le programme et de diffuser les améliorations au public pour en faire profiter toute la communauté (liberté 3). L'accès au code source est une condition requise.

On reçoit les données sous la forme : <Nom du groupe de données:Nom de la donnée:Valeur>
  Exemples:
    <Throttle:Regulator:.000>
    <locochanged:Default_ButtonMapper:DD24500>
    <EmergencyBrake:EmergencyBrake:.000>
    <Ammeter:Ammeter:.000>
    <Speed:SpeedometerKPH:1.125>
    <SpeedLimit:CurrentSpeedLimit:120.700>
    <Speed:SpeedometerKPH:.011>
    <Speed:SpeedometerKPH:80.011>

Quand on reçoit une valeur, pour animer une sortie, on peut animer :
    Les sorties servomoteur, avec une valeur de 0 à 255.
    Les sorties pwm (analogique 0-5 Volts), avec une valeur de 0 à 255.
    Les sorties tout ou rien, avec une valeur de 0 ou 1.
    Dans tous les cas, mettre le bit à '1' avec la ligne "bitWrite(,,1)", pour que programme effectue une mise à jour de la sortie.

  Mettre à jour les tables suivantes :
    i2c_srv_val[x] = 0 à 255 + bitWrite(i2c_srv_maj, x, 1)        (x = 0 à 7)  Servomoteurs, manomètres.
    i2c_pwm_val[x] = 0 à 255 + bitWrite(i2c_pwm_maj, x, 1)        (x = 0 à 7)  Compte-tours, compteur de vitesse, galvanomètre, ampèremètre, voltmètre, jauge.
    bitWrite(i2c_out1_val, x, 0) + bitWrite(i2c_out1_maj, x, 1);  (x = 0 à 15) Voyants.
    bitWrite(i2c_out2_val, x, 0) + bitWrite(i2c_out2_maj, x, 1);  (x = 0 à 15) Voyants.
     (bitWrite(i2c_out3_val, x, 0) + bitWrite(i2c_out3_maj, x, 1);  (x = 0 à 15) Voyants) Carte Optionnelle.
    Si maj_forcee = 1 : Mise à jour forcée des sorties vers les cartes.  */

//-----------------------------------------------------------------------------------------------------------------------------
void Data_Recues_du_PC() {
/* Cette version est pour 'TS Classic Raildriver and Joystick Interface' avec 'RailsWorks Classic'.
   On reçoit sur la liaison série, ce type de trame : <Nom du groupe de données:Nom de la donnée:Valeur>
     qu'il faut répartir en 3 chaines de caractères (80 max) :
       -  buffer_rx[0] = Nom du groupe de données (Texte).
       -  buffer_rx[1] = Nom de la donnée (Texte).
       -  buffer_rx[2] = Valeur au format texte (Nombre entier ou avec virgule).

   A chaque passage, on dépile tous les caractères reçus entre temps.
     On ne fournira une action à réaliser, que lorsque l'on aura reçu une commande complète.
     Indicateurs reçus :  Début de trame = '<'  Séparation de champs début de trame = ':'  Fin de trame = '>'  */

  while(Serial.available() > 0) {
    char car_lu = Serial.read();                         // La fonction 'Serial.read()' retourne un entier !  'car_lu' est déclaré en char.
    if(car_lu == '<') {                                  // On a reçu l'indicateur de début de trame '<'.
      debut_rx = true;                                   // D'office, on initialise tout.
      final_rx = false;                                  // indicateur de début de trame reçue = true, de fin de trame = false.
      buffer_rx_buf = 0;                                 // Initialise compteur de champ et de caractères.
  	  buffer_rx_cpt = 0;                                 //
      buffer_rx[0][0] = '\0';                            // Initialise les chaines de caractères.
      buffer_rx[1][0] = '\0';                            //
      buffer_rx[2][0] = '\0';                            //
    }
    else if(car_lu == '>') {                             // On a reçu l'indicateur de fin de trame '>'.
      if ((debut_rx == true) && (buffer_rx_buf == 2)) {  //
        buffer_rx[buffer_rx_buf][buffer_rx_cpt] = '\0';  // On écrit le caractère 'Null' pour finir la chaine de caractères.
        final_rx = true;                                 // On a bien reçu les trois champs, on valide la réception de fin de trame.
        break;                                           // On sort de la boucle pour traiter cette trame complète, avant de traiter au prochain passage les autres caractères.
      }
      else { debut_rx = false; }                         // On a reçu l'indicateur de fin de trame, sans recevoir celui de début de trame et les 3 champs. On laisse tomber.
    }
    else if(car_lu == ':') {                             // On a reçu l'indicateur de changement de champ de données ':'.
	    if (debut_rx == true) {
        buffer_rx[buffer_rx_buf][buffer_rx_cpt] = '\0';  // On écrit le caractère 'Null' pour finir la chaine de caractères.
        buffer_rx_buf++;
	      buffer_rx_cpt = 0;
        if (buffer_rx_buf >= 3) { debut_rx = false; }    // On vient de lire un troisième indicateur de changement de champ ':', il y a une erreur !
	    }                                                  // On laisse tomber.
    }
    else if (debut_rx == true) {                         // On a déjà reçu l'indicateur de début de trame!
      buffer_rx[buffer_rx_buf][buffer_rx_cpt] = car_lu;  // On a reçu un caractère qui n'est pas un indicateur, on le stocke.
      buffer_rx_cpt++;
      if (buffer_rx_cpt > 78) { debut_rx = false; }      // On vient de lire 78 caractères sans indicateur de fin de trame ! On laisse tomber
    }                                                    // On n'a pas encore reçu l'indicateur de fin de trame. Donc, on jette le caractère reçu.
  }
// On a vidé le buffer de réception, ou l'on a reçu une trame complète.

// -----------------------------------------------------------
  if ((debut_rx == true) && (final_rx==true)) {
    debut_rx = false; final_rx = false;
/* On a reçu une trame de commande.
     -  buffer_rx[0] = Nom du groupe de données (Texte).
     -  buffer_rx[1] = Nom de la donnée (Texte).
     -  buffer_rx[2] = Valeur au format texte (Nombre entier ou avec virgule).
                       Suivant l'utilisation, on convertira cette dernière chaine de caractère, en entier ou en flottant.
                       buffer_rx_valeur  = atoi(buffer_rx[2]); // Conversion du dernier champ : Ascii-> Entier.   Pas de contrôle ! Si Nok valeur = 0!
                       buffer_rx_fvaleur = atof(buffer_rx[2]); // Conversion du dernier champ : Ascii-> Flottant. Pas de contrôle ! Si Nok valeur = 0!*/

// Recopier des lignes au bon endroit, pour débuger une valeur reçue :
//    Serial.print("[Groupe]"); Serial.print(buffer_rx[0]); Serial.print("[Nom]"); Serial.print(buffer_rx[1]); Serial.print("[Valeur]"); Serial.println(buffer_rx_valeur);
//    Serial.print(var_BL); Serial.print(" : "); Serial.print(var_EG1_sim); Serial.print(" : "); Serial.println(bitRead(i2c_in3_val_ref, 0));
//    Serial.print(" x=13 ");  Serial.print(bitRead(i2c_in1_val_ref, 12));Serial.println(bitRead(i2c_in1_val_ref, 13));
//
//=============================================================================================================================
// /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
//=============================================================================================================================
// SORTIES SERVOMOTEURS = MANOMETRES
// Attention mettre un '.' et pas une virgule dans les calculs.
// <  :RE_control:5.50>                                ==> Sortie servo 1 - Aiguille blanche RE   5.5 recu = 255.
    if (!strcmp(buffer_rx[1],"RE_control")) {
      buffer_rx_fvaleur = atof(buffer_rx[2]);           // Conversion du dernier champ : Ascii-> Flottant. Pas de contrôle ! Si Nok valeur = 0 !
      buffer_rx_fvaleur = 46.54*buffer_rx_fvaleur;      // 5.5 Bars => buffer_rx_fvaleur = 256 au maximum (Coéf = 256/5.5). Une seule multiplication en flottant, pour économiser le cpu.
      buffer_rx_valeur  = int(buffer_rx_fvaleur);       //
      buffer_rx_valeur  = min(buffer_rx_valeur, 255);   // Valeur <= 255.
	  i2c_srv_val[0]    = max(buffer_rx_valeur, 0);     // Valeur positive !
      bitWrite(i2c_srv_maj, 0, 1);
    }
// <  :CP_control:5.50>                                ==> Sortie servo 0 - Aiguille rouge CP.  Pour 5,5 l'aiguille rouge est bien à 9 Bars.  5.5 recu = 255.
    else if (!strcmp(buffer_rx[1],"CP_control")) {
      buffer_rx_fvaleur = atof(buffer_rx[2]);           // Conversion du dernier champ : Ascii-> Flottant. Pas de contrôle ! Si Nok valeur = 0 !
      buffer_rx_fvaleur = 46.54*buffer_rx_fvaleur;      // 5.5 Bars => buffer_rx_fvaleur = 256 au maximum (Coéf = 256/5.5). Une seule multiplication en flottant, pour économiser le cpu.
      buffer_rx_valeur  = int(buffer_rx_fvaleur);       //
      buffer_rx_valeur  = min(buffer_rx_valeur, 255);   // Valeur <= 255.
      i2c_srv_val[1]    = max(buffer_rx_valeur, 0);     // Valeur positive !
      bitWrite(i2c_srv_maj, 1, 1);
    }
// <  :CG_control:5.50>                                ==> Sortie servo 2 - Aiguille CG 5.5    recu = 255.
    else if (!strcmp(buffer_rx[1],"CG_control")) {
      buffer_rx_fvaleur = atof(buffer_rx[2]);           // Conversion du dernier champ : Ascii-> Flottant. Pas de contrôle ! Si Nok valeur = 0 !
      buffer_rx_fvaleur = 46.54*buffer_rx_fvaleur;      // 5.5 Bars => buffer_rx_fvaleur = 256 au maximum (Coéf = 256/5.5). Une seule multiplication en flottant, pour économiser le cpu.
      buffer_rx_valeur  = int(buffer_rx_fvaleur);       //
      buffer_rx_valeur  = min(buffer_rx_valeur, 255);   // Valeur <= 255.
      i2c_srv_val[2]    = max(buffer_rx_valeur, 0);     // Valeur positive !
      bitWrite(i2c_srv_maj, 2, 1);
    }
// <  :CF_control:4.00>                                ==> Sortie servo 3 - Aiguille boggie   4.0 recu = 255.
    else if (!strcmp(buffer_rx[1],"CF_control")) {
      buffer_rx_fvaleur = atof(buffer_rx[2]);           // Conversion du dernier champ : Ascii-> Flottant. Pas de contrôle ! Si Nok valeur = 0 !
      buffer_rx_fvaleur = 64*buffer_rx_fvaleur;         // 4 Bars => buffer_rx_fvaleur = 256 au maximum (Coéf = 256/4). Une seule multiplication en flottant, pour économiser le cpu.
      buffer_rx_valeur  = int(buffer_rx_fvaleur);       //
      buffer_rx_valeur  = min(buffer_rx_valeur, 255);   // Valeur <= 255.
      i2c_srv_val[3]    = max(buffer_rx_valeur, 0);     // Valeur positive !
      bitWrite(i2c_srv_maj, 3, 1);
      i2c_srv_val[4]    = max(buffer_rx_valeur, 0);     // Valeur positive !
      bitWrite(i2c_srv_maj, 4, 1);
    }
// <  :CF_control:5.00>                                ==> Sortie servo 4  !!! UTILISE LA MEME SORTIE PWM 3 !!!
//=============================================================================================================================
// /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
//=============================================================================================================================
// SORTIES PWM - GALVANOMETRES
// Attention mettre un '.' et pas une virgule dans les calculs.
// <   :aiguille_UL_C_control:16.00>                   ==> Sortie pwm 0 Tension ligne.  0 à 16. 15.00 reçu = 1,5KV affiché.
    else if(!strcmp(buffer_rx[1],"aiguille_UL_C_control")){// Volts transmis en flottant.  
      buffer_rx_fvaleur = atof(buffer_rx[2]);           // Conversion du dernier champ : Ascii-> Flottant. Pas de contrôle ! Si Nok valeur = 0 !
      buffer_rx_fvaleur = 16*buffer_rx_fvaleur;         // 16 => buffer_rx_fvaleur = 256 au maximum (Coéf = 256/16). Une seule multiplication en flottant, pour économiser le cpu.
      buffer_rx_valeur  = int(buffer_rx_fvaleur);       //
      buffer_rx_valeur  = min(buffer_rx_valeur, 255);   // Valeur <= 255.
      i2c_pwm_val[0]    = max(buffer_rx_valeur, 0);     // Valeur positive !
      bitWrite(i2c_pwm_maj, 0, 1);
    }
// <   :aigu_mot_1_control:2000.00>                     ==> Sorties pwm 1 et pwm 2  Courant moteur. 0 à 2000.
    else if(!strcmp(buffer_rx[1],"aigu_mot_1_control")){// Ampères transmis en flottant. 2000.00 reçu = 2,5KA affiché.
      buffer_rx_fvaleur = atof(buffer_rx[2]);           // Conversion du dernier champ : Ascii-> Flottant. Pas de contrôle ! Si Nok valeur = 0 !
      buffer_rx_fvaleur =  0.128*buffer_rx_fvaleur;     // 2000 => buffer_rx_fvaleur = 256 au maximum (Coéf = 256/2000). Une seule multiplication en flottant, pour économiser le cpu.
      buffer_rx_valeur  = int(buffer_rx_fvaleur);       //
      buffer_rx_valeur  = min(buffer_rx_valeur, 255);   // Valeur <= 255.
      i2c_pwm_val[1]    = max(buffer_rx_valeur, 0);     // Valeur positive !
      bitWrite(i2c_pwm_maj, 1, 1);
      i2c_pwm_val[2]    = max(buffer_rx_valeur, 0);     // Valeur positive !
      bitWrite(i2c_pwm_maj, 2, 1);
	}
// <   :aigu_exc_1_control:2000.00>                     ==> Sorties pwm 3 et pwm 4  Courant +/- moteur. -1000 à +2000.
// Valeur reçue de -1000 (-2000 Amp) à + 2000 (2000 Amp) => Valeur (0-255) = (aigu_exc_1_control + 1000)*(256/3000). Pour un galva avec une aiguille normalement en tout en bas.
    else if(!strcmp(buffer_rx[1],"aigu_exc_1_control")){// Ampères transmis en flottant. 
      buffer_rx_fvaleur = atof(buffer_rx[2]);           // Conversion du dernier champ : Ascii-> Flottant. Pas de contrôle ! Si Nok valeur = 0 !
      buffer_rx_fvaleur = buffer_rx_fvaleur + 1000;     //
	    buffer_rx_fvaleur = 0.085*buffer_rx_fvaleur;      // 3000 => buffer_rx_fvaleur = 256 au maximum (Coéf = 256/3000). Une seule multiplication en flottant, pour économiser le cpu.
      buffer_rx_valeur  = int(buffer_rx_fvaleur);       //
      buffer_rx_valeur  = min(buffer_rx_valeur, 255);   // Valeur <= 255.
      i2c_pwm_val[3]    = max(buffer_rx_valeur, 0);     // Valeur positive !
      bitWrite(i2c_pwm_maj, 3, 1);
      i2c_pwm_val[4]    = max(buffer_rx_valeur, 0);     // Valeur positive !
      bitWrite(i2c_pwm_maj, 4, 1);
	}
// <   :AbsoluteSpeed_control:60.00>                   ==> Sorties pwm 5   Vitesse. Il faut * par 3 la valeur reçue. Affichage 180 Km/h max.
    else if(!strcmp(buffer_rx[1],"AbsoluteSpeed_control")){// Vitesse transmise en flottant.
      buffer_rx_fvaleur = atof(buffer_rx[2]);           // Conversion du dernier champ : Ascii-> Flottant. Pas de contrôle ! Si Nok valeur = 0 !
      buffer_rx_fvaleur =  4.26*buffer_rx_fvaleur;      // 180/3 => buffer_rx_fvaleur = 256 au maximum (Coéf = 256/(180/3). Une seule multiplication en flottant, pour économiser le cpu.
      buffer_rx_valeur  = int(buffer_rx_fvaleur);       //
      buffer_rx_valeur  = min(buffer_rx_valeur, 255);   // Valeur <= 255.
      i2c_pwm_val[5]    = max(buffer_rx_valeur, 0);     // Valeur positive !
      bitWrite(i2c_pwm_maj, 5, 1);
    }
// <   :aigu_VI_control:160.00>                        ==> Sorties pwm 6   Vitesse imposée. 0 à 160.
    else if(!strcmp(buffer_rx[1],"aigu_VI_control")){   // Vitesse transmis en flottant.
      buffer_rx_fvaleur = atof(buffer_rx[2]);           // Conversion du dernier champ : Ascii-> Flottant. Pas de contrôle ! Si Nok valeur = 0 !
      buffer_rx_fvaleur =  1.6*buffer_rx_fvaleur;       // 160 => buffer_rx_fvaleur = 256 au maximum (Coéf = 256/160). Une seule multiplication en flottant, pour économiser le cpu.
      buffer_rx_valeur  = int(buffer_rx_fvaleur);       //
      buffer_rx_valeur  = min(buffer_rx_valeur, 255);   // Valeur <= 255.
      i2c_pwm_val[6]    = max(buffer_rx_valeur, 0);     // Valeur positive !
      bitWrite(i2c_pwm_maj, 6, 1);
    }
//	
// Le galvanomètre de batterie est alimenté directement par la clé des leviers en 5 Volts. Pas de variable envoyée par le simu.
//
//=============================================================================================================================
// /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
//=============================================================================================================================
// LE REGULATEUR DE TRACTION EN MODE ANALOGIQUE
// <   :Regulator:1.00>   Le cas particulier du Cerclo en mode semi-analogique.
    else if(!strcmp(buffer_rx[1],"Regulator")) {        // de 0.00 à 1.00
      buffer_rx_fvaleur = atof(buffer_rx[2]);           // Conversion du dernier champ : Ascii-> Flottant. Pas de contrôle ! Si Nok valeur = 0 !
      regul_val_sim     = 32*buffer_rx_fvaleur;         // regul_val_sim = 0 à 31.     
      regul_val_sim     = min(regul_val_sim , 31);      // Valeur <= 31.
      regul_val_maj = 1;
    }
// LA VITESSE DES ESSUIE-GLACES EN MODE ANALOGIQUE
// <   :potar_EG1_control:1.00>   Le cas particulier de la vitesse des essuie-glaces en mode semi-analogique.
    else if(!strcmp(buffer_rx[1],"potar_EG1_control")) {// de 0.00 à 1.00
      buffer_rx_fvaleur = atof(buffer_rx[2]);           // Conversion du dernier champ : Ascii-> Flottant. Pas de contrôle ! Si Nok valeur = 0 !
      eg_vit_val_sim    = 16*buffer_rx_fvaleur;         // eg_vit_val_sim = 0 à 15.
      eg_vit_val_sim    = min(eg_vit_val_sim, 15);      // Valeur <= 15.
      eg_vit_val_maj = 1;
    }
// LE LEVIER DE TRACTION : Trois contacts utilisés :             F(in1,9)           T(in1,10) VI(in1, 11)
// ON NE TRAITE QUE LES POSITIONS SANS BLOCAGE. SINON TROP DE CONTRAINTES : Levier de déverrouillage bloquant, Cerclo à 0,,,.
//   Positions du levier de traction     |  nom de variable    |    F    |   O     |   T     |   VI     |
//   ------------------------------------+---------------------+---------+---------+---------+----------+-----------------------------------------
//   Retour position levier traction     |  traction_control   |    1    |   0,666 |   0,333 | variable | Pas significatif si L_VI_control = 1
//   Retour positio aiguill compteur VI  |  aigu_VI_control    |    0    |   0     |   0     |  0 à 160 |  Vitesse Imposée en km/h
//   Retour valeur du potentiomètre      |  L_VI_control       |    0    |   0     |   0     |    1     |  1 = Levier sur Vitesse Imposée en cours
//   Retour info si position VI actif    |  visi_trac_control  |variable |variable |variable |  0 à 10  |  0 = VI minimum,   10 = VI maximum
// <   :L_VI_control:1.00>  Le cas particulier du levier de traction à 4 positions.
/*    else if (!strcmp(buffer_rx[1],"L_VI_control"))  {
      buffer_rx_fvaleur = atof(buffer_rx[2]);                               // Obligé de passer par un nombre flottant.
      if (buffer_rx_fvaleur > 0.98) {
        bitWrite(i2c_in1_val_sim,  9, 0); bitWrite(i2c_in1_val_sim, 10, 1); bitWrite(i2c_in1_val_sim, 11, 1);
        bitWrite(i2c_in1_maj_sim,  9, 1); bitWrite(i2c_in1_maj_sim, 10, 1); bitWrite(i2c_in1_maj_sim, 11, 1); // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
      }
      if (buffer_rx_fvaleur < 0.02) {     bitWrite(i2c_in1_val_sim, 11, 0); bitWrite(i2c_in1_maj_sim, 11, 1); // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
      }
    }*/
// <   :traction_control:1.00>  Le cas particulier du levier de traction à 4 positions.
    else if (!strcmp(buffer_rx[1],"traction_control")) {                    //
      buffer_rx_fvaleur = atof(buffer_rx[2]);                               // Obligé de passer par un nombre flottant.
      if     (((buffer_rx_fvaleur > 0.98) && (bitRead(i2c_in1_val, 9) == 0))) { bitWrite(i2c_in1_val_sim, 9, 1); bitWrite(i2c_in1_val_sim, 10, 0); // Sens F -> 0 uniquement.
                bitWrite(i2c_in1_maj_sim, 9, 1); bitWrite(i2c_in1_maj_sim, 10, 1); // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
      }
      else if ((buffer_rx_fvaleur > 0.64) && (buffer_rx_fvaleur < 0.68)) { bitWrite(i2c_in1_val_sim, 9, 0); bitWrite(i2c_in1_val_sim, 10, 0); // 0
                bitWrite(i2c_in1_maj_sim, 9, 1); bitWrite(i2c_in1_maj_sim, 10, 1); // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
      }
      else if  (buffer_rx_fvaleur < 0.35)                           { bitWrite(i2c_in1_val_sim, 9, 0); bitWrite(i2c_in1_val_sim, 10, 1); // T
                bitWrite(i2c_in1_maj_sim, 9, 1); bitWrite(i2c_in1_maj_sim, 10, 1); // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
      }
    }
//
//=============================================================================================================================
// /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
//=============================================================================================================================
// SORTIES 1 TOUT OU RIEN : On peut utiliser la fonction "buffer2_compare_int_maj_out" car buffer_rx[2] est toujours un entier 0 ou 1 pour un voyant.
// --------------------------------------------------------------------------
// Boite à pictogrammes
    else if (!strcmp(buffer_rx[1],"LS_DJ_control"))          buffer2_compare_int_maj_out(out1,  0); // <   :LS_DJ_control:1>       Disjoncteur
    else if (!strcmp(buffer_rx[1],"LS_GR_control"))          buffer2_compare_int_maj_out(out1,  1); // <   :LS_GR_control:1>  
    else if (!strcmp(buffer_rx[1],"LS_PAT_control"))         buffer2_compare_int_maj_out(out1,  2); // <   :LS_PAT_control:1>      Escargot
//  else if (!strcmp(buffer_rx[1],"????????????"))           buffer2_compare_int_maj_out(out1,  3); // <   :????:1>                CB
    else if (!strcmp(buffer_rx[1],"LS_SAB_control"))         buffer2_compare_int_maj_out(out1,  4); // <   :LS_SAB_control:1>      Sablage en cours
    else if (!strcmp(buffer_rx[1],"LS_FAM_control"))         buffer2_compare_int_maj_out(out1,  5); // <   :LS_FAM_control:1>      ?
    else if (!strcmp(buffer_rx[1],"LS_pictos_control"))      buffer2_compare_int_maj_out(out1,  6); // <   :LS_pictos_control:1>   Moteur isolé
    else if (!strcmp(buffer_rx[1],"LS_FEP_control"))         buffer2_compare_int_maj_out(out1,  7); // <   :LS_FEP_control:1>      ?
    else if (!strcmp(buffer_rx[1],"LS_pictos2_control"))     buffer2_compare_int_maj_out(out1,  8); // <   :LS_pictos2_control:1>  ?
//-------------    
    else if (!strcmp(buffer_rx[1],"Lum_SUR_control"))        buffer2_compare_int_maj_out(out1, 10); // <   :Lum_SUR_control:1>     Témoin Surcharge allumé.  
    else if (!strcmp(buffer_rx[1],"SAL_control"))            buffer2_compare_int_maj_out(out1, 11); // <   :SAL_control:1>         Témoin Signal alarme - Warning feux clignotant.  
//
//=============================================================================================================================
// /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
//=============================================================================================================================
// SORTIES 2 TOUT OU RIEN : On doit utiliser la fonction "buffer2_compare_float_maj_out" car buffer_rx[2] est souvent un flottant entre 0.00 et 1.00.
    else if (!strcmp(buffer_rx[1],"son_RA_control"))          buffer2_compare_int_maj_out(out2,  0); // <   :son_RA_control:1>   Alarme sonore RA
    else if (!strcmp(buffer_rx[1],"son_MA_control"))          buffer2_compare_int_maj_out(out2,  1); // <   :son_MA_control:1>   Alarme sonore MA
//
//=============================================================================================================================02
// /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
//=============================================================================================================================
// VARIABLE DE FONCTIONNALITES
// <locochanged:   :jCC72000>                                 ==> On a changé de locomotive, on remet à zéro tous les équipements.
    else if (!strcmp(buffer_rx[0],"locochanged")) {            //
      for (x = 0; x < i2c_srv_nbmax; x ++) i2c_srv_val[x] = 0; // Initialise la valeur des servomoteurs.
      i2c_srv_maj  = 0xFF;                                     //
      for (x = 0; x < i2c_pwm_nbmax; x ++) i2c_pwm_val[x] = 0; // Initialise la valeur des sorties pwm.
	    i2c_pwm_maj  = 0xFF;                                     //
      i2c_out1_val = 0x0000; i2c_out1_maj = 0xFFFF;            // Initialise la valeur des sorties 0/1.
      i2c_out2_val = 0x0000; i2c_out2_maj = 0xFFFF;            //
    }
//
//=============================================================================================================================
// /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
//=============================================================================================================================
// ENTREES 2 - LE BLOC D'INTERRUPTEURS EN ENTREES IN2.
// Sur le pupitre, il y a des interrupteurs, par exemple pour activer le disjoncteur.
// Quand on bascule l'interrupteur, on ne sait pas en envoyant la touche 'y', si le disjoncteur va se fermer ou s'ouvrir.
// On récupére la valeur du simulateur, pour comparer à la position sur le pupitre.
// --------------------------------------------------------
// Obligé de passer par un nombre flottant, car la valeur passe progressivement de 0.0 à 1.00. La comparaison et demande de mise à jour, se fera automatiquement.

    else if (!strcmp(buffer_rx[1],"BP_URG_control"))                  buffer2_compare_float_maj_sim(in1,  3); // <   :BP_URG_control:1>                     Info en retour sur le bouton rouge - Frein d'urgence. La valeur passe progressivement de 0.0 à 1.00.
//-------------    
    else if (!strcmp(buffer_rx[1],"inter_DJ_control"))                buffer2_compare_float_maj_sim(in2,  1); // <   :inter_DJ_control:1>                   Info en retour sur le Disjoncteur. La valeur passe progressivement de 0.0 à 1.00.
    else if (!strcmp(buffer_rx[1],"inter_compresseur_auto_control"))  buffer2_compare_float_maj_sim(in2,  3); // <   :inter_compresseur_auto_control:1>     Info en retour sur l'interrupteur Compresseur Auto. La valeur passe progressivement de 0.0 à 1.00.
    else if (!strcmp(buffer_rx[1],"inter_compresseur_direct_control"))buffer2_compare_float_maj_sim(in2,  4); // <   :inter_compresseur_direct_control:1>   Info en retour sur l'interrupteur Compresseur Direct. La valeur passe progressivement de 0.0 à 1.00.
    else if (!strcmp(buffer_rx[1],"inter_ventilos_control"))          buffer2_compare_float_maj_sim(in2,  5); // <   :inter_ventilos_control:1>             Info en retour sur l'interrupteur des Ventilateurs. La valeur passe progressivement de 0.0 à 1.00.
    else if (!strcmp(buffer_rx[1],"inter_chauffage_control"))         buffer2_compare_float_maj_sim(in2,  6); // <   :inter_chauffage_control:1>            Info en retour sur l'interrupteur du chauffage. La valeur passe progressivement de 0.0 à 1.00.
    else if (!strcmp(buffer_rx[1],"inter_cabine_control"))            buffer2_compare_float_maj_sim(in2,  8); // <   :inter_cabine_control:1>               Info en retour sur l'éclairage de la cabine. La valeur passe progressivement de 0.0 à 1.00.
    else if (!strcmp(buffer_rx[1],"BP_horaire_control"))              buffer2_compare_float_maj_sim(in2,  9); // <   :BP_horaire_control:1>                 Info en retour sur l'éclairage de la fiche horaire. La valeur passe progressivement de 0.0 à 1.00.
    else if (!strcmp(buffer_rx[1],"inter_lum_pup_control"))           buffer2_compare_float_maj_sim(in2, 10); // <   :inter_lum_pup_control:1>              Info en retour sur l'éclairage du pupitre. La valeur passe progressivement de 0.0 à 1.00.
    else if (!strcmp(buffer_rx[1],"inter_fanal_G_control"))           buffer2_compare_float_maj_sim(in2, 11); // <   :inter_fanal_G_control:1>              Info en retour sur l'interrupteur fanal Gauche. La valeur passe progressivement de 0.0 à 1.00.
    else if (!strcmp(buffer_rx[1],"inter_fanal_D_control"))           buffer2_compare_float_maj_sim(in2, 12); // <   :inter_fanal_D_control:1>              Info en retour sur l'interrupteur fanal Droit. La valeur passe progressivement de 0.0 à 1.00.
    else if (!strcmp(buffer_rx[1],"inter_projecteurs_control"))       buffer2_compare_float_maj_sim(in2, 13); // <   :inter_projecteurs_control:1>          Info en retour sur l'interrupteur des projecteurs. La valeur passe progressivement de 0.0 à 1.00.
    else if (!strcmp(buffer_rx[1],"inter_annul_VA_control"))          buffer2_compare_float_maj_sim(in2, 14); // <   :inter_annul_VA_control:1>             Info en retour sur l'interrupteur annulation VACMA. La valeur passe progressivement de 0.0 à 1.00.
    else if (!strcmp(buffer_rx[1],"inter_essai_VA_control"))          buffer2_compare_float_maj_sim(in2, 15); // <   :inter_essai_VA_control:1>             Info en retour sur l'inter essais VACMA. La valeur passe progressivement de 0.0 à 1.00.
//-------------
    else if (!strcmp(buffer_rx[1],"cle_BL_control"))                  buffer2_compare_float_maj_sim(in3,  0); // <   :cle_BL_control:1>                     Info en retour sur l'interrupteur boite à leviers. La valeur passe progressivement de 0.0 à 1.00. 
    else if (!strcmp(buffer_rx[1],"Wipers"))                          buffer2_compare_float_maj_sim(in3,  3); // <   :Wipers:1>                             Info en retour sur l'interrupteur essuie-glaces. La valeur passe progressivement de 0.0 à 1.00.
//
//=============================================================================================================================
// /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
//=============================================================================================================================
// LES INTERRUPTEURS A PLUSIEURS POSITIONS
//
// <   :FD_control:1.1>                                 ==> FD_control - Interrupteur à 3 positions - Grand Levier frein direct.
//   i2c_in1_val(4)    i2c_in1_val(5)  Position du frein direct            valeur FD_control
//          1                 0            = Desserrage en avant                  -0.25
//          0                 1            = Serrage    en arrière                 0.40
//          0                 0            = Position neutre au centre             0.10
    else if (!strcmp(buffer_rx[1],"FD_control")) {                                  // Grand levier de frein direct à trois positions.
      buffer_rx_fvaleur = atof(buffer_rx[2]);                                       // Obligé de passer par un nombre flottant.
      if       (buffer_rx_fvaleur >  0.38)                                { bitWrite(i2c_in1_val_sim, 4, 0); bitWrite(i2c_in1_val_sim, 5, 1);
                bitWrite(i2c_in1_maj_sim,  4, 1); bitWrite(i2c_in1_maj_sim,  5, 1); // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
      }
      else if  (buffer_rx_fvaleur < -0.23)                                { bitWrite(i2c_in1_val_sim, 4, 1); bitWrite(i2c_in1_val_sim, 5, 0); 
                bitWrite(i2c_in1_maj_sim,  4, 1); bitWrite(i2c_in1_maj_sim,  5, 1); // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
      } 
      else if ((buffer_rx_fvaleur >  0.08) && (buffer_rx_fvaleur < 0.12)) { bitWrite(i2c_in1_val_sim, 4, 0); bitWrite(i2c_in1_val_sim, 5, 0); 
                bitWrite(i2c_in1_maj_sim,  4, 1); bitWrite(i2c_in1_maj_sim,  5, 1); // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
      }
    }
//
// <   :inverseur_control:1>                            ==> inverseur_control - Interrupteur à 3 positions - Levier inverseur de traction.
//   i2c_in1_val(12)   i2c_in1_val(13)  Position de l'inverseur de traction    valeur inverseur_control
//          1                 0             = Position en avant +                    1
//          0                 1             = Position en arrière -                 -1
//          0                 0             = Position neutre au centre              0
    else if (!strcmp(buffer_rx[1],"inverseur_control")) {                           //
      buffer_rx_fvaleur = atof(buffer_rx[2]);                                       // Obligé de passer par un nombre flottant.
      if       (buffer_rx_fvaleur >  0.98)                                { bitWrite(i2c_in1_val_sim, 12, 1); bitWrite(i2c_in1_val_sim, 13, 0);
                bitWrite(i2c_in1_maj_sim, 12, 1); bitWrite(i2c_in1_maj_sim, 13, 1); // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
      }
      else if  (buffer_rx_fvaleur < -0.98)                                { bitWrite(i2c_in1_val_sim, 12, 0); bitWrite(i2c_in1_val_sim, 13, 1);
                bitWrite(i2c_in1_maj_sim, 12, 1); bitWrite(i2c_in1_maj_sim, 13, 1); // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
      }
      else if ((buffer_rx_fvaleur > -0.02) && (buffer_rx_fvaleur < 0.02)) { bitWrite(i2c_in1_val_sim, 12, 0); bitWrite(i2c_in1_val_sim, 13, 0);
                bitWrite(i2c_in1_maj_sim, 12, 1); bitWrite(i2c_in1_maj_sim, 13, 1); // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
      }
    }
//
// <   :cle_panto_continu_control, :1>                  ==> cle_panto_continu_control - Interrupteur à 4 positions - Pantographe.
//   i2c_in3_val(12)   i2c_in3_val(13)   i2c_in3_val(14)  Position pantographes    valeur cle_panto_continu_control
//          1                 1                 1              =   AV                       1.000
//          0                 1                 1              = AV + AR                    0,666
//          0                 0                 1              =   AR                       0,333
//          0                 0                 0              =    0                       0.000
    else if (!strcmp(buffer_rx[1],"cle_panto_continu_control")) {                   //
      buffer_rx_fvaleur = atof(buffer_rx[2]);                                       // Obligé de passer par un nombre flottant.
      if       (buffer_rx_fvaleur > 0.98)                                { bitWrite(i2c_in3_val_sim, 12, 1); bitWrite(i2c_in3_val_sim, 13, 1); bitWrite(i2c_in3_val_sim, 14, 1);
                bitWrite(i2c_in3_maj_sim, 12, 1); bitWrite(i2c_in3_maj_sim, 13, 1); bitWrite(i2c_in3_maj_sim, 14, 1); // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
      }
      else if  (buffer_rx_fvaleur < 0.02)                                { bitWrite(i2c_in3_val_sim, 12, 0); bitWrite(i2c_in3_val_sim, 13, 0); bitWrite(i2c_in3_val_sim, 14, 0);
                bitWrite(i2c_in3_maj_sim, 12, 1); bitWrite(i2c_in3_maj_sim, 13, 1); bitWrite(i2c_in3_maj_sim, 14, 1); // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
      }
      else if ((buffer_rx_fvaleur > 0.31) && (buffer_rx_fvaleur < 0.35)) { bitWrite(i2c_in3_val_sim, 12, 0); bitWrite(i2c_in3_val_sim, 13, 0); bitWrite(i2c_in3_val_sim, 14, 1);
                bitWrite(i2c_in3_maj_sim, 12, 1); bitWrite(i2c_in3_maj_sim, 13, 1); bitWrite(i2c_in3_maj_sim, 14, 1); // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
      }
      else if ((buffer_rx_fvaleur > 0.64) && (buffer_rx_fvaleur < 0.68)) { bitWrite(i2c_in3_val_sim, 12, 0); bitWrite(i2c_in3_val_sim, 13, 1); bitWrite(i2c_in3_val_sim, 14, 1);
                bitWrite(i2c_in3_maj_sim, 12, 1); bitWrite(i2c_in3_maj_sim, 13, 1); bitWrite(i2c_in3_maj_sim, 14, 1); // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
      }
    }
//
// <   :cle_frein_control:1>                              ==> cle_frein_control - Interrupteur à 4 positions - Clé de frein.
//   i2c_in3_val(5)    i2c_in3_val(6)    i2c_in3_val(7)  Position clé de frein    valeur cle_frein_control
//          1                 1                 1            =  ISOLEMENT                 1.000                           RETRAIT
//          0                 1                 1            =   RETRAIT                  0,666                     NEUTRE   O   ISOLEMENT
//          0                 0                 1            =   NEUTRE                   0,333                           SERVICE
//          0                 0                 0            =   SERVICE                  0.000
    else if (!strcmp(buffer_rx[1],"cle_frein_control")) {                           //
      buffer_rx_fvaleur = atof(buffer_rx[2]);                                       // Obligé de passer par un nombre flottant.
      if       (buffer_rx_fvaleur > 0.98)                                { bitWrite(i2c_in3_val_sim, 5, 1); bitWrite(i2c_in3_val_sim, 6, 1); bitWrite(i2c_in3_val_sim, 7, 1);
                bitWrite(i2c_in3_maj_sim, 5, 1); bitWrite(i2c_in3_maj_sim, 6, 1); bitWrite(i2c_in3_maj_sim, 7, 1); // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
      }
      else if  (buffer_rx_fvaleur < 0.02)                                { bitWrite(i2c_in3_val_sim, 5, 0); bitWrite(i2c_in3_val_sim, 6, 0); bitWrite(i2c_in3_val_sim, 7, 0);
                bitWrite(i2c_in3_maj_sim, 5, 1); bitWrite(i2c_in3_maj_sim, 6, 1); bitWrite(i2c_in3_maj_sim, 7, 1); // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
      }
      else if ((buffer_rx_fvaleur > 0.31) && (buffer_rx_fvaleur < 0.35)) { bitWrite(i2c_in3_val_sim, 5, 0); bitWrite(i2c_in3_val_sim, 6, 0); bitWrite(i2c_in3_val_sim, 7, 1);
                bitWrite(i2c_in3_maj_sim, 5, 1); bitWrite(i2c_in3_maj_sim, 6, 1); bitWrite(i2c_in3_maj_sim, 7, 1); // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
      }
      else if ((buffer_rx_fvaleur > 0.64) && (buffer_rx_fvaleur < 0.68)) { bitWrite(i2c_in3_val_sim, 5, 0); bitWrite(i2c_in3_val_sim, 6, 1); bitWrite(i2c_in3_val_sim, 7, 1);
                bitWrite(i2c_in3_maj_sim, 5, 1); bitWrite(i2c_in3_maj_sim, 6, 1); bitWrite(i2c_in3_maj_sim, 7, 1); // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
      }
    }
//
//=============================================================================================================================
// /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
//=============================================================================================================================
// TRANSFERT DES ORDRES DU PC VERS LE KVB, sur la LIAISON TX3.
// -----------------------------------------------------------
// Si le simulateur a envoyé une commande pour le KVB, on la traite ici.
// On peut mettre deux ordres pour une même commande, pour être compatible avec plusieurs locomotives.
/* L'afficheur :                                           Les voyants :
 b => [   ][ b ]                                        0 =>  (V)   Eteint     1 =>  (V)   Allumée
 c => [   ][   ] Efface que l'afficheur [   ][   ]      2 =>  (FU)  Eteint     3 =>  (FU)  Allumée
 e => [   ][===]                                        4 => (SOL)  Eteint     5 => (SOL)  Allumée
 F => [   ][ F ]                                        6 => (ENG)  Eteint     7 => (ENG)  Allumée
 l => [ L ][   ]                                        g => [VAL]  Eteint     G => [VAL]  Allumée     A => [VAL]  Clignotant
 L => [   ][ L ]                                        h =>  [MV]  Eteint     H =>  [MV]  Allumée
 m => [---][---] Moins                                  i =>  [FC]  Eteint     I =>  [FC]  Allumée
 M => [---][---] Moins Clignotant                       j => (LSSF) Eteint     J => (LSSF) Fixe        C => (LSSF) Clignotant
 p => [ p ][   ]                                        k => Arret  klaxon     K => Klaxon actif sur haut-parleur
 P => [   ][ P ]                                        q => Arret  buzzer     Q => Buzzer actif
 t => [888][888] Affiche 888 888
 U => [   ][ FU] fU
 y => [ 00][   ] 2 Zéro
 Y => [000][   ] 3 Zéro
 x => [---][ 00] Moins + 2 Zéro
 z => [   ][ 00] 2 Zéro Clignotant
 Z => [   ][ 00] 2 Zéro Fixe                            Il existe d'autres commandes pour le KVB, mais pas employées ici. (Voir notice du KVB).
 T => Séquence de test.
 s => Séquence d'initialisation du KVB, à la mise sous tension du pupitre. */

// -----------------------------------------------------------
// KVB.
// <KVB:XXXXXX:1>                                        ==> Envoi d'un ordre vers le KVB, sur la liaison série n°3.
#ifdef FONCTION_KVB                                       // FONCTION : Compilation conditionnelle, si KVB déclaré.
    if(!strcmp(buffer_rx[0],"KVB")) {
      buffer_rx_valeur = atoi(buffer_rx[2]);              // Valeur = 0 ou 1.
      if     (!strcmp(buffer_rx[1],"KVB_BP_VAL_lumiere_control"))  {if(buffer_rx_valeur == 1) KVB_car_vers_KVB = 'G'; else KVB_car_vers_KVB = 'g'; }
      else if(!strcmp(buffer_rx[1],"KVB_BP_CAR_lumiere_control"))  {if(buffer_rx_valeur == 1) KVB_car_vers_KVB = 'I'; else KVB_car_vers_KVB = 'i'; }
      else if(!strcmp(buffer_rx[1],"KVB_BP_VIO_lumiere_control"))  {if(buffer_rx_valeur == 1) KVB_car_vers_KVB = 'H'; else KVB_car_vers_KVB = 'h'; }
      else if(!strcmp(buffer_rx[1],"Autotest_KVB_control"))        {if(buffer_rx_valeur == 0) KVB_car_vers_KVB = 'O';   //  [   ][   ] + lampes SOL et ENG éteintes.
                                                               else if(buffer_rx_valeur == 1) KVB_car_vers_KVB = 'n';   //  [ PA][400] + Buzzer
                                                               else if(buffer_rx_valeur == 2) KVB_car_vers_KVB = 'N';   //  [ UC][512] + lampes SOL et ENG allumes + Alarme HP.
                                                               else if(buffer_rx_valeur == 3) KVB_car_vers_KVB = 'o'; } //               lampes SOL et ENG allumes + Buzzer + Alarme HP.
      else if(!strcmp(buffer_rx[1],"KVB_LS_SF_control"))           {if(buffer_rx_valeur == 1) KVB_car_vers_KVB = 'J'; else KVB_car_vers_KVB = 'j'; }
      else if(!strcmp(buffer_rx[1],"KVB_LS_V_control"))            {if(buffer_rx_valeur == 1) KVB_car_vers_KVB = '1'; else KVB_car_vers_KVB = '0'; }
      else if(!strcmp(buffer_rx[1],"KVB_LS_FU_control"))           {if(buffer_rx_valeur == 1) KVB_car_vers_KVB = '3'; else KVB_car_vers_KVB = '2'; }
      else if(!strcmp(buffer_rx[1],"bip_V_control"))               {if(buffer_rx_valeur == 1) KVB_car_vers_KVB = 'Q'; else KVB_car_vers_KVB = 'q'; }
      else if(!strcmp(buffer_rx[1],"KVB_visu_control"))            {if(buffer_rx_valeur == 0) KVB_car_vers_KVB = 'c';   //  [   ][   ]
                                                               else if(buffer_rx_valeur == 1) KVB_car_vers_KVB = 'm';   //  [---][---]
                                                               else if(buffer_rx_valeur == 3) KVB_car_vers_KVB = 'T';   //  [888][888] Séquence Test.
                                                               else if(buffer_rx_valeur == 8) KVB_car_vers_KVB = 't';   //  [888][888]
                                                               else if(buffer_rx_valeur == 9) KVB_car_vers_KVB = 'F'; } //  [   ][ F ]
    }
#endif
  }
//
//=============================================================================================================================
// /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
//=============================================================================================================================
// Toutes les xxx msec, on vérifie périodiquement si les interrupteurs du simulateur, sont en accord avec ceux du pupitre.
// i2c_in1_val     = Valeur de l'entrée sur le pupitre physique.
// i2c_in1_val_ref = Dernière valeur mémorisée sur le pupitre physique.
// i2c_in1_val_sim = Valeur envoyée par l'ordinateur.
// Si ce n'est pas égal, on demande une mise à jour en activant un bit dans "i2c_in1_maj".
// On ne le fait pas pour toutes les valeurs. Il faut que la valeur a été reçue. (i2c_in1_maj_sim = 1).
// On le fait pour les interrupteurs, pas pour les boutons poussoirs.
//
  if (ic2_in_comp_ref_milli > millis() + duree_ic2_in_comp_ref)   ic2_in_comp_ref_milli = millis() + duree_ic2_in_comp_ref; // On limite le delai maximum d'attente, de la prochaine comparaison.
  if (millis() > ic2_in_comp_ref_milli) {
  ic2_in_comp_ref_milli = millis() + duree_ic2_in_comp_ref;  // On repassera ici dans "duree_ic2_in_comp_ref" msec.
//
    if (regul_val_maj == 1) {                                      // Pour le Cerclo, régulateur de traction.
      if (touche_etat[touche_num_en_cours] == touche_etat_fait) {  // Pas de régulation du cerclo, tand que l'on n'a pas envoyé toutes les touches dans la file d'attente.
        regul_val_ref = regul_val_sim;
        regul_val_maj = 0;
      }
    } 
    if (eg_vit_val_maj == 1) {                                     // Pour la vitesse des essuie-glaces.
      if (touche_etat[touche_num_en_cours] == touche_etat_fait) {  // Pas de régulation des esssuie-glaces, tand que l'on n'a pas envoyé toutes les touches dans la file d'attente.
        eg_vit_val_ref = eg_vit_val_sim;
        eg_vit_val_maj = 0;
      }
    } 
    if (i2c_in1_maj_sim != 0x0000) {
      for ( x = 0; x < i2c_in_nbmax; x++) {
        if (bitRead(i2c_in1_maj_sim,  x) == 1) {
          if ((bitRead(i2c_in1_val,  x) + bitRead(i2c_in1_val_sim,  x)) == 1) { bitWrite(i2c_in1_val_ref, x, bitRead(i2c_in1_val_sim,  x)); bitWrite(i2c_in1_maj,  x, 1); }
        }
      }
      i2c_in1_maj_sim = 0x0000;
    }
    if (i2c_in2_maj_sim != 0x0000) {
      for ( x = 0; x < i2c_in_nbmax; x++) {
        if (bitRead(i2c_in2_maj_sim,  x) == 1) {
          if ((bitRead(i2c_in2_val,  x) + bitRead(i2c_in2_val_sim,  x)) == 1) { bitWrite(i2c_in2_val_ref, x, bitRead(i2c_in2_val_sim,  x)); bitWrite(i2c_in2_maj,  x, 1); }
        }
      }
      i2c_in2_maj_sim = 0x0000;
    }
    if (i2c_in3_maj_sim != 0x0000) {
      for ( x = 0; x < i2c_in_nbmax; x++) {
        if (bitRead(i2c_in3_maj_sim,  x) == 1) {
          if ((bitRead(i2c_in3_val,  x) + bitRead(i2c_in3_val_sim,  x)) == 1) { bitWrite(i2c_in3_val_ref, x, bitRead(i2c_in3_val_sim,  x)); bitWrite(i2c_in3_maj,  x, 1); }
        }
      }
      i2c_in3_maj_sim = 0x0000;
    }
  }
}
//
//=============================================================================================================================
// /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
//=============================================================================================================================
// Sous programme de comparaison d'un nombre entier et mise à jour des entrées.
//  buffer2_compare_int_maj_sim(1=in1, 2=in2, 3=in3; Numéro de l'entrée);
void buffer2_compare_int_maj_sim(int x, int y) {
  buffer_rx_valeur = atoi(buffer_rx[2]);                     // On passe par un nombre entier. Conversion en : 0/1.
  if (y < i2c_in_nbmax) {
    if      (x == 1) {
      if       (buffer_rx_valeur == 1) { bitWrite(i2c_in1_val_sim, y, 1); bitWrite(i2c_in1_maj_sim, y, 1); }
      else                             { bitWrite(i2c_in1_val_sim, y, 0); bitWrite(i2c_in1_maj_sim, y, 1); } // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
    }
    else if (x == 2) {
      if       (buffer_rx_valeur == 1) { bitWrite(i2c_in2_val_sim, y, 1); bitWrite(i2c_in2_maj_sim, y, 1); }
      else                             { bitWrite(i2c_in2_val_sim, y, 0); bitWrite(i2c_in2_maj_sim, y, 1); } // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
    }
    else if (x == 3) {
      if       (buffer_rx_valeur == 1) { bitWrite(i2c_in3_val_sim, y, 1); bitWrite(i2c_in3_maj_sim, y, 1); }
      else                             { bitWrite(i2c_in3_val_sim, y, 0); bitWrite(i2c_in3_maj_sim, y, 1); } // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
    }
  }
}
// ------------------------------------------------------------
// Sous programme de comparaison d'un nombre flottant et mise à jour des entrées.
//  buffer2_compare_float_maj_sim(1=in1, 2=in2, 3=in3; Numéro de l'entrée);
void buffer2_compare_float_maj_sim(int x, int y) {
  buffer_rx_fvaleur = atof(buffer_rx[2]);                     // Obligé de passer par un nombre flottant.
  if (y < i2c_in_nbmax) {
    if      (x == 1) {
      if       (buffer_rx_fvaleur > 0.98) { bitWrite(i2c_in1_val_sim, y, 1); bitWrite(i2c_in1_maj_sim, y, 1); }
      else if  (buffer_rx_fvaleur < 0.02) { bitWrite(i2c_in1_val_sim, y, 0); bitWrite(i2c_in1_maj_sim, y, 1); } // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
    }
    else if (x == 2) {
      if       (buffer_rx_fvaleur > 0.98) { bitWrite(i2c_in2_val_sim, y, 1); bitWrite(i2c_in2_maj_sim, y, 1); }
      else if  (buffer_rx_fvaleur < 0.02) { bitWrite(i2c_in2_val_sim, y, 0); bitWrite(i2c_in2_maj_sim, y, 1); } // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
    }
    else if (x == 3) {
      if       (buffer_rx_fvaleur > 0.98) { bitWrite(i2c_in3_val_sim, y, 1); bitWrite(i2c_in3_maj_sim, y, 1); }
      else if  (buffer_rx_fvaleur < 0.02) { bitWrite(i2c_in3_val_sim, y, 0); bitWrite(i2c_in3_maj_sim, y, 1); } // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
    }
  }
}
// ------------------------------------------------------------
// Sous programme de comparaison d'un nombre entier et mise à jour des sorties.
//  buffer2_compare_int_maj_out(1=out1, 2=out2, Numéro de la sortie);
void buffer2_compare_int_maj_out(int x, int y) {
  buffer_rx_valeur = atoi(buffer_rx[2]);                     // On passe par un nombre entier. Conversion en : 0/1.
  if (y < i2c_in_nbmax) {
    if      (x == 1) {
      if       (buffer_rx_valeur == 1) { bitWrite(i2c_out1_val, y, 1); bitWrite(i2c_out1_maj, y, 1); }
      else                             { bitWrite(i2c_out1_val, y, 0); bitWrite(i2c_out1_maj, y, 1); } // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
    }
    else if (x == 2) {
      if       (buffer_rx_valeur == 1) { bitWrite(i2c_out2_val, y, 1); bitWrite(i2c_out2_maj, y, 1); }
      else                             { bitWrite(i2c_out2_val, y, 0); bitWrite(i2c_out2_maj, y, 1); } // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
    }
  }
}
// ------------------------------------------------------------
// Sous programme de comparaison d'un nombre flottant et mise à jour des sorties.
//  buffer2_compare_float_maj_out(1=out1, 2=out2; Numéro de la sortie);
void buffer2_compare_float_maj_out(int x, int y) {
  buffer_rx_fvaleur = atof(buffer_rx[2]);                     // Obligé de passer par un nombre flottant.
  if (y < i2c_in_nbmax) {
    if      (x == 1) {
      if       (buffer_rx_fvaleur > 0.98) { bitWrite(i2c_out1_val, y, 1); bitWrite(i2c_out1_maj, y, 1); }
      else if  (buffer_rx_fvaleur < 0.02) { bitWrite(i2c_out1_val, y, 0); bitWrite(i2c_out1_maj, y, 1); } // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
    }
    else if (x == 2) {
      if       (buffer_rx_fvaleur > 0.98) { bitWrite(i2c_out2_val, y, 1); bitWrite(i2c_out2_maj, y, 1); }
      else if  (buffer_rx_fvaleur < 0.02) { bitWrite(i2c_out2_val, y, 0); bitWrite(i2c_out2_maj, y, 1); } // La comparaison et demande de mise à jour, se fera automatiquement toutes les xxx msec.
    }
  }
}