/* Fichier : Data_Envoyees_vers_PC_TSCRJI_BB67000_Y.ino
   Sous-programme d'émission des caractères sur la ligne série.      JLF le 15/02/2025.

  Cette version est pour 'RailsWorks Classic'.
  Ce sous programme envoie un code de touche avec une émulation de clavier usb, au simulateur sur ordinateur.
  On peut aussi envoyer des valeurs (0-32) en émulant un joystick nommé 'Arduino Due'.
  En modifiant ce sous-programme, il est adaptable à d'autre simulateur sur ordinateur.

Pour la :
 ######  ######      #####  #######   ###     ###     ###                       #     # 
 #     # #     #    #     # #    #   #   #   #   #   #   #     #####  ######     #   #   ####  #    #   ##   #    #
 #     # #     #    #           #   #     # #     # #     #    #    # #           # #   #    # #    #  #  #  ##   #
 ######  ######     ######     #    #     # #     # #     #    #    # #####        #    #    # ###### #    # # #  #
 #     # #     #    #     #   #     #     # #     # #     #    #    # #            #    #    # #    # ###### #  # #
 #     # #     #    #     #   #      #   #   #   #   #   #     #    # #            #    #    # #    # #    # #   ##
 ######  ######      #####    #       ###     ###     ###      #####  ######       #     ####  #    # #    # #    #

Si vous réaliser des améliorations matériels ou logicielles, merci de les poster sur le forum RMF pour en faire profiter le plus grand nombre.
Si vous publier cette réalisation avec ou sans améliorations, vous devez publier votre code source.
Ce logiciel est un logiciel libre. Exigence du concepteur : Ne pas modifier la ligne d'affichage "JLF  xx/xx/xxxx" sur l'écran LCD.
On peut modifier ce programme et le diffuser. Dans ce cas, il faut préciser l'origine et donner accès aux sources modifiées.
Définition : Un logiciel libre est un logiciel distribué avec l’intégralité de ses programmes-sources, afin que l’ensemble des utilisateurs qui l’emploient, puissent l’enrichir et le redistribuer à leur tour.
Note : Un logiciel libre n’est pas nécessairement gratuit et les droits de la chaîne des auteurs sont préservés.
Équivalent étranger : free software, open source software.
(Source : Vocabulaire de l’informatique (liste de termes, expressions et définitions adoptés), NOR: CTNX0710138K, J.O n° 93 du 20 avril 2007 page 7078, texte n° 84)
logiciel libre
Par logiciel libre on entend un logiciel qui offre la liberté aux utilisateurs d'exécuter, de copier, de distribuer, d'étudier, de modifier et d'améliorer le logiciel. Plus précisément, elle fait référence à quatre types de liberté pour les utilisateurs du logiciel :
    La liberté d'exécuter le programme, pour tous les usages (liberté 0).
    La liberté d'étudier comment le programme fonctionne et de l'adapter à ses besoins (liberté 1). L'accès au code source est une condition requise.
    La liberté de redistribuer des copies, (liberté 2).
    La liberté d'améliorer le programme et de diffuser les améliorations au public pour en faire profiter toute la communauté (liberté 3). L'accès au code source est une condition requise.  */

// Essai d'envoi des commandes à travers les boutons d'un joystick émulé par l'Arduino.
//   if (bitRead(i2c_in1_maj, x) == 1) { Joystick_1.setButton(15-x, bitRead(i2c_in1_val, x));  joystick_maj = 1;} // On traite que si demande de maj.
//   Le bouton du joystick change bien d'état, mais le programme 'TS Classic Raildriver and Joystick Interface' ne l'exploite pas!
// Ligne de code à ajouter pour débug.
//   Serial.print(" 0 "); Serial.print(bitRead(i2c_in1_val, x)); Serial.print(" : "); Serial.print(bitRead(i2c_in1_val_ref, x)); Serial.print(" ");
//
//   Serial.print(" 1 "); Serial.print(bitRead(i2c_in1_val, 1)); Serial.print(" : "); Serial.print(bitRead(i2c_in1_val_ref, 1)); Serial.print(" : ");
//                      ; Serial.print(bitRead(i2c_in1_val, 2)); Serial.print(" : "); Serial.print(bitRead(i2c_in1_val_ref, 2)); Serial.println(" ");
//
//=============================================================================================================================
// /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
//=============================================================================================================================
// Quand une entrée a bougée, on récupère la valeur de l'entrée X = bitRead(i2c_in1_val, X) = 0 ou 1. (1 = ON).
// On envoie un code de touche au simulateur.
//
// on traite les types d'entrées suivantes :
// 1 / Bouton poussoir pouvant être maintenu appuyé plusieurs secondes. Des que l'on cesse d'appuyer le bouton remonte tout seul sur le pupitre.
//     C'est pour une action pouvant être rapide, ou durer quelques secondes.
//     Quand on appuie sur le bouton, on envoie un code de touche.
//     Quand on relâche le bouton, on envoie un code de fin de touche.
//
// 2 / Bouton poussoir momentané. Des que l'on cesse d'appuyer le bouton remonte tout seul sur le pupitre. C'est fait pour appuyer rapidement une seule fois.
//     Quand on appuie sur le bouton, on envoie un code de touche et rapidement un code de fin de touche.
//     Quelque soit la durée d'appui sur ce bouton, on envoi la code de la touche puis immédiatement le relâchement de cette touche.
//     Permet d'activer un bouton poussoir momentané et rapide.
//
// 3 / Interrupteur. Il est fermé ou ouvert pour une durée longue.
//     On envoi une touche pour le fermer ou l'ouvrir. A chaque envoi, l'interrupteur bascule sur le simulateur.
//     Quand on manipule d'interrupteur quelque soit le sens, on envoie un code de touche et rapidement un code de fin de touche.
//
// 4 / Cas plus complexes, avec plusieurs boutons poussoirs pouvant être maintenus appuyés.
//     4a / Petit manipulateur de frein de train. Il y a un contact dans le sens poussé, et un contact dans le sens tiré.
//          Il revient automatiquement au centre. C'est comme deux boutons poussoirs.
//          On envoie un code de touche X quand le levier est poussé et un autre code de touche Y quand le levier et tiré.
//          Quand on tire sur le levier, on envoie un code de touche X.
//          Quand on relâche le levier, il revient automatiquement au centre, on envoie un code de fin de touche X.
//          Quand on pousse le levier, on envoie un code de touche Y.
//          Quand on relâche le levier, il revient automatiquement au centre, on envoie un code de fin de touche Y.
//
//     4b / Inverseur de traction. Il y a un contact dans le sens poussé, et un contact dans le sens tiré.
//          Il ne revient pas automatiquement au centre. C'est comme deux interrupteurs.
//          On envoie un code de touche X quand le levier est poussé et un autre code de touche Y quand le levier et tiré.
//          Quand on tire sur le levier, on envoie un code de touche X et rapidement un code de fin de touche X.
//          Quand on remet le levier au centre, on envoie un code de touche Y et rapidement un code de fin de touche Y.
//          Quand on pousse le levier, on envoie un code de touche Y et rapidement un code de fin de touche Y.
//          Quand on remet le levier au centre, on envoie un code de touche XY et rapidement un code de fin de touche X.
//
//     4c / Le cerclo. Il y a un mélange avec un interrupteur pour les positions "(-) 0" et "STOP",
//          et un bouton poussoir pouvant être maintenu appuyé plusieurs secondes, pour la position (+).
//
// Les durées de touche enfoncée sont variables. Il faut mettre la bonne durée, sinon ça ne fonctionne pas sur le simulateur.
// Certains équipements mettent plus de temps que d'autres à réagir.
//     duree_touche_50  : Durée minimale, utilisé pour le relâchement des touches.
//     duree_touche_100 : Durée par défaut pour Rail Simulator Classic. Durée pour les interrupteurs.
//     duree_touche_200 :
//     duree_touche_400 : Pour le Cerclo.
//
// Quand une entrée a bougée, on récupére la valeur de l'entrée "i2c_in1_val".
// On envoie un code de touche au simulateur. On mémorise la valeur de l'entrée envoyée à l'ordinateur, dans "i2c_in1_val_ref".
//
// Dans le programme de réception des trames envoyées par le simulateur, on récupére la position des équipements sur l'ordinateur.
// On met à jour ces variables : "i2c_in1_val_sim".
//
// On compare périodiquement, la valeur envoyée par le simulateur avec la valeur du pupitre physique : "i2c_in1_sim"  = "i2c_in1_val_ref" ?
// Si les équipements ne sont pas en phase, on force une mise à jour "i2c_in1_maj".
//
//------------------------------------------------------------------------------------------
void Data_Envoyees_vers_PC() {
// ENVOI DES COMMANDES VERS LE PC.
// Si une entrée a bougée, un bit de i2c_in1_maj == 1, un bit de i2c_in2_maj == 1 ou un bit de i2c_in3_maj == 1   (3 * 16 bits).
// Dans ce cas récupérer la valeur (0/1) dans i2c_in1_val, i2c_in2_val ou i2c_in3_val.   (3 * 16 bits).
//
  if (int_0_val == 1) {   // Si l'interrupteur "ENVOI" est sur 'ON' = 0, on inhibe l'envoi des touches au PC.
//--in1--in1--in1--in1--in1--in1--in1--in1--in1--in1--in1--in1--in1--in1--in1--in1--in1--in1--in1--in1--
    if (i2c_in1_maj != 0x0000) {
      ic2_in_comp_ref_milli = ic2_in_comp_ref_milli + duree_touche_400; // Si un bouton/interrupteur a bougé sur le pupitre, on attendra un peu plus avant de vérifier les valeurs du simu.
      for (x = 0; x < i2c_in_nbmax; x++) {
        if (bitRead(i2c_in1_maj, x) == 1) {
// Cas du bouton poussoir qui reste enfoncé tant que l'on appuie sur le bouton. Pas de timer, on libérera la touche quand on la relâchera.
          if       (x ==  1) { if(bitRead(i2c_in1_val, x) == 1) tch_env(NORMAL, 'x', PRESS); else tch_env(NORMAL, 'x', RELEASE); } //  x             Bouton poussoir Sable.
          else if  (x ==  2) { if(bitRead(i2c_in1_val, x) == 1) tch_env(NORMAL, 'l', PRESS); else tch_env(NORMAL, 'l', RELEASE); } //  l             Bouton poussoir Desserrage Grand Débit.
          else if  (x ==  6) { if(bitRead(i2c_in1_val, x) == 1) tch_env(NORMAL, ';', PRESS); else tch_env(NORMAL, ';', RELEASE); } //  ;     pour m  Petit levier Frein du train en avant.
          else if  (x ==  7) { if(bitRead(i2c_in1_val, x) == 1) tch_env(NORMAL,  96, PRESS); else tch_env(NORMAL,  96, RELEASE); } // 96 = ' pour ù  Petit levier Frein du train en arrière.
          else if  (x ==  8) { if(bitRead(i2c_in1_val, x) == 1) tch_env(NORMAL, ' ', PRESS); else tch_env(NORMAL, ' ', RELEASE); } // 'Espace'       Bouton poussoir Veille Active du cerclo.
          else if  (x ==  9) { if(bitRead(i2c_in1_val, x) == 1) tch_env(NORMAL, 'a', PRESS); else tch_env(NORMAL, 'a', RELEASE); } // a pour q       Bouton poussoir Cerclo vers la gauche au passage sur (+). Dans ce cas, l'entrée 10 est toujours = 1.
          else if ((bitRead(i2c_in1_val, x) + bitRead(i2c_in1_val_ref, x)) == 1) {
// Cas des interrupteurs. On doit prévoir le traitement en retour de la valeur du simulateur.
// Dans le cas où il y a plusieurs contacts sur un levier, on assure ici que l'envoi d'un code de touche quand le contact = 1.
// Il y a aussi des envois de code de touche différents, à la fermeture et à l'ouverture d'un contact (Cerclo +).
            if       (x ==  3)                          { tch_env(NORMAL, KEY_BACKSPACE, duree_touche_100); bitWrite(i2c_in1_val_ref, x, bitRead(i2c_in1_val, x)); } // 'KEY_BACKSPACE' Frein d'urgence.
            else if ((x ==  4) && (bitRead(i2c_in1_val, x) == 1)) { tch_env(NORMAL,  93, duree_touche_100); bitWrite(i2c_in1_val_ref, x, bitRead(i2c_in1_val, x)); } // 93 = '$' = ]    Grand levier Frein direct en avant.
            else if ((x ==  5) && (bitRead(i2c_in1_val, x) == 1)) { tch_env(NORMAL,  91, duree_touche_100); bitWrite(i2c_in1_val_ref, x, bitRead(i2c_in1_val, x)); } // 91 = '^' = [    Grand levier Frein direct en arrière.
            else if ((x == 10) && (bitRead(i2c_in1_val, x) == 0)) { tch_env(NORMAL, 'd', duree_touche_400); bitWrite(i2c_in1_val_ref, x, bitRead(i2c_in1_val, x)); } // d Cerclo vers la droite au passage sur (-) ou 0.
            else if ((x == 10) && (bitRead(i2c_in1_val, x) == 1)) { tch_env(NORMAL, 'a', duree_touche_400); bitWrite(i2c_in1_val_ref, x, bitRead(i2c_in1_val, x)); } // a pour q  Cerclo vers la gauche au passage sur STOP.
            else if ((x == 12) && (bitRead(i2c_in1_val, x) == 1)) { tch_env(NORMAL, 'w', duree_touche_100); bitWrite(i2c_in1_val_ref, x, bitRead(i2c_in1_val, x)); } // w pour z        Inverseur de traction, en avant.
            else if ((x == 13) && (bitRead(i2c_in1_val, x) == 1)) { tch_env(NORMAL, 's', duree_touche_100); bitWrite(i2c_in1_val_ref, x, bitRead(i2c_in1_val, x)); } //       s         Inverseur de traction, en arrière.
          }
// On traite les retours à '0', de levier à plusieurs positions.
// On regarde si le levier est en position centrale : Entrée1 = 0 et Entrée2 = 0.
// Il faut envoyer un code de touche différent, pour revenir à la position centrale. C'est un code de touche pour faire l'action inverse.
          if (((x == 4) || (x == 5))  && ((bitRead(i2c_in1_val, 4) == 0)) && (bitRead(i2c_in1_val, 5) == 0)) {
            if      (bitRead(i2c_in1_val_ref, 4) == 1) { tch_env(NORMAL, 91, duree_touche_100); } // 91 = '^' = [ Grand levier Frein direct en arrière.
            else if (bitRead(i2c_in1_val_ref, 5) == 1) { tch_env(NORMAL, 93, duree_touche_100); } // 93 = '$' = ] Grand levier Frein direct en avant.
            bitWrite(i2c_in1_val_ref, 4, 0); bitWrite(i2c_in1_val_ref, 5, 0);
          }
          if (((x == 12) || (x == 13)) && ((bitRead(i2c_in1_val, 12) == 0)) && (bitRead(i2c_in1_val, 13) == 0)) {
            if      (bitRead(i2c_in1_val_ref, 12) == 1) { tch_env(NORMAL, 's', duree_touche_100); } //     s     Inverseur de traction, en arrière.
            else if (bitRead(i2c_in1_val_ref, 13) == 1) { tch_env(NORMAL, 'w', duree_touche_100); } // w pour z  Inverseur de traction, en avant.
            bitWrite(i2c_in1_val_ref, 12, 0); bitWrite(i2c_in1_val_ref, 13, 0);
          }
        }
      }
      i2c_in1_maj = 0x0000;  // Le changement des entrées a été traité.
    }
//--in2--in2--in2--in2--in2--in2--in2--in2--in2--in2--in2--in2--in2--in2--in2--in2--in2--in2--in2--in2--
    if (i2c_in2_maj != 0x0000) {
      ic2_in_comp_ref_milli = ic2_in_comp_ref_milli + duree_touche_400; // Si un bouton/interrupteur a bougé sur le pupitre, on attendra un peu plus avant de vérifier les valeurs du simu.
      for (x = 0; x < i2c_in_nbmax; x++) {
        if (bitRead(i2c_in2_maj, x) == 1) {
// Cas du bouton poussoir qui reste enfoncé tant que l'on appuie sur le bouton. Pas de timer, on libérera la touche quand on la relâchera.
          if (x == 1) { if(bitRead(i2c_in2_val, x) == 1) tch_env(NORMAL, 'o', PRESS); else tch_env(NORMAL, 'o', RELEASE); }  // o   Bouton poussoir momentané. BP(R)Q   Réarmement QT Bouton poussoir
          else if ((bitRead(i2c_in2_val, x) + bitRead(i2c_in2_val_ref, x)) == 1) {
// Cas des interrupteurs. On doit prévoir le traitement en retour de la valeur du simulateur.
             if      (x ==  2) { tch_env(NORMAL, 'c', duree_touche_100);        bitWrite(i2c_in2_val_ref, x, bitRead(i2c_in2_val, x)); } //   c       Interrupteur - Z1(CPA Compresseur Auto.
             else if (x ==  3) { tch_env(NORMAL, 'n', duree_touche_100);        bitWrite(i2c_in2_val_ref, x, bitRead(i2c_in2_val, x)); } //   n       Interrupteur - Z1(CH) Chauffage du train.
             else if (x ==  5) { tch_env(NORMAL, 'i', duree_touche_100);        bitWrite(i2c_in2_val_ref, x, bitRead(i2c_in2_val, x)); } //   i       Interrupteur - Accéleration diesel.
             else if (x ==  7) { tch_env(NORMAL, 'z', duree_touche_100);        bitWrite(i2c_in2_val_ref, x, bitRead(i2c_in2_val, x)); } // z pour w  Interrupteur - Clé BL, Boite à levier.
             else if (x ==  8) { tch_env(NORMAL, 'j', duree_touche_100);        bitWrite(i2c_in2_val_ref, x, bitRead(i2c_in2_val, x)); } //   j       Interrupteur - Eclairage Cabine.
             else if (x == 10) { tch_env(KEY_LEFT_CTRL, 'j', duree_touche_100); bitWrite(i2c_in2_val_ref, x, bitRead(i2c_in2_val, x)); } //  ^j       Interrupteur - Eclairage pupitre.
             else if (x == 11) { tch_env(NORMAL, 'r', duree_touche_100);        bitWrite(i2c_in2_val_ref, x, bitRead(i2c_in2_val, x)); } //   r       Interrupteur - Eclairage Fanal Gauche.
             else if (x == 12) { tch_env(KEY_LEFT_CTRL, 'r', duree_touche_100); bitWrite(i2c_in2_val_ref, x, bitRead(i2c_in2_val, x)); } //  ^r       Interrupteur - Eclairage Fanal Droit.
             else if (x == 13) { tch_env(NORMAL, 'h', duree_touche_100);        bitWrite(i2c_in2_val_ref, x, bitRead(i2c_in2_val, x)); } //   h       Interrupteur - Eclairage les 2 Projecteurs.
             else if (x == 14) { tch_env(NORMAL, 'k', duree_touche_100);        bitWrite(i2c_in2_val_ref, x, bitRead(i2c_in2_val, x)); } //   k       Interrupteur - Essais VA.
          }
        }
      }
      i2c_in2_maj = 0x0000;  // Le changement des entrées a été traité.
    }
//--in3--in3--in3--in3--in3--in3--in3--in3--in3--in3--in3--in3--in3--in3--in3--in3--in3--in3--in3--in3--
    if (i2c_in3_maj != 0x0000) {
      ic2_in_comp_ref_milli = ic2_in_comp_ref_milli + duree_touche_400; // Si un bouton/interrupteur a bougé sur le pupitre, on attendra un peu plus avant de vérifier les valeurs du simu.
      for (x = 0; x < i2c_in_nbmax; x++) {
        if (bitRead(i2c_in3_maj, x) == 1) {
// Cas du bouton poussoir qui reste enfoncé tant que l'on appuie sur le bouton. Pas de timer, on libérera la touche quand on la relâchera.
          if      (x == 10) { if(bitRead(i2c_in3_val, x) == 1) tch_env(NORMAL, KEY_PAGE_UP,  PRESS); else tch_env(NORMAL, KEY_PAGE_UP,  RELEASE); } // P_up   Bouton poussoir momentané - Avertisseur 2 tons.
          else if (x == 11) { if(bitRead(i2c_in3_val, x) == 1) tch_env(NORMAL, KEY_PAGE_DOWN,PRESS); else tch_env(NORMAL, KEY_PAGE_DOWN,RELEASE); } // P_down Bouton poussoir momentané - Avertisseur 2 tons.
          else if (x ==  1) { if(bitRead(i2c_in3_val, x) == 1) tch_env(NORMAL, KEY_KP_ENTER, PRESS); else tch_env(NORMAL, KEY_KP_ENTER, RELEASE); } // Entrée_pavé_Num  BP momentané - BP(AC)SF, Acquittement signaux.
// Traitement spécial pour ces 4 boutons poussoirs. On envoie une touche rapidement, sinon ça fait activer un second bouton. Défaut de simulation.
          else if ((x == 4) &&  (bitRead(i2c_in3_val, x) == 1)) { tch_env(NORMAL, 'p', duree_touche_100);         bitWrite(i2c_in3_val_ref, x, bitRead(i2c_in3_val, x)); } //  p    Bouton poussoir momentané - Démarrage du moteur 1.
          else if ((x == 5) &&  (bitRead(i2c_in3_val, x) == 1)) { tch_env(KEY_LEFT_SHIFT, 'p', duree_touche_100); bitWrite(i2c_in3_val_ref, x, bitRead(i2c_in3_val, x)); } //  P    Bouton poussoir momentané - Démarrage du moteur 2.
          else if ((x == 6) &&  (bitRead(i2c_in3_val, x) == 1)) { tch_env(NORMAL, 'y', duree_touche_100);         bitWrite(i2c_in3_val_ref, x, bitRead(i2c_in3_val, x)); } //  y    Bouton poussoir momentané - Arrêt du moteur 1.
          else if ((x == 7) &&  (bitRead(i2c_in3_val, x) == 1)) { tch_env(KEY_LEFT_SHIFT, 'y', duree_touche_100); bitWrite(i2c_in3_val_ref, x, bitRead(i2c_in3_val, x)); } //  Y    Bouton poussoir momentané - Arrêt du moteur 2.
          else if ((bitRead(i2c_in3_val, x) + bitRead(i2c_in3_val_ref, x)) == 1) {
// Cas des interrupteurs. On doit prévoir le traitement en retour de la valeur du simulateur.
            if      (x ==  3) { tch_env(NORMAL, 'v', duree_touche_100);        bitWrite(i2c_in3_val_ref, x, bitRead(i2c_in3_val, x)); } //  v    Interrupteur - Essuie-glaces.
            else if (x ==  8) { tch_env(NORMAL, 'f', duree_touche_100);        bitWrite(i2c_in3_val_ref, x, bitRead(i2c_in3_val, x)); } //  f    Interrupteur - Eclairage Feu Rouge Gauche Cab 2.
            else if (x ==  9) { tch_env(KEY_LEFT_CTRL, 'f', duree_touche_100); bitWrite(i2c_in3_val_ref, x, bitRead(i2c_in3_val, x)); } // ^f    Interrupteur - Eclairage Feu Rouge Droit Cab2 .
            else if (x == 12) { tch_env(KEY_LEFT_CTRL, 'k', duree_touche_100); bitWrite(i2c_in3_val_ref, x, bitRead(i2c_in3_val, x)); } // ^k    Interrupteur - Isolation VA.
            else if (x == 13) { tch_env(NORMAL, KEY_F11, duree_touche_100);    bitWrite(i2c_in3_val_ref, x, bitRead(i2c_in3_val, x)); } // F11   Interrupteur - Isolation KVB.
            else if (x == 14) { tch_env(NORMAL, KEY_KP_PLUS, duree_touche_100);bitWrite(i2c_in3_val_ref, x, bitRead(i2c_in3_val, x)); } // +_pavé_Num   Inter - Isolation RS.
          }
        }
      }
      i2c_in3_maj = 0x0000;  // Le changement des entrées a été traité.
    }
  }

//
// Gestion de la file d'attente des codes de touche à envoyer à l'ordinateur.
// On envoie un code de touche et l'on attend un delai variable. On envoie ensuite un code de fin de touche et l'on attend un delai de 50 msec.
//   tch_env(NORMAL, 'a', duree_touche_200);         = Envoi du début de la lettre 'a', suivi d'une pause de 120 msec + envoi de la fin de la lettre 'a', suivi d'une pause de 50 msec.
//   tch_env(NORMAL, 'a', PRESS);                    = Envoi du début de la lettre 'a', suivi d'une pause de 100 msec.
//   tch_env(NORMAL, 'a', RELEASE);                  = Envoi de la fin de la lettre 'a', suivi d'une pause de 50 msec.
//   tch_env(KEY_LEFT_CTRL, 'a', duree_touche_400);  = Envoi de la fin de la lettre 'Ctrl-a', suivi d'une pause de 200 msec + envoi de la fin de la lettre 'Ctrl-a', suivi d'une pause de 50 msec.
//   tch_env(KEY_LEFT_SHIFT, 'a', duree_touche_200); = Envoi de la fin de la lettre 'A', suivi d'une pause de 400 msec + envoi de la fin de la lettre 'A', suivi d'une pause de 50 msec.
//   tch_env(KEY_LEFT_SHIFT+KEY_LEFT_CTRL, 'v', duree_touche_200); = Envoi de la fin de la lettre Ctrl +'v', pour le KVB suivi d'une pause de 400 msec + ...
//
// Codes de touches possibles :
//   KEY_LEFT_CTRL, KEY_LEFT_SHIFT, KEY_LEFT_ALT, KEY_LEFT_GUI, KEY_RIGHT_CTRL, KEY_RIGHT_SHIFT, KEY_RIGHT_ALT, KEY_RIGHT_GUI
//   KEY_UP_ARROW, KEY_DOWN_ARROW, KEY_LEFT_ARROW, KEY_RIGHT_ARROW, KEY_BACKSPACE, KEY_TAB, KEY_RETURN, KEY_MENU
//   KEY_ESC, KEY_INSERT, KEY_DELETE, KEY_PAGE_UP, KEY_PAGE_DOWN, KEY_HOME, KEY_END, KEY_CAPS_LOCK, KEY_PRINT_SCREEN, KEY_SCROLL_LOCK, KEY_PAUSE
//   KEY_NUM_LOCK, KEY_KP_SLASH, KEY_KP_ASTERISK, KEY_KP_MINUS, KEY_KP_PLUS, KEY_KP_ENTER, KEY_KP_1, KEY_KP_2,,, KEY_KP_0, KEY_KP_DOT
//   KEY_F1, KEY_F2, KEY_F3, KEY_F4,,, KEY_F22, KEY_F23, KEY_F24
//
  if (touche_etat[touche_num_en_cours] != touche_etat_fait) {
// --------------------------------------------------------------------------------
    if (led_car_envoi_val == 0) { digitalWrite(pin_led_car_envoi, HIGH);  led_car_envoi_val = 1; } // Allume la led témoin d'envoi de touches.
    if (touche_etat[touche_num_en_cours] == touche_etat_demande) {
      if (touche_milli[touche_num_en_cours] == PRESS) {         // Code PRESS.
        if      (touche_shift[touche_num_en_cours] == KEY_LEFT_CTRL)  {Keyboard.press(KEY_LEFT_CTRL);  Keyboard.press(touche_code[touche_num_en_cours]); Keyboard.release(KEY_LEFT_CTRL);}
        else if (touche_shift[touche_num_en_cours] == KEY_LEFT_SHIFT) {Keyboard.press(KEY_LEFT_SHIFT); Keyboard.press(touche_code[touche_num_en_cours]); Keyboard.release(KEY_LEFT_SHIFT);}
        else if (touche_shift[touche_num_en_cours] == NORMAL)         {                                Keyboard.press(touche_code[touche_num_en_cours]);}
        touche_milli_en_cours = millis() + duree_touche_100;
        touche_etat[touche_num_en_cours] = touche_etat_lib_en_cours;  // On passe ensuite en mode attente libération. On a envoyé un code de touche. On va attendra 50 msec avant de redonner la main.
      }
// -------------------
      else if (touche_milli[touche_num_en_cours] == RELEASE) {   // Code RELEASE.
        if      (touche_shift[touche_num_en_cours] == KEY_LEFT_CTRL)  {Keyboard.press(KEY_LEFT_CTRL);  Keyboard.release(touche_code[touche_num_en_cours]); Keyboard.release(KEY_LEFT_CTRL);}
        else if (touche_shift[touche_num_en_cours] == KEY_LEFT_SHIFT) {Keyboard.press(KEY_LEFT_SHIFT); Keyboard.release(touche_code[touche_num_en_cours]); Keyboard.release(KEY_LEFT_SHIFT);}
        else if (touche_shift[touche_num_en_cours] == NORMAL)         {                                Keyboard.release(touche_code[touche_num_en_cours]);}
        touche_milli_en_cours = millis() +  duree_touche_50;
        touche_etat[touche_num_en_cours] = touche_etat_lib_en_cours;  // On passe ensuite en mode attente libération. On a envoyé un code de touche. On va attendra 100 msec avant de redonner la main.
      }
      else {                                                   // Code  Durée d'appui de touche classique.
        if      (touche_shift[touche_num_en_cours] == KEY_LEFT_CTRL)  {Keyboard.press(KEY_LEFT_CTRL);  Keyboard.press(touche_code[touche_num_en_cours]); Keyboard.release(KEY_LEFT_CTRL);}
        else if (touche_shift[touche_num_en_cours] == KEY_LEFT_SHIFT) {Keyboard.press(KEY_LEFT_SHIFT); Keyboard.press(touche_code[touche_num_en_cours]); Keyboard.release(KEY_LEFT_SHIFT);}
        else if (touche_shift[touche_num_en_cours] == KEY_LEFT_SHIFT+KEY_LEFT_CTRL)
                                                                      {Keyboard.press(KEY_LEFT_SHIFT); Keyboard.press(KEY_LEFT_CTRL);
                                                                       Keyboard.press(touche_code[touche_num_en_cours]);
                                                                       Keyboard.release(KEY_LEFT_CTRL);Keyboard.release(KEY_LEFT_SHIFT);}
        else if (touche_shift[touche_num_en_cours] == NORMAL)         {                                Keyboard.press(touche_code[touche_num_en_cours]);}
        if (touche_milli[touche_num_en_cours] == PRESS) touche_milli_en_cours = millis() + duree_touche_100;
        else                                            touche_milli_en_cours = millis() + touche_milli[touche_num_en_cours];
        touche_etat[touche_num_en_cours] = touche_etat_p_en_cours;   // On a envoyé un code de touche. On va attendra 100 msec ou xxx msec avant de redonner la main.
      }
// --------------------------------------------------------------------------------
    }
    else if (touche_etat[touche_num_en_cours] == touche_etat_p_en_cours) {
      if (millis() >= touche_milli_en_cours) {
        if      (touche_shift[touche_num_en_cours] == KEY_LEFT_CTRL)  {Keyboard.press(KEY_LEFT_CTRL);  Keyboard.release(touche_code[touche_num_en_cours]); Keyboard.release(KEY_LEFT_CTRL);}
        else if (touche_shift[touche_num_en_cours] == KEY_LEFT_SHIFT) {Keyboard.press(KEY_LEFT_SHIFT); Keyboard.release(touche_code[touche_num_en_cours]); Keyboard.release(KEY_LEFT_SHIFT);}
        else if (touche_shift[touche_num_en_cours] == KEY_LEFT_SHIFT+KEY_LEFT_CTRL)
                                                                      {Keyboard.press(KEY_LEFT_SHIFT); Keyboard.press(KEY_LEFT_CTRL);
                                                                       Keyboard.release(touche_code[touche_num_en_cours]);
                                                                       Keyboard.release(KEY_LEFT_CTRL);Keyboard.release(KEY_LEFT_SHIFT);}
        else if (touche_shift[touche_num_en_cours] == NORMAL)         {                                Keyboard.release(touche_code[touche_num_en_cours]);}
        if (touche_milli[touche_num_en_cours] == 25) touche_milli_en_cours = millis() + 25; // Pour le Cerclo.
        else                                         touche_milli_en_cours = millis() + duree_touche_50;
        touche_etat[touche_num_en_cours] = touche_etat_lib_en_cours; // On a envoyé un code de FIN de touche. On va attendra 50 msec avant de redonner la main.
      }
    }
// --------------------------------------------------------------------------------
    else if (touche_etat[touche_num_en_cours] == touche_etat_lib_en_cours) {
      if (millis() >= touche_milli_en_cours) {
        touche_etat[touche_num_en_cours] = touche_etat_fait;         // On vient de dépasser le délai après l'envoi d'un code de FIN de touche.
        touche_num_en_cours++;                                       // Prochain indice à traiter ?
        if (touche_num_en_cours == touche_nb_max) touche_num_en_cours = 0;
      }
    }
  }
  else { if (led_car_envoi_val == 1) { digitalWrite(pin_led_car_envoi, LOW); led_car_envoi_val = 0; }} // Eteint la led témoin d'envoi de touches.

/*  Gestion des envois de grandeurs analogique = OK. Enlever la mise en commentaire pour l'utiliser.
   La valeur du joystick change bien de valeur, mais le programme 'TS Classic Raildriver and Joystick Interface' ne l'exploite pas!
  joystick_cpt++;                                                                  // Pour le moment on arrive à émuler 7 axes sur un joystick.
  if (joystick_cpt >= joystick_1_nb_max) joystick_cpt = 0;                         // On a un compteur de boucle, pour ne traiter qu'un axe à la fois.
  joystick_1[joystick_cpt] = analogRead(joystick_cpt)>>5; // 0 à 1023 => 0 à 31;   // Ca ne bouge pas trop vite, et on économise du cpu.
  if (joystick_1[joystick_cpt] != joystick_1_old[joystick_cpt]) {                  // Manette analogique = 32 crans
    joystick_1_old[joystick_cpt] = joystick_1[joystick_cpt];
    if (joystick_cpt == 0)  Joystick_1.setXAxis(   joystick_1[0]);
    if (joystick_cpt == 1)  Joystick_1.setYAxis(   joystick_1[1]);
    if (joystick_cpt == 2)  Joystick_1.setZAxis(   joystick_1[2]);
    if (joystick_cpt == 3)  Joystick_1.setRxAxis(  joystick_1[3]);
    if (joystick_cpt == 4)  Joystick_1.setRyAxis(  joystick_1[4]);
    if (joystick_cpt == 5)  Joystick_1.setRzAxis(  joystick_1[5]);
    if (joystick_cpt == 6)  Joystick_1.setThrottle(joystick_1[6]);
    joystick_maj = 1;     }                                                         //   Pour l'envoi de la mises à jour des boutons au PC.
// Essai d'envoi des commandes à travers les boutons d'un joystick émulé par l'Arduino.
// Le bouton du joystick change bien d'état, mais le programme 'TS Classic Raildriver and Joystick Interface' ne l'exploite pas!
  for (x = 0; x < i2c_in_nbmax; x ++ ) {
    if (bitRead(i2c_in1_maj, x) == 1) {
      if (bitRead(i2c_in1_maj, x) == 1) { Joystick_1.setButton(x, bitRead(i2c_in1_val, x)); joystick_maj = 1: } // On traite que si demande de maj.
    }
  }
  if (joystick_maj == 1) Joystick_1.sendState(); // Envoi la mises à jour des boutons au PC.
  joystick_maj = 0;    */

//=============================================================================================================================
// /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
//=============================================================================================================================
/* KVB : On envoie, si l'on a reçu un appui de touche du KVB, une commande au PC.
   Code des touches recues sur la liaison série : On envoie un caractère par touche.
   [VAL] => 'A' enfoncée, 'a' relâchée
    [MV] => 'B' enfoncée, 'b' relâchée
    [FC] => 'C' enfoncée, 'c' relâchée
  [TEST] => 'D' enfoncée, 'd' relâchée
    [SF] => 'E' enfoncée, 'e' relâchée
KVB pret => 'o'   ('o' pour ok 'n'  pour nok, si la carte TM1638 n'est pas détectée).*/
//
  if (int_0_val == 1) { // Si l'interrupteur est sur 'ON' = 0, on inhibe l'envoi des touches KVB au PC.
    if (Serial3.available() > 0) {
      char car_lu = Serial3.read();
/*    if      (car_lu == 'A') { tch_env(NORMAL, 'a', duree_touche_100); }
      else if (car_lu == 'B') { tch_env(NORMAL, 'b', duree_touche_100); }
      else if (car_lu == '<') { roues_codeuses_cpt = 1; roues_codeuses[0] = '<';}
      else if ((car_lu >= '0') && (car_lu <= '9') && (roues_codeuses_cpt >= 1)) {
        roues_codeuses[roues_codeuses_cpt] = car_lu;
        roues_codeuses_cpt++;
        if (roues_codeuses_cpt >= 9) roues_codeuses_cpt = 0;
      }
      else if ((car_lu == '>') && (roues_codeuses_cpt = 8))  {
        roues_codeuses_cpt = 0;                   // Le tableau roues_codeuses[] = <1234561> =
        roues_codeuses[8] = '>';                  // [VD VU]    [VU]    |DC DD DU]    Centaines, Dizaines, Unités + Bouton [VO-ME-MA] 1:VO, 2:ME, 3:MA
        roues_codeuses[9] = '\0';                 // peut être envoyé au PC.
        Serial.write(roues_codeuses,9);
      }  */
    }
  }
 
//-----------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------
// Lecture des entrées du boitier de commande.
  bp_cpt ++;
  if (bp_cpt > 30) {
    bp_cpt = 0;                 // Compteur pour ne faire l'acquisition des boutons qu'une fois sur trente = Toutes les msec.
    int_0_cpt = int_0_cpt << 1; // On décale d'un bit à gauche à chaque passage.
    bp_1_cpt  = bp_1_cpt  << 1; // Et on va écrire le nouveau bit en lisant l'entrée.
    bp_2_cpt  = bp_2_cpt  << 1; // 0 = Entrée active.
    bp_3_cpt  = bp_3_cpt  << 1;
    if (digitalRead(pin_boitier_int_0) == 0) int_0_cpt++; // 16 derniers états de l'interrupteur 0.  On attend donc 16 msec avant de valider un bouton.
    if (digitalRead(pin_boitier_bp_1)  == 0) bp_1_cpt++;  // 16 derniers états du bouton poussoir 1. Dispositif de lecture anti-rebonds.
    if (digitalRead(pin_boitier_bp_2)  == 0) bp_2_cpt++;  // 16 derniers états du bouton poussoir 2.
    if (digitalRead(pin_boitier_bp_3)  == 0) bp_3_cpt++;  // 16 derniers états du bouton poussoir 3.
//
// Les entrées sont normalement à 1, sans appui de bouton.
    if (int_0_cpt == 0xFFFF) int_0_val = 0;               // Interrupteur n° 0, int_0_val = 0 : Pas d'envoi de caractère d'émulation clavier.
    if (int_0_cpt == 0x0000) int_0_val = 1;               // Interrupteur n° 0, int_0_val = 1 : Envoi de caractères possible.
    if (bp_1_cpt == 0x0000) bp_1_val = 0;                 // Bouton poussoir n° 1 = BLEU.
    if (bp_2_cpt == 0x0000) bp_2_val = 0;                 // Bouton poussoir n° 2 = BLANC.
    if (bp_3_cpt == 0x0000) bp_3_val = 0;                 // Bouton poussoir n° 3 = NOIR.
//
    if (int_0_val == 1 ) {  // Si l'interrupteur "ENVOI" est sur 'ON' = 0, on inhibe l'envoi des touches au PC.
      if ((bp_1_cpt == 0xFFFF) && (bp_1_val == 0)) { tch_env(KEY_LEFT_CTRL,  'n', duree_touche_100); bp_1_val = 1; } //  ^n  : Sectionneur batterie.
      if ((bp_2_cpt == 0xFFFF) && (bp_2_val == 0)) { tch_env(KEY_LEFT_SHIFT, 'e', duree_touche_100); bp_2_val = 1; } // MajE : Commutateur éclairage.
      if ((bp_3_cpt == 0xFFFF) && (bp_3_val == 0)) { tch_env(KEY_LEFT_CTRL,  'b', duree_touche_100); bp_3_val = 1; } //  ^b  : Frein à main.
    }
  led_en_vie_cpt ++;
  if (led_en_vie_cpt > 200) {   // Fait clignoter la led verte.
    led_en_vie_cpt = 0;         // Le clignotement ralenti si le cpu est beaucoup utilisé.
    led_en_vie_val++;
    if (led_en_vie_val == 2) led_en_vie_val = 0;
    if (led_en_vie_val == 0) { digitalWrite(pin_led_en_vie, HIGH); digitalWrite(pin_led_en_vie_boit, HIGH); }
    else                     { digitalWrite(pin_led_en_vie, LOW);  digitalWrite(pin_led_en_vie_boit, LOW); }
    }
  }
}
//
// ----------------------------------------------------------------------------------------------------------
// Sous programme de mise en file d'attente des touches.
// Ca permet d'envoyer le code des touches au fur et à mesure vers l'ordinateur, avec des delais entre actions.
//   t_shift = NORMAL, KEY_LEFT_CTRL ou KEY_LEFT_SHIFT.
//   t_code  = Code ascii de la touche : 'a', BASCKSPACE ou 124.
//   t_milli = 0:PRESS, 1:RELEASE ou 50, 100, 200 ou 400 = tempo en millisecondes.
//             - Nombre > 1 = Envoie le code de la touche et le code de fin de la touche. Keyboard.press + Keyboard.release, avec le délai indiqué.
//             - PRESS      = Envoie uniquement le code de début de touche.               Keyboard.press.
//             - RELEASE    = Envoie uniquement le code de la fin de la touche.           Keyboard.release.
//
void tch_env(int t_shift, int t_code, int t_milli) {
  if (touche_etat[touche_num_libre] == touche_etat_fait) {
    touche_shift[touche_num_libre] = t_shift;            // La file d'attente n'est pas saturée.
    touche_code[touche_num_libre]  = t_code;
    touche_milli[touche_num_libre] = t_milli;
    touche_etat[touche_num_libre]  = touche_etat_demande;
    touche_num_libre++;                                  // Prochain indice à utiliser.
    if (touche_num_libre == touche_nb_max) touche_num_libre = 0;
  }
}